﻿unit chemdata_u;
interface
uses sysutils, forms, classes,BasicMolDecl_u, simplefuncs, math, CurrentProjectOptions_u,
 geometry,
withtextsimple, mystreams_u, arrays, universalarrays_u;

var
atomstypenames:array[tatomtype] of string =(
'X',
'H','He',
'Li','Be','B','C','N','O','F','Ne',
'Na','Mg','Al','Si','P','S','Cl','Ar',
'K','Ca','Sc','Ti','V','Cr','Mn','Fe','Co','Ni','Cu','Zn','Ga','Ge','As','Se','Br','Kr',
'Rb','Sr','Y','Zr','Nb','Mo','Tc','Ru','Rh','Pd','Ag','Cd','In','Sn','Sb','Te','I','Xe',
'Cs','Ba','La','Ce','Pr','Nd','Pm','Sm','Eu','Gd','Tb','Dy','Ho','Er','Tm','Yb','Lu','Hf','Ta','W','Re','Os','Ir','Pt','Au','Hg','Tl','Pb','Bi','Po','At','Rn',
'Fr','Ra','Ac','Th','Pa','U','Np','Pu','Am','Cm','Bk','Cf','Es','Fm','Md','No','Lr','Ku','Ns'{,'E-W','E-Re'}
);

bondstypenames:array[tbondtype] of string =(
{'No bond',}'Single','Aromatic','Double','Triple','H-bond'
);

GamessAtomsNames:array[tatomtype] of string =(
'X',//0
'HYDROGEN',//1
'HELIUM',//2
'LITHIUM',//3
'BERYLLIUM',//4
'BORON',//5
'CARBON',//6
'NITROGEN',//7
'OXYGEN',//8
'FLUORINE',//9
'NEON',//10
'SODIUM',//11
'MAGNESIUM',//12
'ALUMINUM',//13
'SILICON',//14
'PHOSPHOROUS',
//'PHOSPHORUS',//15
'SULFUR',//16
'CHLORINE',//17
'ARGON',//18
'POTASSIUM',//19
'CALCIUM',//20
'SCANDIUM',//21
'TITANIUM',//22
'VANADIUM',//23
'CHROMIUM',//24
'MANGANESE',//25
'IRON',//26
'COBALT',//27
'NICKEL',//28
'COPPER',//29
'ZINC',//30
'GALLIUM',//31
'GERMANIUM',//32
'ARSENIC',//33
'SELENIUM',//34
'BROMINE',//35
'KRYPTON',//36
'RUBIDIUM',//37
'STRONTIUM',//38
'YTTRIUM',//39
'ZIRCONIUM',//40
'NIOBIUM',//41
'MOLYBDENUM',//42
'TECHNETIUM',//43
'RUTHENIUM',//44
'RHODIUM',//45
'PALLADIUM',//46
'SILVER',//47
'CADMIUM',//48
'INDIUM',//49
'TIN',//50
'ANTIMONY',//51
'TELLURIUM',//52
'IODINE',//53
'XENON',//54
'CESIUM',//55
'BARIUM',//56
'LANTHANUM',//57
'CERIUM',//58
'PRASEODYNIUM',//59
'NEODYMIUM',//60
'PROMETHEUM',//61
'SAMARIUM',//62
'EUROPIUM',//63
'GADOLINIUM',//64
'TERBIUM',//65
'DYSPROSIUM',//66
'HOLMIUM',//67
'ERBIUM',//68
'THULIUM',//69
'YTTERBIUM',//70
'LUTETIUM',//71
'HAFNIUM',//72
'TANTALUM',//73
'TUNGSTEN',//74
'RHENIUM',//75
'OSMIUM',//76
'IRIDIUM',// 77
'PLATINUM',//78
'GOLD',//79
'MERCURY',//80
'THALLIUM',//81
'LEAD',//82
'BISMUTH',//83
'POLONIUM',//84
'ASTATINE',//85
'RADON',//86
'FRANCIUM',//87
'RADIUM',//88
'ACTINIUM',//89
'THORIUM',//
'PROTACTINIUM',//
'URANIUM',//
'NEPTUNIUM',//
'PLUTONIUM',//
'AMERICIUM',//
'CURIUM',//
'BERKELIUM',//
'CALIFORNIUM',//
'UNDEFINED',//
'UNDEFINED',//
'UNDEFINED',//
'UNDEFINED',//
'UNDEFINED',//
'UNDEFINED',//
'UNDEFINED'//
);


CollPolarAtomsDiam:array[tatomtype] of double;
{
'UNKNOWN',
'HYDROGEN','He',
'Li','Be','B','CARBON','NITROGEN','OXYGEN','F','Ne',
'Na','Mg','Al','Si','P','S','Cl','Ar',
'K','Ca','Sc','Ti','V','Cr','Mn','Fe','Co','Ni','Cu','Zn','Ga','Ge','As','Se','Br','Kr',
'Rb','Sr','Y','Zr','Nb','Mo','Tc','Ru','Rh','Pd','Ag','Cd','In','Sn','Sb','Te','I','Xe',
'Cs','Ba','La','Ce','Pr','Nd','Pm','Sm','Eu','Gd','Tb','Dy','Ho','Er','Tm','Yb','Lu','Hf','Ta','W','Re','Os','Ir','Pt','Au','Hg','Tl','Pb','Bi','Po','At','Rn',
'Fr','Ra','Ac','Th','Pa','U','Np','Pu','Am','Cm','Bk','Cf','Es','Fm','Md','No','Lr','Ku','Ns'//,'E-W','E-Re'
);
}
{0: X
1: H
2: He
3: Li
4: Be
5: B
6: C
7: N
8: O
9: F
10: Ne
11: Na
12: Mg
13: Al
14: Si
15: P
16: S
17: Cl
18: Ar
19: K
20: Ca
21: Sc
22: Ti
23: V
24: Cr
25: Mn
26: Fe
27: Co
28: Ni
29: Cu
30: Zn
31: Ga
32: Ge
33: As
34: Se
35: Br
36: Kr
37: Rb
38: Sr
39: Y
40: Zr
41: Nb
42: Mo
43: Tc
44: Ru
45: Rh
46: Pd
47: Ag
48: Cd
49: In
50: Sn
51: Sb
52: Te
53: I
54: Xe
55: Cs
56: Ba
57: La
58: Ce
59: Pr
60: Nd
61: Pm
62: Sm
63: Eu
64: Gd
65: Tb
66: Dy
67: Ho
68: Er
69: Tm
70: Yb
71: Lu
72: Hf
73: Ta
74: W
75: Re
76: Os
77: Ir
78: Pt
79: Au
80: Hg
81: Tl
82: Pb
83: Bi
84: Po
85: At
86: Rn
87: Fr
88: Ra
89: Ac
90: Th
91: Pa
92: U
93: Np
94: Pu
95: Am
96: Cm
97: Bk
98: Cf
99: Es
100: Fm
101: Md
102: No
103: Lr
104: Ku
105: Ns
}




AtomicMasses: array[tatomtype] of double=(
0,      1.007825E+00,4.0026E+00,7.01600E+00,9.01218E+00,11.00931E+00,
        12.0E+00,14.00307E+00,15.99491E+00,18.99840E+00,19.99244E+00,
        22.9898E+00,23.98504E+00,26.98153E+00,27.97693E+00,
        30.97376E+00,31.97207E+00,34.96885E+00,39.948E+00,
        38.96371E+00,39.96259E+00,44.95592E+00,47.90E+00,50.9440E+00,
        51.9405E+00,54.9381E+00,55.9349E+00,58.9332E+00,57.9353E+00,
        62.9298E+00,63.9291E+00,68.9257E+00,73.9219E+00,74.9216E+00,
        79.9165E+00,78.9183E+00,83.9115E+00,
        84.9117E+00,87.9056E+00,89.9054E+00,89.9043E+00,92.9060E+00,
        97.9055E+00,97.0E+00,101.9037E+00,102.9048E+00,105.9032E+00,
        106.9041E+00,113.9036E+00,114.9041E+00,119.9022E+00,
        120.9038E+00,129.9067E+00,126.9044E+00,131.9042E+00,
        132.9054E+00,137.9052E+00,138.9063E+00,139.9054E+00,
        140.9076E+00,141.9077E+00,144.9127E+00,151.9197E+00,
        152.9212E+00,157.9241E+00,158.9253E+00,163.9292E+00,
        164.9303E+00,165.9303E+00,168.9342E+00,173.9389E+00,
        174.9408E+00,179.9465E+00,180.9480E+00,183.9509E+00,
        186.9557E+00,191.9615E+00,192.9629E+00,194.9648E+00,
        196.9665E+00,201.9706E+00,
        204.9744E+00,207.9766E+00,208.9804E+00,208.9824E+00,
        209.9871E+00,222.0176E+00,
        223.0197E+00,226.0254E+00,
        227.0278E+00,232.0381E+00,231.0359E+00,238.0508E+00,
        237.0482E+00,244.0642E+00,243.0614E+00,247.0703E+00,
        247.0703E+00,251.0796E+00,252.0829E+00,257.0751E+00,
        258.0986E+00,259.1009E+00,260.1053E+00,261.1087E+00,
        300);


const exotatomscount=15;

var
exotatomnames:array[0..exotatomscount-1] of string=(
'Rf',
'Db',
'Sg',
'Bh',
'Hs',
'Mt',
'Uun',
'Uuu',
'Uub',
'Uut',
'Uuq',
'Uup',
'Uuh',
'Uus',
'Uuo'
);

IsotopeAbundancies: array[tatomtype] of record
firstisotope:integer;
isotopescount:integer;
isotopes:array[0..20] of double;//Процентное содержание каждого изотопа
AverMass:double;
end;

IsotopeMasses:array[tatomtype] of record
firstisotope:integer;
IsotopesCount:integer;
MainIsotope:integer;//номер в массиве isotopemasses
isotopemasses:array[0..100] of double;//Масса каждого изотопа
end;

function GetAtomName(atom:tatomtype; nameformat:integer; uniformlength:boolean):string;
//Универсальная функция;nameformat:0 - обычные (H, Si,...), 1 - Принятые в GAMESS (SILICON,...)
function AtomTypeName(typ:tatomtype):string;
function BondTypeName(typ:tbondtype):string;
function AtomTypeNum(name:string):tatomtype;
function AtomTypeNumSafe(name:string):integer;//возвращает atNoAtom, если строка не интерпретируется как название атома
function AtomTypeNumIgnoreDigits(name:string):tatomtype;//Может быть использована строка, где после названия атома идут еще цифры или любые другие символы
function BondTypeNum(name:string):tbondtypenum;
function GetAtomCharge(str:string):tatomtype;//Может быть строка с числом или обозначением атома в формате: C, C1
function TryGetAtomCharge(str:string; out res:tatomtype):boolean;
function GetAtomChargeFromMass(mass:integer):tatomtype;
//function SafeGetAtomCharge1(str:string; errval:tatomtype):tatomtype; overload;
function SafeGetAtomCharge(str:string):integer; overload;
//Возвращает -1, если атом не нашёлся, и -2, если это атом типа Sg, которого нет в массивах
function AtomTypeNumInPDB(name:string; babelformat:boolean):tatomtype;
function StringCanBeAtom(str:string):boolean;
function StringIsAtom(str:string):boolean;


function GamessAtomTypeSafe(name:string):integer;//возвращает atNoAtom, если строка не интерпретируется как название атома

type
TCrystABCParams=record
a,b,c,alpha,beta,gamma:double;//Угды в радианах
function IsZero:boolean;
procedure ComputeLatticeVectors(out vect1,vect2,vect3:tvect);
function ComputeCartToFracMatrix:trotmatrix;
function ComputeFracToCartMatrix:trotmatrix;
function AlphaInDegrees:double;
function BetaInDegrees:double;
function GammaInDegrees:double;
end;

function ComputeABCFromLatticeVectors(vect1,vect2,vect3:tvect; out cellabc:TCrystABCParams):boolean;


const
maxbondlength=2.2;
maxbondlength2=maxbondlength*maxbondlength;

bohrtoangkoef=0.529177249;
angtobohrkoef=1/bohrtoangkoef;

autoevcoef=27.2116;

autoccalcoef=627.5095;
autokdzhcoef=autoccalcoef*4.184;
kcaltokdhcoef=4.184;


consth=6.6260755E-34;
constc=2.99792458E8;
constk=1.380658E-23;//Константа Больцмана, дж/к

constAvn=6.0221367E23;

autocmm1coef=(autokdzhcoef*1000/constAvn)/(consth*constc)*0.01;



constzerocink=273.15;//?
type
TPossibleBondTypeData=record typ:tbondtype; standardvalue,maxvalue2:double; end;
//По умолчанию maxvalue2=sqr(standardvalue)+0.2 (но не обязательно).
//maxvalue2 используется для автоматического определения связей, а
//standardvalue - стандартная длиная связи
//надо будет доделать (вернуться) возможность, конда standardvalue<0 - значит стандартная длина связи неизвестна,
//хотя известна максимальная

TPossibleBondData=record
typescount:integer;
maxvalue,maxvalue2:double;//в файл эти величины не записываются, а автоматически пересчитываются при чтении
types:array[tbondtype] of TPossibleBondTypeData;
end;
//Надо будет доделать minvalue (для оптимизации);



TPossibleBondsDataList=record
CalculateBonds:boolean;
CountHBonds:boolean;
UseAngleCutoffForBondsCounting:boolean;
AngleCutoffMin:tanglerad;
AdjustBondsByValences:boolean;
AdjustSettongDoubleBonds:boolean;
UseFastModeForBigMolecules:boolean;
UseShortContactsMethod:boolean;
Bonds: array[tatomtype,tatomtype] of tpossiblebonddata;
fSavedOptionCalculateBonds:boolean;
procedure SaveOptionCalculateBonds;
procedure RestoreOptionCalculateBonds;
end;
PPossibleBondsDataList=^TPossibleBondsDataList;

TTPossibleBondsDataChangeList=array[tatomtype,tatomtype] of array[tbondtype] of boolean;
PPossibleBondsDataChangeList=^TTPossibleBondsDataChangeList;
//Для обновления


var


PossibleBondsData:TPossibleBondsDataList;

//PossibleBondLength:array[tatomtype,tatomtype,tbondtype] of double;
//PossibleBondLength2:array[tatomtype,tatomtype,tbondtype] of double;

//StandardAtomValence:array[tatomtype] of integer; //Передумал

ShortContactsData:TPossibleBondsDataList;

AtomTypesData:array[tatomtype] of record
MaxValence:integer;//Для O=2
MaxElParValence:integer;
//Для нахождения количества электронных пар, например для определения валентных углов. Для O=6
GoodValence:integer;//Для S=2
IsMetal:boolean;
IsTransMetal:boolean;
end;

//MaxAtomElParValence:array[tatomtype] of integer;//Для нахождения количества электронных пар, например для определения валентных углов

MaxAtomValence:array[tatomtype] of integer;//

AtomsNamesPrior:array[tatomtype] of tatomtype;

AtomsGroupsData:array[tatomtype] of integer;


VanRadii:array[tatomtype] of double=(0.25,
0.87,0.59,
2.90,1.78,1.45,1.21,1.03,0.93,0.82,0.73,
2.87,2.20,2.03,1.75,1.54,1.43,1.30,1.18,
3.51,2.84,2.61,2.44,2.31,2.26,2.11,2.03,1.96,1.89,1.83,1.92,2.01,1.82,1.63,1.56,1.45,1.35,
3.62,3.02,2.83,2.62,2.50,2.34,2.25,2.13,2.05,1.69,1.93,1.93,2.09,1.97,1.88,1.77,1.68,1.59,
3.91,3.41,3.14,3.09,3.04,3.15,3.11,3.07,3.03,2.86,2.94,2.90,2.87,2.83,2.79,2.76,2.80,2.53,2.36,2.23,2.13,2.04,1.97,1.87,1.80,1.79,1.96,1.89,1.95,1.89,1.82,1.74,
3.65,3.37,3.18,3.18,2.94,3.01,2.92,2.90,2.86,2.84,2.83,2.74,2.70,2.88,2.63,2.60,3,3,3);
{
VanDerWaalsRadii:array[atomtype] of double=(
0.25,
1.2,1.4
}

MoldenCovAtomRadii:array[tatomtype] of double=(1,
0.430000,
0.741000,
0.880000,
0.550000,
1.030000,
0.900000,
0.880000,
0.880000,
0.840000,
0.815000,
1.170000,
1.300000,
1.550000,
1.400000,
1.250000,
1.220000,
1.190000,
0.995000,
1.530000,
1.190000,
1.640000,
1.670000,
1.530000,
1.550000,
1.550000,
1.540000,
1.530000,
1.700000,
1.720000,
1.650000,
1.420000,
1.370000,
1.410000,
1.420000,
1.410000,
1.069000,
1.670000,
1.320000,
1.980000,
1.760000,
1.680000,
1.670000,
1.550000,
1.600000,
1.650000,
1.700000,
1.790000,
1.890000,
1.830000,
1.660000,
1.660000,
1.670000,
1.600000,
1.750000,
1.870000,
1.540000,
2.070000,
2.030000,
2.020000,
2.010000,
2.000000,
2.000000,
2.190000,
1.990000,
1.960000,
1.950000,
1.940000,
1.930000,
1.920000,
2.140000,
1.920000,
1.770000,
1.630000,
1.570000,
1.550000,
1.570000,
1.520000,
1.700000,
1.700000,
1.900000,
1.750000,
1.740000,
1.740000,
1.880000,
0.200000,
0.200000,
0.200000,
2.100000,
2.080000,
1.990000,
1.810000,
1.780000,
1.750000,
0.200000,
1.710000,
0.200000,
0.200000,
1.730000,
1.7,
1.7,
1.7,
1.7,
1.7,
1.7,
1.7
);

GroupsRanges:array[1..7] of record beg,last:integer; end;
function FindBondLength(typ1,typ2:tatomtype; bondtype:tbondtype):double;
function StandardBondLength(type1,type2:tatomtype; bondtype:tbondtype; out res:double):boolean; overload;
function StandardBondLength(type1,type2:tatomtype; bondtype:tbondtype):double; overload;

function GetAtomVanRadius(atomtype:tatomtype):double;

function PossibleBond(type1,type2:tatomtype; range2:double):tbondtypenum;

procedure SortBondsData(var possdata:TPossibleBondData);
procedure FinalizeBondsData(var possdata:TPossibleBondData);


procedure AddBondsFromCovRadii;

procedure FinishPossibleBondsData;

procedure DiagExtendBondsData(var data:TPossibleBondsDataList);



procedure SaveBondsData;
procedure LoadBondsData;

procedure LoadAndPrepareBondsData;
procedure SimplyPrepareBondsData;



const
PhysicsAndChemistryConstantsSi_R=8.31446261815324;//J⋅K−1⋅mol−1// m3⋅Pa⋅K−1⋅mol−1//kg⋅m2⋅s−2⋅K−1⋅mol−1
PhysicsAndChemistryConstantsSi_Na=6.02214076E23;//Mol-1
PhysicsAndChemistryConstantsSi_k=PhysicsAndChemistryConstantsSi_R/PhysicsAndChemistryConstantsSi_Na;//J*K
PhysicsAndChemistryConstantsSi_h=6.62607015/1E34;//J*s//kg*m^2*s-3
PhysicsAndChemistryConstantsSi_C=299792458;//m*s-1
PhysicsAndChemistryConstantsSi_Da=1.66053906660E-27;//kg


//PhysicsAndChemistryConstantsSi:TPhysicsAndChemistryConstantsSi;

type
FreqsArrData=record
outfnum:integer;
freqval:double;
end;

tthermrecountunits=(truJouleMolK,truCalMolK,truJouleMol,truCalMol,truau,truEV);

Tfreqsarray=class(TAnyStandardArray<FreqsArrData>)
procedure AddFreq(outfnum:integer; freqval:double);
end;



TThermDataCalculator=class
FTemterK:extended;
FPressurePa:extended;
FFrequencies:tfreqsarray;
FAtomTypes:tintarray;
FCoords:tvectsarray;
FMasskg:extended;
FIvaluesSi:tvect;//моменты инерции xx,yy,zz в кг-m2
FUseFreqsThreshold:boolean;
FFreqsThreshold:extended;
FIsLinear:boolean;
FPointGroupFullNum:integer;
FElEnergyh:extended;
FComputedData:record
HasGh:boolean;
Gh:extended;
end;
FHasGEnFromFileh:boolean;
FGEnFromFileh:extended;
function ComputeThermFunc(outstrlist:tstrings; recunits:tthermrecountunits):double;
//units: 0,1
// 2,3 - the entropy will be multiplied by T
constructor Create;
destructor Destroy; override;
end;

procedure ComputeNewABCVectorsInTermsOfOld(olda,oldb,oldc:tvect; rotmat:TRotMatrixInt; out newa,newb,newc:tvect);

implementation

uses withtext, pointgroup_u;


function GetAtomName(atom:tatomtype; nameformat:integer; uniformlength:boolean):string;
begin
case nameformat of
0: begin
result:=atomstypenames[atom];
if uniformlength then begin while length(result)<2 do result:=result+' '; end;
end;
1: begin
result:=GamessAtomsNames[atom];
if uniformlength then begin while length(result)<11 do result:=result+' '; end;
end;
end;//end case
end;



function AtomTypeName(typ:tatomtype):string;
begin
result:=atomstypenames[typ];
end;


function BondTypeName(typ:tbondtype):string;
begin
result:=bondstypenames[typ];;
end;


function AtomTypeNum(name:string):tatomtype;
var
q:integer;
begin
name:=lowercase(name);
if length(name)>1 then if name[2]=' ' then name:=name[1];
for q:=0 to atomsinfocount-1 do if lowercase(atomstypenames[q])=name then begin
result:=q;
exit;
end;
//raise exception.Create('Некорректное имя типа атома');
raise exception.Create('Incorrect atom type');
end;

function AtomTypeNumSafe(name:string):integer;
var
q:integer;
begin
if not stringfilled(name) then begin result:=0; exit; end;
name:=CuttenString(name);

name:=lowercase(name);

for q:=1 to atomsinfocount-1 do if lowercase(atomstypenames[q])=name then begin
result:=q;
exit;
end;
result:=atNoAtom;
end;


function AtomTypeNumIgnoreDigits(name:string):tatomtype;
var
q:integer;
found:boolean;
begin
result:=0;
name:=lowercase(name);
found:=false;
for q:=0 to atomsinfocount-1 do if lowercase(atomstypenames[q])=copy(name,1,length(atomstypenames[q])) then begin
found:=true;
result:=q;
if length(atomstypenames[q])=2 then exit;
end;
if found then exit;
//raise exception.Create('Некорректное имя типа атома');
raise exception.Create('Incorrect atom type');
end;

function AtomTypeNumInPDB(name:string; babelformat:boolean):tatomtype;
var
q:integer;
//firstspace:boolean;
res:integer;
begin
result:=0;
//firstspace:=(name[1]=' ') or ((name[1]>='0') and (name[1]<='9'));
name:=CuttenString(name);
if name='' then exit;

//while (length(name)>1) and ((name[1]=' ') or ((name[1]>='0') and (name[1]<='9'))) do delete(name,1,1);
//while (length(name)>1) and ((name[length(name)]=' ') or ((name[length(name)]>='0') and (name[length(name)]<='9'))) do delete(name,length(name),1);

if length(name)>1 then begin
case babelformat of
false:if not((name[2]>='a') and (name[2]<='z') or (name[2]>='A') and (name[2]<='Z')) then name:=name[1];
true:if not((name[2]>='a') and (name[2]<='z')) then name:=name[1];
end;
//Если поставить эту строку, программа станет правильно читать pdb файлы сгенерированные Shellx (CL будет
//читаться как хлор), но станут неправильно читаться другие файлы (CA, CB, CD будут читаться ка Ca, *, Cd)
//..Вроде с babelformat стало нормально, но надо ещё проверять
if length(name)>2 then name:=copy(name,1,2);
end;




//for q:=0 to atomsinfocount-1 do if atomstypenames[q]=copy(name,1,length(atomstypenames[q])) then begin result:=q; exit; end;
res:=AtomTypeNumSafe(name);

if res=atNoAtom then result:=0 else result:=res;
//if length(name)>1 then name:=name[1];
//result:=AtomTypeNumSafe(name);
//end;

//Убрал, надеюсь что не станет хуже:
{
if not firstspace then begin//Предполагаю, что имена из двух букв могут начинаться только с первого символа (13-го в строке PDB файла)
for q:=0 to atomsinfocount-1 do if length(atomstypenames[q])=2 then
if lowercase(copy(name,1,2))=lowercase(atomstypenames[q]) then begin result:=q; exit; end;
end;
for q:=0 to atomsinfocount-1 do if length(atomstypenames[q])=1 then
if copy(name,1,1)=atomstypenames[q] then begin result:=q; exit; end;
if name[1]='D' then begin result:=1; exit; end;
}
end;


function StringCanBeAtom(str:string):boolean;
var
q:integer;
begin
result:=false;
str:=cuttenstring(lowercase(str));
//На всякий случай проверяем, нет ли цифр в строке; если есть - отсекаем:
for q:=1 to length(str) do if (str[q]>='0') and (str[q]<='9') then begin str:=copy(str,1,q-1); break; end;
for q:=0 to atomsinfocount-1 do if str=lowercase(atomstypenames[q]) then begin result:=true; exit; end;
end;

function StringIsAtom(str:string):boolean;
var
digitfound:boolean;
//res:integer;
q:integer;
begin
result:=false;
if StringCanBeIntDigitV(str) then begin
digitfound:=true;
try strtoint(str); except digitfound:=false; end;
if digitfound then begin result:=true; exit; end;
end;
//if StringCanBeDigitV(str) then begin
//digitfound:=true;
//try res:=round(strtofloat(str)); except digitfound:=false; end;
//if digitfound then begin result:=true; exit; end;
//end;

//На всякий случай проверяем, нет ли цифр в строке; если есть - отсекаем:
for q:=1 to length(str) do if (str[q]>='0') and (str[q]<='9') then begin str:=copy(str,1,q-1); break; end;
str:=lowercase(str);
for q:=0 to atomsinfocount-1 do if str=lowercase(atomstypenames[q]) then begin result:=true; exit; end;
end;


function BondTypeNum(name:string):tbondtypenum;
var
q:integer;
begin
for q:=0 to bondsinfocount-1 do if bondstypenames[q]=name then begin
result:=q;
exit;
end;
//raise exception.Create('Некорректное имя типа связи');
raise exception.Create('Incorrect bond type');
//result:=-1;
end;



function GetAtomCharge(str:string):tatomtype;
begin
if not trygetatomcharge(str,result) then raise exception.Create('Invalid atom name ('+str+').');
end;


function TryGetAtomCharge(str:string; out res:tatomtype):boolean;
var
q:integer;
//res:integer;
//n:integer;
//isdig:boolean;
digitfound:boolean;
begin
{
n:=0;
for q:=1 to length(str) do if (str[q]>='0') and (str[q]<='9') then begin n:=q; break; end;
if n<>0 then begin
isdig:=true;
for q:=1 to n-1 do if str[q]>' ' then begin isdig:=false; break; end;
end;
}
str:=CuttenString(str);

res:=0;
result:=true;

if StringCanBeIntDigitV(str) then begin
digitfound:=true;
try res:=strtoint(str); except digitfound:=false; end;
if digitfound then begin if res<0 then res:=0; exit; end;
end;

if StringCanBeDigitV(str) then begin
digitfound:=true;
try res:=round(strtofloat(str)); except digitfound:=false; end;
if digitfound then begin if res<0 then res:=0; exit; end;
end;

//На всякий случай проверяем, нет ли цифр в строке; если есть - отсекаем (за исключением случая, когда в строке 8 символов - это EFP из GAMESS):
if length(str)<>8 then begin
for q:=1 to length(str) do if (str[q]>='0') and (str[q]<='9') then begin str:=copy(str,1,q-1); break; end;
end;


str:=lowercase(str);

if length(str)>1 then if str[1]='z' then if str[2]<>'n' then if str[2]<>'r' then str:=copy(str,2,length(str)-1);//Для Sanya


for q:=0 to atomsinfocount-1 do if str=lowercase(atomstypenames[q]) then begin res:=q; exit; end;

if length(str)=8 then begin//EFP из GAMESS
for q:=0 to atomsinfocount-1 do if copy(str,4,5)=lowercase(copy(GamessAtomsNames[q],1,5)) then begin res:=q; exit; end;
end;

result:=false;
end;

{
function SafeGetAtomCharge1(str:string; errval:tatomtype):tatomtype;
var
q:integer;
begin
str:=lowercase(str);
if str='' then begin result:=errval; exit; end;
for q:=0 to atomsinfocount-1 do if str=lowercase(atomstypenames[q]) then begin result:=q; exit; end;
if not((str[1]>='0') and (str[1]<='9')) then begin result:=errval; exit; end;

try
result:=getatomcharge(str);
except
result:=errval;
end;
end;
}

function SafeGetAtomCharge(str:string):integer; overload;
var
q:integer;
ch:tatomtype;
begin
str:=lowercase(cuttenstring(str));
if str='' then begin result:=0; exit; end;
for q:=0 to atomsinfocount-1 do if str=lowercase(atomstypenames[q]) then begin result:=q; exit; end;

if ((str[1]>='0') and (str[1]<='9')) then begin//Вроде число
if TryGetAtomCharge(str,ch) then result:=ch else result:=-1;
exit;
end;

result:=0;
for q:=0 to exotatomscount-1 do if str=lowercase(exotatomnames[q]) then begin result:=-2; exit; end;



end;

function GetAtomChargeFromMass(mass:integer):tatomtype;
var
q:integer;
bestmatch:integer;
curmatch:integer;
bestnum:integer;
begin
bestmatch:=9999999;
bestnum:=1;
for q:=1 to atomsinfocount-1 do begin
curmatch:=abs(mass-round(AtomicMasses[q]));
if curmatch<bestmatch then begin bestmatch:=curmatch; bestnum:=q; end;
end;
result:=bestnum;
end;



function GamessAtomTypeSafe(name:string):integer;
function CuttenLRString(str:string):string;//Обрезает слева и справа пробелы в строке
//Взял из withtext.pas, чтобы не подключать лишний раз модуль
var
q:integer;
firstchar,lastchar:integer;//Номера первого и последнего значащего символа (не пробела)
begin
firstchar:=0; lastchar:=0;
for q:=1 to length(str) do if str[q]>' ' then begin firstchar:=q; break; end;
for q:=length(str) downto 1 do if str[q]>' ' then begin lastchar:=q; break; end;
if firstchar=0 then begin str:=''; exit; end;
result:=copy(str,firstchar,lastchar-firstchar+1);
end;

var
q:integer;

begin
name:=CuttenLRString(name);
name:=lowercase(name);
result:=-1;
if (length(name)<2) or (length(name)>15) then exit;
for q:=0 to atomsinfocount-1 do if lowercase(GamessAtomsNames[q])=name then begin result:=q; exit; end;
end;


function StandardBondLength(type1,type2:tatomtype; bondtype:tbondtype; out res:double):boolean;
var
q:integer;
begin
result:=false;
//if ((type1=1) and (type2=14)) or ((type2=1) and (type1=14)) then begin result:=true; res:=1.488; exit; end;
for q:=0 to PossibleBondsData.bonds[type1,type2].typescount-1 do
if possiblebondsdata.bonds[type1,type2].types[q].typ=bondtype then begin
if possiblebondsdata.bonds[type1,type2].types[q].standardvalue<0 then exit;
result:=true;
res:=possiblebondsdata.bonds[type1,type2].types[q].standardvalue;
end;
end;

function StandardBondLength(type1,type2:tatomtype; bondtype:tbondtype):double;
var
res:double;
begin
if StandardBondLength(type1,type2,bondtype,res) then result:=res
else begin
result:=MoldenCovAtomRadii[type1]+MoldenCovAtomRadii[type2];
end;
end;

function FindBondLength(typ1,typ2:tatomtype; bondtype:tbondtype):double;
//var
//tmp:tatomtype;
begin
if bondtype=-1 then begin result:=1.5; exit; end;
if standardbondlength(typ1,typ2,bondtype,result) then exit;
//if typ1>typ2 then begin tmp:=typ2; typ2:=typ1; typ1:=tmp; end;

result:=1.4;
end;



function GetAtomVanRadius(atomtype:tatomtype):double;
begin
result:=vanradii[atomtype];
end;



const
TypesPrior:array[0..4] of tbondtype =(4,0,1,2,3);
function PossibleBond(type1,type2:tatomtype; range2:double):tbondtypenum;
var
//range:double;
q:integer;
//curtype:tbondtype;
begin
//result:=-1;
//if range2<possiblebondlength2[type1,type2] then result:=0;
//exit;
//range:=sqrt(range2);
{
result:=-1;
for q:=0 to 4 do begin
curtype:=typesprior[q];
if range2>possiblebondlength[type1,type2,curtype] then exit;
result:=curtype;
end;
}
result:=-1;
for q:=0 to possiblebondsdata.bonds[type1,type2].typescount-1 do begin
if range2<possiblebondsdata.bonds[type1,type2].types[q].maxvalue2 then begin
result:=possiblebondsdata.bonds[type1,type2].types[q].typ;
exit;
end;
end;//next q
end;






function StandBondLenFromMoldenRad(atom1,atom2:tatomtype):double;
begin
result:=MoldenCovAtomRadii[atom1]+MoldenCovAtomRadii[atom2]-0.3;
if (AtomsGroupsData[atom1]<=2) and (AtomsGroupsData[atom2]<=2) then result:=result-0.2;
if atom1=atom2 then if AtomsGroupsData[atom1]<=2 then result:=result-0.2;
end;



procedure FinalizeBondsData(var possdata:TPossibleBondData);
var
curmax:double;
q:integer;
begin
sortbondsdata(possdata);

if possdata.typescount>0 then begin
curmax:=0;
for q:=0 to possdata.typescount-1 do if possdata.types[q].maxvalue2>curmax then curmax:=possdata.types[q].maxvalue2;
possdata.maxvalue2:=curmax;
possdata.maxvalue:=sqrt(curmax);
end;

end;

procedure SortBondsData(var possdata:TPossibleBondData);
var
q:integer;

function FindMin(beg,last:integer):integer;
var
q:integer;
//minval:double;
minnum:integer;
begin
result:=beg;
//minval:=possiblebondsdata.bond[[rownum,colnum].types[beg].maxvalue2;
minnum:=bondtypesorder[possdata.types[beg].typ];
for q:=beg+1 to last do
if bondtypesorder[possdata.types[q].typ]<minnum then begin
minnum:=bondtypesorder[possdata.types[q].typ];
result:=q;
end;
end;

procedure DoSwap(num1,num2:integer);
var
tmp:tpossiblebondtypedata;
begin
tmp:=possdata.types[num1];
possdata.types[num1]:=possdata.types[num2];
possdata.types[num2]:=tmp;
end;

begin
//if rownum=6 then if colnum=6 then
//beep;
for q:=0 to possdata.typescount-2 do
doswap(q,findmin(q,possdata.typescount-1));
end;



procedure AddPossibleBond(type1,type2:tatomtype; typ:tbondtype; length:double{; modifymaxvalue2:boolean});
var
tmp:tatomtype;
begin
if type1>type2 then begin tmp:=type1; type1:=type2; type2:=tmp; end;
inc(possiblebondsdata.bonds[type1,type2].typescount);
possiblebondsdata.bonds[type1,type2].types[possiblebondsdata.bonds[type1,type2].typescount-1].typ:=typ;
possiblebondsdata.bonds[type1,type2].types[possiblebondsdata.bonds[type1,type2].typescount-1].standardvalue:=length;
{if modifymaxvalue2 then} possiblebondsdata.bonds[type1,type2].types[possiblebondsdata.bonds[type1,type2].typescount-1].maxvalue2:=sqr(length)+0.15;

end;


procedure AddPossibleBondWithoutExpand(type1,type2:tatomtype; typ:tbondtype; length:double);
//максимальная длина связи принимается равной стандартной длине
begin
addpossiblebond(type1,type2,typ,length);
possiblebondsdata.bonds[type1,type2].types[possiblebondsdata.bonds[type1,type2].typescount-1].maxvalue2:=sqr(length);
end;



procedure AddBondsFromCovRadii;
var
q,w:integer;
//currad:double;
begin
for q:=1 to atomsinfocount-1 do for w:=q to atomsinfocount-1 do if possiblebondsdata.bonds[q,w].typescount=0 then begin
//if AtomsGroupsData[q]
AddPossibleBondWithoutExpand(q,w,0,StandBondLenFromMoldenRad(q,w));
end;//if
end;//proc

procedure DiagExtendBondsData(var data:TPossibleBondsDataList);
var
q,w:integer;
begin
for q:=0 to atomsinfocount-1 do for w:=0 to q-1 do data.bonds[q,w]:=data.bonds[w,q];
end;


procedure Finishpossiblebondsdata;
var
q,w:integer;
begin
AddBondsFromCovRadii;

DiagExtendBondsData(PossibleBondsData);



//for q:=0 to atomsinfocount-1 do for w:=0 to atomsinfocount-1 do
//for e:=0 to possiblebondsdata.bond[.bond[.bond[q,w].typesnum-1 do possiblebondsdata.bond[.bond[.bond[q,w].types[e].maxvalue2:=sqr(possiblebondsdata.bond[.bond[.bond[q,w].types[e].standardvalue+0.01);



for q:=0 to atomsinfocount-1 do for w:=0 to atomsinfocount-1 do
finalizebondsdata(possiblebondsdata.Bonds[q,w]);

//for q:=0 to atomsinfocount-1 do for w:=0 to q-1 do possiblebondlength[q,w]:=possiblebondlength[w,q];
//for q:=0 to atomsinfocount-1 do for w:=0 to atomsinfocount-1 do for e:=0 to bondsinfocount-1 do possiblebondlength[q,w,e]:=possiblebondlength[q,w,e]+0.04;
//for q:=0 to atomsinfocount-1 do for w:=0 to atomsinfocount-1 do for e:=0 to bondsinfocount-1 do possiblebondlength2[q,w,e]:=sqr(possiblebondlength[q,w,e]);
end;

const
tableatoms:array[0..28] of tatomtype=(1,3,4,5,6,7,8,9,11,12,13,14,15,16,17,19,20,31,32,33,34,35,37,38,49,50,51,52,53);
procedure PrepareBuiltInBondsData;
procedure AddBonds(typenum:integer; const arr:array of integer);
var
q:integer;
begin
if length(arr)<>length(tableatoms) then beep;
for q:=0 to length(arr)-1 do begin
if arr[q]=0 then continue;
addpossiblebond(tableatoms[typenum],tableatoms[q],0,arr[q]/100);
//addpossiblebond(type1,
end;
end;
begin

addbonds(0,[74,160,134,116,108,100,96,92,187,173,150,148,144,133,128,224,200,150,153,152,146,141,237,215,0,170,171,170,160]);
addbonds(1,[160,267,0,0,0,0,159,156,0,0,0,0,0,0,202,0,0,0,0,0,0,217,0,0,0,0,0,0,239]);
addbonds(2,[134,0,0,0,170,156,0,143,0,0,0,0,0,0,177,0,0,0,0,0,0,0,0,0,0,0,0,0,212]);
addbonds(3,[116,0,0,170,156,0,136,130,0,0,0,201,0,185,174,0,0,0,0,0,194,187,0,0,0,0,0,0,210]);
addbonds(4,[108,0,170,156,154,147,143,138,0,0,199,186,184,182,177,0,0,192,196,196,197,194,0,0,208,216,213,215,216]);
addbonds(5,[100,0,156,0,147,145,141,136,0,0,191,174,165,167,175,0,0,198,184,185,0,0,0,0,0,0,0,0,0]);
addbonds(6,[96,159,0,136,144,141,148,142,0,0,182,163,166,166,170,218,0,196,177,178,0,185,231,0,0,217,193,0,0]);
addbonds(7,[0,0,0,0,0,0,0,142,193,177,163,157,154,155,163,217,210,188,170,171,174,176,227,220,0,0,198,0,180]);
addbonds(8,[0,0,0,0,0,0,0,0,308,0,0,0,0,0,234,0,0,0,0,0,0,250,0,0,0,0,0,0,271]);
addbonds(9,[0,0,0,0,0,0,0,0,0,0,0,0,0,0,218,0,0,0,0,0,0,234,0,0,0,0,0,0,0]);
addbonds(10,[0,0,0,0,0,0,0,0,0,0,0,0,0,0,206,0,0,0,0,0,0,221,0,0,0,0,0,0,253]);
addbonds(11,[0,0,0,0,0,0,0,0,0,0,0,232,225,215,202,0,0,0,237,236,237,219,0,0,0,0,234,0,244]);
addbonds(12,[0,0,0,0,0,0,0,0,0,0,0,0,221,210,203,0,0,0,231,0,224,221,0,0,0,0,0,0,247]);
addbonds(13,[0,0,0,0,0,0,0,0,0,0,0,0,0,205,204,0,0,0,220,224,220,224,0,0,0,257,240,238,0]);
addbonds(14,[0,0,0,0,0,0,0,0,0,0,0,0,0,0,199,267,0,0,210,216,218,214,279,267,243,233,235,234,230]);
addbonds(15,[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,392,0,0,0,0,0,282,0,0,0,0,0,0,305]);
addbonds(17,[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,245]);
addbonds(18,[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,241,0,0,230,0,0,0,0,0,0,251]);
addbonds(19,[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,243,239,233,0,0,0,0,0,257,254]);
addbonds(20,[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,233,232,0,0,0,0,267,250,250]);
addbonds(21,[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,228,294,282,0,246,250,260,0]);
addbonds(22,[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,318]);
addbonds(23,[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,303]);
addbonds(25,[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,278,0,0,269]);
addbonds(26,[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,273]);
addbonds(27,[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,279,0]);
addbonds(28,[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,267]);

addpossiblebond(6,6,1,1.39);
addpossiblebond(6,7,1,1.34);
addpossiblebond(6,8,1,1.26);
addpossiblebond(6,15,1,1.74);
addpossiblebond(6,16,1,1.70);
addpossiblebond(6,33,1,1.86);
addpossiblebond(6,51,1,2.04);
addpossiblebond(7,7,1,1.32);
addpossiblebond(7,8,1,1.22);
addpossiblebond(7,15,1,1.57);
addpossiblebond(7,16,1,1.58);
addpossiblebond(7,33,1,1.76);
addpossiblebond(8,8,1,1.28);
addpossiblebond(8,16,1,1.50);
addpossiblebond(16,16,1,2.01);


addpossiblebond(4,8,2,1.33);
addpossiblebond(5,8,2,1.2);
addpossiblebond(5,16,2,1.61);
//addpossiblebond(6,6,2,1.34);
addpossiblebond(6,6,2,1.30);

addpossiblebond(6,7,2,1.29);
addpossiblebond(6,8,2,1.22);
addpossiblebond(6,15,2,1.71);
addpossiblebond(6,16,2,1.71);
addpossiblebond(6,34,2,1.85);
addpossiblebond(7,7,2,1.25);
addpossiblebond(7,8,2,1.2);
addpossiblebond(7,15,2,1.58);
addpossiblebond(7,16,2,1.63);
addpossiblebond(8,12,2,1.75);
addpossiblebond(8,15,2,1.46);
addpossiblebond(8,16,2,1.43);
addpossiblebond(8,20,2,1.82);
addpossiblebond(8,33,2,1.63);
addpossiblebond(8,34,2,1.66);
addpossiblebond(8,38,2,1.92);
addpossiblebond(15,16,2,1.86);
addpossiblebond(15,34,2,2.02);
addpossiblebond(16,16,2,1.87);
addpossiblebond(16,34,2,2.06);
addpossiblebond(16,34,2,2.06);
addpossiblebond(34,34,2,2.19);
addpossiblebond(52,52,2,2.61);


addpossiblebond(6,6,3,1.2);
addpossiblebond(6,7,3,1.16);
addpossiblebond(6,8,3,1.13);
addpossiblebond(6,15,3,1.54);
addpossiblebond(7,7,3,1.1);
addpossiblebond(7,15,3,1.49);
addpossiblebond(7,16,3,1.43);
addpossiblebond(15,15,3,1.89);
addpossiblebond(51,51,3,2.21);

//addpossiblebond(1,8,4,1.2);
//addpossiblebond(1,9,4,2.0);

end;


var
AtomIsTransMetal:array[tatomtype] of boolean=
(
false,
false,false,
false,false,false,false,false,false,false,false,
false,false,false,false,false,false,false,false,
false,false,true,true,true,true,true,true,true,true,true,true,false,false,false,false,false,false,
false,false,true,true,true,true,true,true,true,true,true,true,false,false,false,false,false,false,
false,false,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,false,false,false,false,false,false,
false,false,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true
);

AtomIsMetal:array[tatomtype] of boolean=
(
false,
false,false,
false,false,false,false,false,false,false,false,
true,true,false,false,false,false,false,false,
true,true,true,true,true,true,true,true,true,true,true,true,false,false,false,false,false,false,
true,true,true,true,true,true,true,true,true,true,true,true,false,false,false,false,false,false,
true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,false,false,false,false,false,false,
true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true
);


procedure SetValences;
var
q:integer;
begin
AtomTypesData[0].MaxElParValence:=0;
AtomTypesData[1].MaxElParValence:=1;
AtomTypesData[2].MaxElParValence:=2;


for q:=3 to 10 do AtomTypesData[q].MaxElParValence:=q-2;

//for q:=3 to 10 do standardatomvalence[q]:=min(q-2,10-q);

for q:=11 to 18 do AtomTypesData[q].MaxElParValence:=q-10;
//for q:=11 to 18 do standardatomvalence[q]:=min(q-10,18-q);
AtomTypesData[19].MaxElParValence:=1;
AtomTypesData[20].MaxElParValence:=2;
for q:=31 to 36 do AtomTypesData[q].MaxElParValence:=q-28;
AtomTypesData[37].MaxElParValence:=1;
AtomTypesData[38].MaxElParValence:=2;
for q:=49 to 54 do AtomTypesData[q].MaxElParValence:=q-46;
AtomTypesData[55].MaxElParValence:=1;
AtomTypesData[56].MaxElParValence:=2;
for q:=81 to 86 do AtomTypesData[q].MaxElParValence:=q-78;

AtomTypesData[87].MaxElParValence:=1;
AtomTypesData[88].MaxElParValence:=2;
AtomTypesData[89].MaxElParValence:=3;

for q:=0 to atomsinfocount-1 do atomtypesdata[q].MaxValence:=atomtypesdata[q].MaxElParValence;
atomtypesdata[7].MaxValence:=3; atomtypesdata[8].MaxValence:=2; atomtypesdata[9].MaxValence:=1;

for q:=0 to atomsinfocount-1 do atomtypesdata[q].IsTransMetal:=AtomIsTransMetal[q];

for q:=0 to atomsinfocount-1 do atomtypesdata[q].IsMetal:=AtomIsMetal[q];

for q:=0 to atomsinfocount-1 do begin
AtomTypesData[q].GoodValence:=AtomTypesData[q].MaxValence;
if AtomTypesData[q].IsMetal then AtomTypesData[q].GoodValence:=2;
end;
atomtypesdata[7].GoodValence:=3; atomtypesdata[8].GoodValence:=2; atomtypesdata[9].GoodValence:=1;
atomtypesdata[15].GoodValence:=3; atomtypesdata[16].GoodValence:=2; atomtypesdata[17].GoodValence:=1;
atomtypesdata[33].GoodValence:=3; atomtypesdata[34].GoodValence:=2; atomtypesdata[35].GoodValence:=1;
atomtypesdata[51].GoodValence:=3; atomtypesdata[52].GoodValence:=2; atomtypesdata[54].GoodValence:=1;
atomtypesdata[83].GoodValence:=3; atomtypesdata[84].GoodValence:=2; atomtypesdata[85].GoodValence:=1;


end;

procedure SetPriors;
var
q,w:integer;
curnum:integer;
begin
curnum:=-1;
for q:=1 to 8 do begin
for w:=atomsinfocount-1 downto 0 do if atomsgroupsdata[w]=q then begin
inc(curnum);
atomsnamesprior[curnum]:=w;
end;//next w
end;
//for q:=
//for q:=0 to atomsinfocount-1 do atomsnamesprior[q]:=atomsinfocount-1-q;
//atomsnamesprior[0]:=atomsinfocount-1-6; atomsnamesprior[atomsinfocount-1-6]:=0;
end;

procedure SetGroups;
var
q:integer;
begin
for q:=0 to atomsinfocount-1 do atomsgroupsdata[q]:=2;
atomsgroupsdata[0]:=8;
atomsgroupsdata[1]:=5; atomsgroupsdata[2]:=8;
for q:=3 to 10 do atomsgroupsdata[q]:=q-2;
for q:=11 to 18 do atomsgroupsdata[q]:=q-10;
atomsgroupsdata[19]:=1; atomsgroupsdata[20]:=2;
for q:=31 to 36 do atomsgroupsdata[q]:=q-28;
atomsgroupsdata[37]:=1; atomsgroupsdata[38]:=2;
for q:=49 to 54 do atomsgroupsdata[q]:=q-46;
atomsgroupsdata[55]:=1; atomsgroupsdata[56]:=2;
for q:=81 to 86 do atomsgroupsdata[q]:=q-78;
atomsgroupsdata[87]:=1; atomsgroupsdata[88]:=2;
groupsranges[1].beg:=0; groupsranges[1].last:=2;
groupsranges[2].beg:=3; groupsranges[2].last:=10;
groupsranges[3].beg:=11; groupsranges[3].last:=18;
groupsranges[4].beg:=19; groupsranges[4].last:=36;
groupsranges[5].beg:=37; groupsranges[5].last:=54;
groupsranges[6].beg:=55; groupsranges[6].last:=86;
groupsranges[7].beg:=87; groupsranges[7].last:=105;

end;

procedure SetVanRadii;
begin
end;


const
NameSortedCollAtNames:array[1..76] of string=(
'Ac',
'Al',
'Sb',
'Ar',
'As',
'At',
'Ba',
'Be',
'Bi',
'B',
'Br',
'Cd',
'Ca',
'C',
'Cs',
'Cl',
'Cr',
'Co',
'Cu',
'F',
'Fr',
'Ga',
'Ge',
'Au',
'Hf',
'He',
'H',
'In',
'I',
'Ir',
'Fe',
'Kr',
'La',
'Pb',
'Li',
'Mg',
'Mn',
'Hg',
'Mo',
'Ne',
'Ni',
'Nb',
'N',
'Os',
'O',
'Pd',
'P',
'Pt',
'Po',
'K',
'Ra',
'Rn',
'Re',
'Rh',
'Rb',
'Ru',
'Sc',
'Se',
'Si',
'Ag',
'Na',
'Sr',
'S',
'Ta',
'Tc',
'Te',
'Tl',
'Sn',
'Ti',
'V',
'W',
'X',
'Xe',
'Y',
'Zn',
'Zr'
);

NameSortedCollAtRads:array[1..76] of double=(
3.369,
2.443,
2.311,
1.664,
2.088,
2.259,
3.544,
2.293,
2.375,
1.944,
1.923,
2.372,
3.174,
1.685,
3.902,
1.747,
2.643,
2.382,
2.277,
1.282,
3.719,
2.428,
2.265,
2.241,
2.862,
1.014,
1.338,
2.564,
2.198,
2.390,
2.448,
1.831,
3.344,
2.327,
3.053,
2.593,
2.514,
2.165,
2.706,
1.119,
2.327,
2.841,
1.508,
2.455,
1.398,
2.142,
2.000,
2.303,
2.327,
3.620,
3.514,
2.193,
2.533,
2.461,
3.695,
2.527,
2.927,
2.022,
2.201,
2.359,
3.058,
3.250,
1.900,
2.721,
2.632,
2.213,
2.390,
2.397,
2.792,
2.686,
2.616,
1.798,
2.056,
3.102,
2.236,
2.931
);
procedure PrepareCollDiams;
var
q,w:integer;
curat:tatomtype;
begin
for q:=1 to 76 do begin
curat:=GetAtomCharge(NameSortedCollAtNames[q]);
CollPolarAtomsDiam[curat]:=NameSortedCollAtRads[q]*2;
end;

CollPolarAtomsDiam[0]:=0;

end;



procedure LoadBondsData;

var
stream:tmyfilestream;
q,w:integer;
tmpint:integer;
function LoadFromStream:tpossiblebonddata;
var
n:word;
q:integer;
begin
stream.read(n,sizeof(n));
result.typescount:=n;
for q:=0 to n-1 do stream.read(result.types[q],sizeof(result.types[q]));
if n=1 then if result.types[0].standardvalue<0 then result.typescount:=0;
end;

begin
//PrepareBuiltInBondsData; exit;
stream:=tmyfilestream.Create(extractfilepath(application.ExeName)+'bonds4.bin',fmOpenRead or fmShareDenyWrite);
tmpint:=stream.hfReadInteger;

for q:=0 to atomsinfocount-1 do
for w:=q to atomsinfocount-1 do possiblebondsdata.bonds[q,w]:=loadfromstream;

PossibleBondsData.CalculateBonds:=stream.hfReadBoolean;
PossibleBondsData.CountHBonds:=stream.hfReadBoolean;
PossibleBondsData.UseAngleCutoffForBondsCounting:=stream.hfReadBoolean;
PossibleBondsData.AngleCutoffMin:=stream.hfReadDouble;
PossibleBondsData.AdjustBondsByValences:=stream.hfReadBoolean;
PossibleBondsData.AdjustSettongDoubleBonds:=stream.hfReadBoolean;
PossibleBondsData.UseFastModeForBigMolecules:=stream.hfReadBoolean;
PossibleBondsData.UseShortContactsMethod:=stream.hfReadBoolean;


stream.Free;
finishpossiblebondsdata;



end;


procedure LoadAndPrepareBondsData;
begin
setgroups;
setvalences;
setpriors;
setvanradii;

//initpossiblebondsdata.bond[.bond[;
//PrepareBuiltInBondsData;
loadbondsdata;
finishpossiblebondsdata;
end;

var
bondsdataprepared:boolean;
procedure SimplyPrepareBondsData;
begin
if bondsdataprepared then exit;
PrepareBuiltInBondsData;
finishpossiblebondsdata;
setgroups;
setvalences;
setpriors;
setvanradii;
//sleep(2000);
bondsdataprepared:=true;
end;

{
var
f:file;
//q,w,e:integer;
begin
assignfile(f,extractfilepath(application.ExeName)+'bonds.bin');
reset(f,1);
//blockread(f,possiblebondlength,sizeof(possiblebondlength));
blockread(f,possiblebondsdata.bond[.bond[,sizeof(possiblebondsdata.bond[.bond[));
closefile(f);
//for q:=0 to atomsinfocount-1 do for w:=0 to atomsinfocount-1 do for e:=0 to bondsinfocount-1 do possiblebondlength2[q,w,e]:=sqr(possiblebondlength[q,w,e]);
end;
}
{
procedure SaveBondsData;
var
f:file;
begin
assignfile(f,extractfilepath(application.ExeName)+'bonds.bin');
rewrite(f,1);
//blockwrite(f,possiblebondlength,sizeof(possiblebondlength));
blockwrite(f,possiblebondsdata.bond[.bond[,sizeof(possiblebondsdata.bond[.bond[));
closefile(f);
end;
}

procedure SaveBondsData;
var
stream:tmyfilestream;
q,w:integer;
procedure AddToStream(data:tpossiblebonddata; at1,at2:tatomtype);
var
n:word;
q:integer;
begin
n:=data.typescount;
if n=1 then if data.types[0].typ=0 then if equal(data.types[0].standardvalue,StandBondLenFromMoldenRad(at1,at2)) then if equal(data.types[0].maxvalue2,sqr(data.types[0].standardvalue)) then n:=0;
//для компрессии на записчваются длины связей, которые можно пересчитать из ковалентных радиусов
stream.Write(n,sizeof(n));
for q:=0 to n-1 do stream.Write(data.types[q],sizeof(data.types[q]));
end;
begin
stream:=tmyfilestream.Create(extractfilepath(application.ExeName)+'bonds4.bin',fmCreate or fmShareDenyRead);
stream.hfWriteInteger(CurProgVerNum);
//stream.hfWriteInteger(progversionnum);

for q:=0 to atomsinfocount-1 do for w:=q to atomsinfocount-1 do addtostream(possiblebondsdata.bonds[q,w],q,w);

stream.hfWriteBoolean(PossibleBondsData.CalculateBonds);
stream.hfWriteBoolean(PossibleBondsData.CountHBonds);
stream.hfWriteBoolean(PossibleBondsData.UseAngleCutoffForBondsCounting);
stream.hfWriteDouble(PossibleBondsData.AngleCutoffMin);
stream.hfWriteBoolean(PossibleBondsData.AdjustBondsByValences);
stream.hfWriteBoolean(PossibleBondsData.AdjustSettongDoubleBonds);
stream.hfWriteBoolean(PossibleBondsData.UseFastModeForBigMolecules);
stream.hfWriteBoolean(PossibleBondsData.UseShortContactsMethod);

stream.hfWriteBoolean(False);
stream.hfWriteBoolean(False);
stream.hfWriteBoolean(False);
stream.hfWriteInteger(0);
stream.hfWriteInteger(0);
stream.hfWriteInteger(0);
stream.hfWriteDouble(0);
stream.hfWriteDouble(0);
stream.hfWriteDouble(0);



stream.Free;
end;
{
procedure TFragments.LoadFromFile;
var
stream:tfilestream;
begin
try
stream:=tfilestream.Create(extractfilepath(application.ExeName)+'Fragments.bin',fmOpenRead or fmShareDenyWrite);
except
stream:=tfilestream.Create(extractfilepath(application.ExeName)+'Fragment.bin',fmOpenRead or fmShareDenyWrite);end;
loadfromstream(stream);
stream.Free;

end;

procedure TFragments.SaveToFile;
var
stream:tfilestream;

begin
stream:=tfilestream.Create(extractfilepath(application.ExeName)+'Fragments.bin',fmOpenWrite or fmShareDenyRead);
addtostream(stream);
stream.Free;
}

procedure CalculateAverIsotopeMassesAndAbundancies;
var
q,w:integer;
sumab:double;
summass:double;
begin
for q:=0 to high(tatomtype) do begin
sumab:=0;
for w:=0 to IsotopeAbundancies[q].isotopescount-1 do sumab:=sumab+IsotopeAbundancies[q].isotopes[w];
for w:=0 to IsotopeAbundancies[q].isotopescount-1 do IsotopeAbundancies[q].isotopes[w]:=IsotopeAbundancies[q].isotopes[w]/sumab;

if equal(sumab,0) then continue;
summass:=0;
for w:=0 to IsotopeAbundancies[q].isotopescount-1 do summass:=summass+(IsotopeAbundancies[q].firstisotope+w)*IsotopeAbundancies[q].isotopes[w];

IsotopeAbundancies[q].AverMass:=summass;
end;
end;

procedure FindMainIsotopes;
var
q,w:integer;
maxval:double; maxnum:integer;
begin
for q:=1 to atomsinfocount-1 do begin
maxval:=-99999;
maxnum:=-1;
for w:=0 to IsotopeAbundancies[q].isotopescount-1 do if IsotopeAbundancies[q].isotopes[w]>maxval then begin maxval:=IsotopeAbundancies[q].isotopes[w]; maxnum:=w; end;
if maxnum=-1 then begin IsotopeMasses[q].MainIsotope:=0; continue; end;
IsotopeMasses[q].MainIsotope:=IsotopeAbundancies[q].firstisotope+maxnum-IsotopeMasses[q].firstisotope;
if (IsotopeMasses[q].MainIsotope<0) or (IsotopeMasses[q].MainIsotope>IsotopeMasses[q].IsotopesCount-1) then IsotopeMasses[q].MainIsotope:=0;
end;//next q
end;//proc

procedure PrepareIsotopeMasses_Abundancies;
begin

IsotopeAbundancies[0].isotopescount:=0;
IsotopeAbundancies[1].isotopescount:=2;
IsotopeAbundancies[1].firstisotope:=1;
IsotopeAbundancies[1].isotopes[0]:=1;
IsotopeAbundancies[1].isotopes[1]:=0.00015;
IsotopeAbundancies[2].isotopescount:=2;
IsotopeAbundancies[2].firstisotope:=3;
IsotopeAbundancies[2].isotopes[0]:=0;
IsotopeAbundancies[2].isotopes[1]:=1;
IsotopeAbundancies[3].isotopescount:=2;
IsotopeAbundancies[3].firstisotope:=6;
IsotopeAbundancies[3].isotopes[0]:=0.075;
IsotopeAbundancies[3].isotopes[1]:=0.925;
IsotopeAbundancies[4].isotopescount:=1;
IsotopeAbundancies[4].firstisotope:=9;
IsotopeAbundancies[4].isotopes[0]:=1;
IsotopeAbundancies[5].isotopescount:=2;
IsotopeAbundancies[5].firstisotope:=10;
IsotopeAbundancies[5].isotopes[0]:=0.2;
IsotopeAbundancies[5].isotopes[1]:=0.8;
IsotopeAbundancies[6].isotopescount:=2;
IsotopeAbundancies[6].firstisotope:=12;
IsotopeAbundancies[6].isotopes[0]:=0.989;
IsotopeAbundancies[6].isotopes[1]:=0.0111;
IsotopeAbundancies[7].isotopescount:=2;
IsotopeAbundancies[7].firstisotope:=14;
IsotopeAbundancies[7].isotopes[0]:=0.996;
IsotopeAbundancies[7].isotopes[1]:=0.0036;
IsotopeAbundancies[8].isotopescount:=3;
IsotopeAbundancies[8].firstisotope:=16;
IsotopeAbundancies[8].isotopes[0]:=0.998;
IsotopeAbundancies[8].isotopes[1]:=0.0004;
IsotopeAbundancies[8].isotopes[2]:=0.002;
IsotopeAbundancies[9].isotopescount:=1;
IsotopeAbundancies[9].firstisotope:=19;
IsotopeAbundancies[9].isotopes[0]:=1;
IsotopeAbundancies[10].isotopescount:=3;
IsotopeAbundancies[10].firstisotope:=20;
IsotopeAbundancies[10].isotopes[0]:=0.905;
IsotopeAbundancies[10].isotopes[1]:=0.0027;
IsotopeAbundancies[10].isotopes[2]:=0.0922;
IsotopeAbundancies[11].isotopescount:=1;
IsotopeAbundancies[11].firstisotope:=23;
IsotopeAbundancies[11].isotopes[0]:=1;
IsotopeAbundancies[12].isotopescount:=3;
IsotopeAbundancies[12].firstisotope:=24;
IsotopeAbundancies[12].isotopes[0]:=0.79;
IsotopeAbundancies[12].isotopes[1]:=0.1;
IsotopeAbundancies[12].isotopes[2]:=0.11;
IsotopeAbundancies[13].isotopescount:=1;
IsotopeAbundancies[13].firstisotope:=27;
IsotopeAbundancies[13].isotopes[0]:=1;
IsotopeAbundancies[14].isotopescount:=3;
IsotopeAbundancies[14].firstisotope:=28;
IsotopeAbundancies[14].isotopes[0]:=0.922;
IsotopeAbundancies[14].isotopes[1]:=0.0467;
IsotopeAbundancies[14].isotopes[2]:=0.031;
IsotopeAbundancies[15].isotopescount:=1;
IsotopeAbundancies[15].firstisotope:=31;
IsotopeAbundancies[15].isotopes[0]:=1;
IsotopeAbundancies[16].isotopescount:=5;
IsotopeAbundancies[16].firstisotope:=32;
IsotopeAbundancies[16].isotopes[0]:=0.95;
IsotopeAbundancies[16].isotopes[1]:=0.0076;
IsotopeAbundancies[16].isotopes[2]:=0.0422;
IsotopeAbundancies[16].isotopes[3]:=0;
IsotopeAbundancies[16].isotopes[4]:=0.0002;
IsotopeAbundancies[17].isotopescount:=3;
IsotopeAbundancies[17].firstisotope:=35;
IsotopeAbundancies[17].isotopes[0]:=0.758;
IsotopeAbundancies[17].isotopes[1]:=0;
IsotopeAbundancies[17].isotopes[2]:=0.242;
IsotopeAbundancies[18].isotopescount:=5;
IsotopeAbundancies[18].firstisotope:=36;
IsotopeAbundancies[18].isotopes[0]:=0.0034;
IsotopeAbundancies[18].isotopes[1]:=0;
IsotopeAbundancies[18].isotopes[2]:=0.0007;
IsotopeAbundancies[18].isotopes[3]:=0;
IsotopeAbundancies[18].isotopes[4]:=0.996;
IsotopeAbundancies[19].isotopescount:=3;
IsotopeAbundancies[19].firstisotope:=39;
IsotopeAbundancies[19].isotopes[0]:=0.933;
IsotopeAbundancies[19].isotopes[1]:=0.0001;
IsotopeAbundancies[19].isotopes[2]:=0.0673;
IsotopeAbundancies[20].isotopescount:=9;
IsotopeAbundancies[20].firstisotope:=40;
IsotopeAbundancies[20].isotopes[0]:=0.969;
IsotopeAbundancies[20].isotopes[1]:=0;
IsotopeAbundancies[20].isotopes[2]:=0.00647;
IsotopeAbundancies[20].isotopes[3]:=0.00135;
IsotopeAbundancies[20].isotopes[4]:=0.0209;
IsotopeAbundancies[20].isotopes[5]:=0;
IsotopeAbundancies[20].isotopes[6]:=4E-5;
IsotopeAbundancies[20].isotopes[7]:=0;
IsotopeAbundancies[20].isotopes[8]:=0.00187;
IsotopeAbundancies[21].isotopescount:=1;
IsotopeAbundancies[21].firstisotope:=45;
IsotopeAbundancies[21].isotopes[0]:=1;
IsotopeAbundancies[22].isotopescount:=5;
IsotopeAbundancies[22].firstisotope:=46;
IsotopeAbundancies[22].isotopes[0]:=0.08;
IsotopeAbundancies[22].isotopes[1]:=0.075;
IsotopeAbundancies[22].isotopes[2]:=0.737;
IsotopeAbundancies[22].isotopes[3]:=0.055;
IsotopeAbundancies[22].isotopes[4]:=0.053;
IsotopeAbundancies[23].isotopescount:=2;
IsotopeAbundancies[23].firstisotope:=50;
IsotopeAbundancies[23].isotopes[0]:=0.0025;
IsotopeAbundancies[23].isotopes[1]:=0.998;
IsotopeAbundancies[24].isotopescount:=5;
IsotopeAbundancies[24].firstisotope:=50;
IsotopeAbundancies[24].isotopes[0]:=0.0435;
IsotopeAbundancies[24].isotopes[1]:=0;
IsotopeAbundancies[24].isotopes[2]:=0.838;
IsotopeAbundancies[24].isotopes[3]:=0.095;
IsotopeAbundancies[24].isotopes[4]:=0.0236;
IsotopeAbundancies[25].isotopescount:=1;
IsotopeAbundancies[25].firstisotope:=55;
IsotopeAbundancies[25].isotopes[0]:=1;
IsotopeAbundancies[26].isotopescount:=5;
IsotopeAbundancies[26].firstisotope:=54;
IsotopeAbundancies[26].isotopes[0]:=0.058;
IsotopeAbundancies[26].isotopes[1]:=0;
IsotopeAbundancies[26].isotopes[2]:=0.918;
IsotopeAbundancies[26].isotopes[3]:=0.021;
IsotopeAbundancies[26].isotopes[4]:=0.003;
IsotopeAbundancies[27].isotopescount:=1;
IsotopeAbundancies[27].firstisotope:=59;
IsotopeAbundancies[27].isotopes[0]:=1;
IsotopeAbundancies[28].isotopescount:=7;
IsotopeAbundancies[28].firstisotope:=58;
IsotopeAbundancies[28].isotopes[0]:=0.683;
IsotopeAbundancies[28].isotopes[1]:=0;
IsotopeAbundancies[28].isotopes[2]:=0.261;
IsotopeAbundancies[28].isotopes[3]:=0.0113;
IsotopeAbundancies[28].isotopes[4]:=0.0359;
IsotopeAbundancies[28].isotopes[5]:=0;
IsotopeAbundancies[28].isotopes[6]:=0.0091;
IsotopeAbundancies[29].isotopescount:=3;
IsotopeAbundancies[29].firstisotope:=63;
IsotopeAbundancies[29].isotopes[0]:=0.692;
IsotopeAbundancies[29].isotopes[1]:=0;
IsotopeAbundancies[29].isotopes[2]:=0.308;
IsotopeAbundancies[30].isotopescount:=7;
IsotopeAbundancies[30].firstisotope:=64;
IsotopeAbundancies[30].isotopes[0]:=0.486;
IsotopeAbundancies[30].isotopes[1]:=0;
IsotopeAbundancies[30].isotopes[2]:=0.279;
IsotopeAbundancies[30].isotopes[3]:=0.041;
IsotopeAbundancies[30].isotopes[4]:=0.188;
IsotopeAbundancies[30].isotopes[5]:=0;
IsotopeAbundancies[30].isotopes[6]:=0.006;
IsotopeAbundancies[31].isotopescount:=3;
IsotopeAbundancies[31].firstisotope:=69;
IsotopeAbundancies[31].isotopes[0]:=0.6;
IsotopeAbundancies[31].isotopes[1]:=0;
IsotopeAbundancies[31].isotopes[2]:=0.4;
IsotopeAbundancies[32].isotopescount:=7;
IsotopeAbundancies[32].firstisotope:=70;
IsotopeAbundancies[32].isotopes[0]:=0.205;
IsotopeAbundancies[32].isotopes[1]:=0;
IsotopeAbundancies[32].isotopes[2]:=0.274;
IsotopeAbundancies[32].isotopes[3]:=0.078;
IsotopeAbundancies[32].isotopes[4]:=0.365;
IsotopeAbundancies[32].isotopes[5]:=0;
IsotopeAbundancies[32].isotopes[6]:=0.078;
IsotopeAbundancies[33].isotopescount:=1;
IsotopeAbundancies[33].firstisotope:=75;
IsotopeAbundancies[33].isotopes[0]:=1;
IsotopeAbundancies[34].isotopescount:=9;
IsotopeAbundancies[34].firstisotope:=74;
IsotopeAbundancies[34].isotopes[0]:=0.009;
IsotopeAbundancies[34].isotopes[1]:=0;
IsotopeAbundancies[34].isotopes[2]:=0.09;
IsotopeAbundancies[34].isotopes[3]:=0.076;
IsotopeAbundancies[34].isotopes[4]:=0.235;
IsotopeAbundancies[34].isotopes[5]:=0;
IsotopeAbundancies[34].isotopes[6]:=0.498;
IsotopeAbundancies[34].isotopes[7]:=0;
IsotopeAbundancies[34].isotopes[8]:=0.092;
IsotopeAbundancies[35].isotopescount:=3;
IsotopeAbundancies[35].firstisotope:=79;
IsotopeAbundancies[35].isotopes[0]:=0.507;
IsotopeAbundancies[35].isotopes[1]:=0;
IsotopeAbundancies[35].isotopes[2]:=0.493;
IsotopeAbundancies[36].isotopescount:=9;
IsotopeAbundancies[36].firstisotope:=78;
IsotopeAbundancies[36].isotopes[0]:=0.0035;
IsotopeAbundancies[36].isotopes[1]:=0;
IsotopeAbundancies[36].isotopes[2]:=0.0225;
IsotopeAbundancies[36].isotopes[3]:=0;
IsotopeAbundancies[36].isotopes[4]:=0.116;
IsotopeAbundancies[36].isotopes[5]:=0.115;
IsotopeAbundancies[36].isotopes[6]:=0.569;
IsotopeAbundancies[36].isotopes[7]:=0;
IsotopeAbundancies[36].isotopes[8]:=0.174;
IsotopeAbundancies[37].isotopescount:=3;
IsotopeAbundancies[37].firstisotope:=85;
IsotopeAbundancies[37].isotopes[0]:=0.722;
IsotopeAbundancies[37].isotopes[1]:=0;
IsotopeAbundancies[37].isotopes[2]:=0.278;
IsotopeAbundancies[38].isotopescount:=5;
IsotopeAbundancies[38].firstisotope:=84;
IsotopeAbundancies[38].isotopes[0]:=0.005;
IsotopeAbundancies[38].isotopes[1]:=0;
IsotopeAbundancies[38].isotopes[2]:=0.099;
IsotopeAbundancies[38].isotopes[3]:=0.07;
IsotopeAbundancies[38].isotopes[4]:=0.826;
IsotopeAbundancies[39].isotopescount:=1;
IsotopeAbundancies[39].firstisotope:=89;
IsotopeAbundancies[39].isotopes[0]:=1;
IsotopeAbundancies[40].isotopescount:=7;
IsotopeAbundancies[40].firstisotope:=90;
IsotopeAbundancies[40].isotopes[0]:=0.514;
IsotopeAbundancies[40].isotopes[1]:=0.112;
IsotopeAbundancies[40].isotopes[2]:=0.171;
IsotopeAbundancies[40].isotopes[3]:=0;
IsotopeAbundancies[40].isotopes[4]:=0.175;
IsotopeAbundancies[40].isotopes[5]:=0;
IsotopeAbundancies[40].isotopes[6]:=0.028;
IsotopeAbundancies[41].isotopescount:=1;
IsotopeAbundancies[41].firstisotope:=93;
IsotopeAbundancies[41].isotopes[0]:=1;
IsotopeAbundancies[42].isotopescount:=9;
IsotopeAbundancies[42].firstisotope:=92;
IsotopeAbundancies[42].isotopes[0]:=0.148;
IsotopeAbundancies[42].isotopes[1]:=0;
IsotopeAbundancies[42].isotopes[2]:=0.093;
IsotopeAbundancies[42].isotopes[3]:=0.159;
IsotopeAbundancies[42].isotopes[4]:=0.167;
IsotopeAbundancies[42].isotopes[5]:=0.096;
IsotopeAbundancies[42].isotopes[6]:=0.241;
IsotopeAbundancies[42].isotopes[7]:=0;
IsotopeAbundancies[42].isotopes[8]:=0.096;
IsotopeAbundancies[44].isotopescount:=9;
IsotopeAbundancies[44].firstisotope:=96;
IsotopeAbundancies[44].isotopes[0]:=0.055;
IsotopeAbundancies[44].isotopes[1]:=0;
IsotopeAbundancies[44].isotopes[2]:=0.019;
IsotopeAbundancies[44].isotopes[3]:=0.127;
IsotopeAbundancies[44].isotopes[4]:=0.126;
IsotopeAbundancies[44].isotopes[5]:=0.171;
IsotopeAbundancies[44].isotopes[6]:=0.316;
IsotopeAbundancies[44].isotopes[7]:=0;
IsotopeAbundancies[44].isotopes[8]:=0.186;
IsotopeAbundancies[45].isotopescount:=1;
IsotopeAbundancies[45].firstisotope:=103;
IsotopeAbundancies[45].isotopes[0]:=1;
IsotopeAbundancies[46].isotopescount:=9;
IsotopeAbundancies[46].firstisotope:=102;
IsotopeAbundancies[46].isotopes[0]:=0.01;
IsotopeAbundancies[46].isotopes[1]:=0;
IsotopeAbundancies[46].isotopes[2]:=0.11;
IsotopeAbundancies[46].isotopes[3]:=0.222;
IsotopeAbundancies[46].isotopes[4]:=0.273;
IsotopeAbundancies[46].isotopes[5]:=0;
IsotopeAbundancies[46].isotopes[6]:=0.267;
IsotopeAbundancies[46].isotopes[7]:=0;
IsotopeAbundancies[46].isotopes[8]:=0.118;
IsotopeAbundancies[47].isotopescount:=3;
IsotopeAbundancies[47].firstisotope:=107;
IsotopeAbundancies[47].isotopes[0]:=0.518;
IsotopeAbundancies[47].isotopes[1]:=0;
IsotopeAbundancies[47].isotopes[2]:=0.482;
IsotopeAbundancies[48].isotopescount:=11;
IsotopeAbundancies[48].firstisotope:=106;
IsotopeAbundancies[48].isotopes[0]:=0.012;
IsotopeAbundancies[48].isotopes[1]:=0;
IsotopeAbundancies[48].isotopes[2]:=0.009;
IsotopeAbundancies[48].isotopes[3]:=0;
IsotopeAbundancies[48].isotopes[4]:=0.124;
IsotopeAbundancies[48].isotopes[5]:=0.128;
IsotopeAbundancies[48].isotopes[6]:=0.24;
IsotopeAbundancies[48].isotopes[7]:=0.123;
IsotopeAbundancies[48].isotopes[8]:=0.288;
IsotopeAbundancies[48].isotopes[9]:=0;
IsotopeAbundancies[48].isotopes[10]:=0.076;
IsotopeAbundancies[49].isotopescount:=3;
IsotopeAbundancies[49].firstisotope:=113;
IsotopeAbundancies[49].isotopes[0]:=0.043;
IsotopeAbundancies[49].isotopes[1]:=0;
IsotopeAbundancies[49].isotopes[2]:=0.957;
IsotopeAbundancies[50].isotopescount:=13;
IsotopeAbundancies[50].firstisotope:=112;
IsotopeAbundancies[50].isotopes[0]:=0.01;
IsotopeAbundancies[50].isotopes[1]:=0;
IsotopeAbundancies[50].isotopes[2]:=0.007;
IsotopeAbundancies[50].isotopes[3]:=0.004;
IsotopeAbundancies[50].isotopes[4]:=0.147;
IsotopeAbundancies[50].isotopes[5]:=0.077;
IsotopeAbundancies[50].isotopes[6]:=0.243;
IsotopeAbundancies[50].isotopes[7]:=0.086;
IsotopeAbundancies[50].isotopes[8]:=0.324;
IsotopeAbundancies[50].isotopes[9]:=0;
IsotopeAbundancies[50].isotopes[10]:=0.046;
IsotopeAbundancies[50].isotopes[11]:=0;
IsotopeAbundancies[50].isotopes[12]:=0.056;
IsotopeAbundancies[51].isotopescount:=3;
IsotopeAbundancies[51].firstisotope:=121;
IsotopeAbundancies[51].isotopes[0]:=0.573;
IsotopeAbundancies[51].isotopes[1]:=0;
IsotopeAbundancies[51].isotopes[2]:=0.427;
IsotopeAbundancies[52].isotopescount:=11;
IsotopeAbundancies[52].firstisotope:=120;
IsotopeAbundancies[52].isotopes[0]:=0.001;
IsotopeAbundancies[52].isotopes[1]:=0;
IsotopeAbundancies[52].isotopes[2]:=0.025;
IsotopeAbundancies[52].isotopes[3]:=0.009;
IsotopeAbundancies[52].isotopes[4]:=0.046;
IsotopeAbundancies[52].isotopes[5]:=0.07;
IsotopeAbundancies[52].isotopes[6]:=0.187;
IsotopeAbundancies[52].isotopes[7]:=0;
IsotopeAbundancies[52].isotopes[8]:=0.317;
IsotopeAbundancies[52].isotopes[9]:=0;
IsotopeAbundancies[52].isotopes[10]:=0.345;
IsotopeAbundancies[53].isotopescount:=1;
IsotopeAbundancies[53].firstisotope:=127;
IsotopeAbundancies[53].isotopes[0]:=1;
IsotopeAbundancies[54].isotopescount:=13;
IsotopeAbundancies[54].firstisotope:=124;
IsotopeAbundancies[54].isotopes[0]:=0.001;
IsotopeAbundancies[54].isotopes[1]:=0;
IsotopeAbundancies[54].isotopes[2]:=0.001;
IsotopeAbundancies[54].isotopes[3]:=0;
IsotopeAbundancies[54].isotopes[4]:=0.019;
IsotopeAbundancies[54].isotopes[5]:=0.264;
IsotopeAbundancies[54].isotopes[6]:=0.041;
IsotopeAbundancies[54].isotopes[7]:=0.212;
IsotopeAbundancies[54].isotopes[8]:=0.269;
IsotopeAbundancies[54].isotopes[9]:=0;
IsotopeAbundancies[54].isotopes[10]:=0.104;
IsotopeAbundancies[54].isotopes[11]:=0;
IsotopeAbundancies[54].isotopes[12]:=0.089;
IsotopeAbundancies[55].isotopescount:=1;
IsotopeAbundancies[55].firstisotope:=133;
IsotopeAbundancies[55].isotopes[0]:=1;
IsotopeAbundancies[56].isotopescount:=9;
IsotopeAbundancies[56].firstisotope:=130;
IsotopeAbundancies[56].isotopes[0]:=0.001;
IsotopeAbundancies[56].isotopes[1]:=0;
IsotopeAbundancies[56].isotopes[2]:=0.001;
IsotopeAbundancies[56].isotopes[3]:=0;
IsotopeAbundancies[56].isotopes[4]:=0.024;
IsotopeAbundancies[56].isotopes[5]:=0.066;
IsotopeAbundancies[56].isotopes[6]:=0.079;
IsotopeAbundancies[56].isotopes[7]:=0.112;
IsotopeAbundancies[56].isotopes[8]:=0.717;
IsotopeAbundancies[57].isotopescount:=2;
IsotopeAbundancies[57].firstisotope:=138;
IsotopeAbundancies[57].isotopes[0]:=0.0009;
IsotopeAbundancies[57].isotopes[1]:=0.999;
IsotopeAbundancies[58].isotopescount:=7;
IsotopeAbundancies[58].firstisotope:=136;
IsotopeAbundancies[58].isotopes[0]:=0.002;
IsotopeAbundancies[58].isotopes[1]:=0;
IsotopeAbundancies[58].isotopes[2]:=0.003;
IsotopeAbundancies[58].isotopes[3]:=0;
IsotopeAbundancies[58].isotopes[4]:=0.884;
IsotopeAbundancies[58].isotopes[5]:=0;
IsotopeAbundancies[58].isotopes[6]:=0.111;
IsotopeAbundancies[59].isotopescount:=1;
IsotopeAbundancies[59].firstisotope:=141;
IsotopeAbundancies[59].isotopes[0]:=1;
IsotopeAbundancies[60].isotopescount:=9;
IsotopeAbundancies[60].firstisotope:=142;
IsotopeAbundancies[60].isotopes[0]:=0.272;
IsotopeAbundancies[60].isotopes[1]:=0.122;
IsotopeAbundancies[60].isotopes[2]:=0.238;
IsotopeAbundancies[60].isotopes[3]:=0.083;
IsotopeAbundancies[60].isotopes[4]:=0.172;
IsotopeAbundancies[60].isotopes[5]:=0;
IsotopeAbundancies[60].isotopes[6]:=0.057;
IsotopeAbundancies[60].isotopes[7]:=0;
IsotopeAbundancies[60].isotopes[8]:=0.056;
IsotopeAbundancies[62].isotopescount:=11;
IsotopeAbundancies[62].firstisotope:=144;
IsotopeAbundancies[62].isotopes[0]:=0.031;
IsotopeAbundancies[62].isotopes[1]:=0;
IsotopeAbundancies[62].isotopes[2]:=0;
IsotopeAbundancies[62].isotopes[3]:=0.151;
IsotopeAbundancies[62].isotopes[4]:=0.113;
IsotopeAbundancies[62].isotopes[5]:=0.139;
IsotopeAbundancies[62].isotopes[6]:=0.074;
IsotopeAbundancies[62].isotopes[7]:=0;
IsotopeAbundancies[62].isotopes[8]:=0.266;
IsotopeAbundancies[62].isotopes[9]:=0;
IsotopeAbundancies[62].isotopes[10]:=0.226;
IsotopeAbundancies[63].isotopescount:=3;
IsotopeAbundancies[63].firstisotope:=151;
IsotopeAbundancies[63].isotopes[0]:=0.478;
IsotopeAbundancies[63].isotopes[1]:=0;
IsotopeAbundancies[63].isotopes[2]:=0.522;
IsotopeAbundancies[64].isotopescount:=9;
IsotopeAbundancies[64].firstisotope:=152;
IsotopeAbundancies[64].isotopes[0]:=0.002;
IsotopeAbundancies[64].isotopes[1]:=0;
IsotopeAbundancies[64].isotopes[2]:=0.022;
IsotopeAbundancies[64].isotopes[3]:=0.148;
IsotopeAbundancies[64].isotopes[4]:=0.205;
IsotopeAbundancies[64].isotopes[5]:=0.157;
IsotopeAbundancies[64].isotopes[6]:=0.248;
IsotopeAbundancies[64].isotopes[7]:=0;
IsotopeAbundancies[64].isotopes[8]:=0.218;
IsotopeAbundancies[65].isotopescount:=1;
IsotopeAbundancies[65].firstisotope:=159;
IsotopeAbundancies[65].isotopes[0]:=1;
IsotopeAbundancies[66].isotopescount:=9;
IsotopeAbundancies[66].firstisotope:=156;
IsotopeAbundancies[66].isotopes[0]:=0.0006;
IsotopeAbundancies[66].isotopes[1]:=0;
IsotopeAbundancies[66].isotopes[2]:=0.001;
IsotopeAbundancies[66].isotopes[3]:=0;
IsotopeAbundancies[66].isotopes[4]:=0.0234;
IsotopeAbundancies[66].isotopes[5]:=0.189;
IsotopeAbundancies[66].isotopes[6]:=0.255;
IsotopeAbundancies[66].isotopes[7]:=0.249;
IsotopeAbundancies[66].isotopes[8]:=0.282;
IsotopeAbundancies[67].isotopescount:=1;
IsotopeAbundancies[67].firstisotope:=165;
IsotopeAbundancies[67].isotopes[0]:=1;
IsotopeAbundancies[68].isotopescount:=9;
IsotopeAbundancies[68].firstisotope:=162;
IsotopeAbundancies[68].isotopes[0]:=0.001;
IsotopeAbundancies[68].isotopes[1]:=0;
IsotopeAbundancies[68].isotopes[2]:=0.016;
IsotopeAbundancies[68].isotopes[3]:=0;
IsotopeAbundancies[68].isotopes[4]:=0.334;
IsotopeAbundancies[68].isotopes[5]:=0.229;
IsotopeAbundancies[68].isotopes[6]:=0.27;
IsotopeAbundancies[68].isotopes[7]:=0;
IsotopeAbundancies[68].isotopes[8]:=0.15;
IsotopeAbundancies[69].isotopescount:=1;
IsotopeAbundancies[69].firstisotope:=169;
IsotopeAbundancies[69].isotopes[0]:=1;
IsotopeAbundancies[70].isotopescount:=9;
IsotopeAbundancies[70].firstisotope:=168;
IsotopeAbundancies[70].isotopes[0]:=0.001;
IsotopeAbundancies[70].isotopes[1]:=0;
IsotopeAbundancies[70].isotopes[2]:=0.031;
IsotopeAbundancies[70].isotopes[3]:=0.143;
IsotopeAbundancies[70].isotopes[4]:=0.219;
IsotopeAbundancies[70].isotopes[5]:=0.162;
IsotopeAbundancies[70].isotopes[6]:=0.317;
IsotopeAbundancies[70].isotopes[7]:=0;
IsotopeAbundancies[70].isotopes[8]:=0.127;
IsotopeAbundancies[71].isotopescount:=2;
IsotopeAbundancies[71].firstisotope:=175;
IsotopeAbundancies[71].isotopes[0]:=0.974;
IsotopeAbundancies[71].isotopes[1]:=0.026;
IsotopeAbundancies[72].isotopescount:=7;
IsotopeAbundancies[72].firstisotope:=174;
IsotopeAbundancies[72].isotopes[0]:=0.002;
IsotopeAbundancies[72].isotopes[1]:=0;
IsotopeAbundancies[72].isotopes[2]:=0.052;
IsotopeAbundancies[72].isotopes[3]:=0.185;
IsotopeAbundancies[72].isotopes[4]:=0.271;
IsotopeAbundancies[72].isotopes[5]:=0.138;
IsotopeAbundancies[72].isotopes[6]:=0.352;
IsotopeAbundancies[73].isotopescount:=2;
IsotopeAbundancies[73].firstisotope:=180;
IsotopeAbundancies[73].isotopes[0]:=0.00012;
IsotopeAbundancies[73].isotopes[1]:=1;
IsotopeAbundancies[74].isotopescount:=7;
IsotopeAbundancies[74].firstisotope:=180;
IsotopeAbundancies[74].isotopes[0]:=0.001;
IsotopeAbundancies[74].isotopes[1]:=0;
IsotopeAbundancies[74].isotopes[2]:=0.263;
IsotopeAbundancies[74].isotopes[3]:=0.143;
IsotopeAbundancies[74].isotopes[4]:=0.307;
IsotopeAbundancies[74].isotopes[5]:=0;
IsotopeAbundancies[74].isotopes[6]:=0.286;
IsotopeAbundancies[75].isotopescount:=3;
IsotopeAbundancies[75].firstisotope:=185;
IsotopeAbundancies[75].isotopes[0]:=0.374;
IsotopeAbundancies[75].isotopes[1]:=0;
IsotopeAbundancies[75].isotopes[2]:=0.626;
IsotopeAbundancies[76].isotopescount:=9;
IsotopeAbundancies[76].firstisotope:=184;
IsotopeAbundancies[76].isotopes[0]:=0.0002;
IsotopeAbundancies[76].isotopes[1]:=0;
IsotopeAbundancies[76].isotopes[2]:=0.0158;
IsotopeAbundancies[76].isotopes[3]:=0.016;
IsotopeAbundancies[76].isotopes[4]:=0.133;
IsotopeAbundancies[76].isotopes[5]:=0.161;
IsotopeAbundancies[76].isotopes[6]:=0.264;
IsotopeAbundancies[76].isotopes[7]:=0;
IsotopeAbundancies[76].isotopes[8]:=0.41;
IsotopeAbundancies[77].isotopescount:=3;
IsotopeAbundancies[77].firstisotope:=191;
IsotopeAbundancies[77].isotopes[0]:=0.373;
IsotopeAbundancies[77].isotopes[1]:=0;
IsotopeAbundancies[77].isotopes[2]:=0.627;
IsotopeAbundancies[78].isotopescount:=9;
IsotopeAbundancies[78].firstisotope:=190;
IsotopeAbundancies[78].isotopes[0]:=0.0001;
IsotopeAbundancies[78].isotopes[1]:=0;
IsotopeAbundancies[78].isotopes[2]:=0.0079;
IsotopeAbundancies[78].isotopes[3]:=0;
IsotopeAbundancies[78].isotopes[4]:=0.329;
IsotopeAbundancies[78].isotopes[5]:=0.338;
IsotopeAbundancies[78].isotopes[6]:=0.253;
IsotopeAbundancies[78].isotopes[7]:=0;
IsotopeAbundancies[78].isotopes[8]:=0.072;
IsotopeAbundancies[79].isotopescount:=1;
IsotopeAbundancies[79].firstisotope:=197;
IsotopeAbundancies[79].isotopes[0]:=1;
IsotopeAbundancies[80].isotopescount:=9;
IsotopeAbundancies[80].firstisotope:=196;
IsotopeAbundancies[80].isotopes[0]:=0.002;
IsotopeAbundancies[80].isotopes[1]:=0;
IsotopeAbundancies[80].isotopes[2]:=0.101;
IsotopeAbundancies[80].isotopes[3]:=0.169;
IsotopeAbundancies[80].isotopes[4]:=0.231;
IsotopeAbundancies[80].isotopes[5]:=0.132;
IsotopeAbundancies[80].isotopes[6]:=0.297;
IsotopeAbundancies[80].isotopes[7]:=0;
IsotopeAbundancies[80].isotopes[8]:=0.068;
IsotopeAbundancies[81].isotopescount:=3;
IsotopeAbundancies[81].firstisotope:=203;
IsotopeAbundancies[81].isotopes[0]:=0.295;
IsotopeAbundancies[81].isotopes[1]:=0;
IsotopeAbundancies[81].isotopes[2]:=0.705;
IsotopeAbundancies[82].isotopescount:=5;
IsotopeAbundancies[82].firstisotope:=204;
IsotopeAbundancies[82].isotopes[0]:=0.014;
IsotopeAbundancies[82].isotopes[1]:=0;
IsotopeAbundancies[82].isotopes[2]:=0.241;
IsotopeAbundancies[82].isotopes[3]:=0.221;
IsotopeAbundancies[82].isotopes[4]:=0.524;
IsotopeAbundancies[83].isotopescount:=1;
IsotopeAbundancies[83].firstisotope:=209;
IsotopeAbundancies[83].isotopes[0]:=1;

CalculateAverIsotopeMassesAndAbundancies;

IsotopeMasses[1].firstisotope:=1;
IsotopeMasses[1].isotopescount:=7;
IsotopeMasses[1].isotopemasses[0]:=1007825.03207;
IsotopeMasses[1].isotopemasses[1]:=2014101.7779;
IsotopeMasses[1].isotopemasses[2]:=3016049.2777;
IsotopeMasses[1].isotopemasses[3]:=4027810;
IsotopeMasses[1].isotopemasses[4]:=5035310;
IsotopeMasses[1].isotopemasses[5]:=6044900;
IsotopeMasses[1].isotopemasses[6]:=7052700;
IsotopeMasses[2].firstisotope:=3;
IsotopeMasses[2].isotopescount:=8;
IsotopeMasses[2].isotopemasses[0]:=3016029.319;
IsotopeMasses[2].isotopemasses[1]:=4002603.25415;
IsotopeMasses[2].isotopemasses[2]:=5012220;
IsotopeMasses[2].isotopemasses[3]:=6018889.1;
IsotopeMasses[2].isotopemasses[4]:=7028021;
IsotopeMasses[2].isotopemasses[5]:=8033922;
IsotopeMasses[2].isotopemasses[6]:=9043950;
IsotopeMasses[2].isotopemasses[7]:=10052400;
IsotopeMasses[3].firstisotope:=3;
IsotopeMasses[3].isotopescount:=10;
IsotopeMasses[3].isotopemasses[0]:=3030800;
IsotopeMasses[3].isotopemasses[1]:=4027190;
IsotopeMasses[3].isotopemasses[2]:=5012540;
IsotopeMasses[3].isotopemasses[3]:=6015122.794;
IsotopeMasses[3].isotopemasses[4]:=7016004.55;
IsotopeMasses[3].isotopemasses[5]:=8022487.36;
IsotopeMasses[3].isotopemasses[6]:=9026789.5;
IsotopeMasses[3].isotopemasses[7]:=10035481;
IsotopeMasses[3].isotopemasses[8]:=11043798;
IsotopeMasses[3].isotopemasses[9]:=12053800;
IsotopeMasses[4].firstisotope:=5;
IsotopeMasses[4].isotopescount:=12;
IsotopeMasses[4].isotopemasses[0]:=5041000;
IsotopeMasses[4].isotopemasses[1]:=6019726;
IsotopeMasses[4].isotopemasses[2]:=7016929.83;
IsotopeMasses[4].isotopemasses[3]:=8005305.1;
IsotopeMasses[4].isotopemasses[4]:=9012182.2;
IsotopeMasses[4].isotopemasses[5]:=10013533.8;
IsotopeMasses[4].isotopemasses[6]:=11021658;
IsotopeMasses[4].isotopemasses[7]:=12026921;
IsotopeMasses[4].isotopemasses[8]:=13035690;
IsotopeMasses[4].isotopemasses[9]:=14042890;
IsotopeMasses[4].isotopemasses[10]:=15053500;
IsotopeMasses[4].isotopemasses[11]:=16061900;
IsotopeMasses[5].firstisotope:=6;
IsotopeMasses[5].isotopescount:=14;
IsotopeMasses[5].isotopemasses[0]:=6046800;
IsotopeMasses[5].isotopemasses[1]:=7029920;
IsotopeMasses[5].isotopemasses[2]:=8024607.2;
IsotopeMasses[5].isotopemasses[3]:=9013328.8;
IsotopeMasses[5].isotopemasses[4]:=10012937;
IsotopeMasses[5].isotopemasses[5]:=11009305.4;
IsotopeMasses[5].isotopemasses[6]:=12014352.1;
IsotopeMasses[5].isotopemasses[7]:=13017780.2;
IsotopeMasses[5].isotopemasses[8]:=14025404;
IsotopeMasses[5].isotopemasses[9]:=15031103;
IsotopeMasses[5].isotopemasses[10]:=16039810;
IsotopeMasses[5].isotopemasses[11]:=17046990;
IsotopeMasses[5].isotopemasses[12]:=18056200;
IsotopeMasses[5].isotopemasses[13]:=19063700;
IsotopeMasses[6].firstisotope:=8;
IsotopeMasses[6].isotopescount:=15;
IsotopeMasses[6].isotopemasses[0]:=8037675;
IsotopeMasses[6].isotopemasses[1]:=9031036.7;
IsotopeMasses[6].isotopemasses[2]:=10016853.2;
IsotopeMasses[6].isotopemasses[3]:=11011433.6;
IsotopeMasses[6].isotopemasses[4]:=12000000;
IsotopeMasses[6].isotopemasses[5]:=13003354.8378;
IsotopeMasses[6].isotopemasses[6]:=14003241.989;
IsotopeMasses[6].isotopemasses[7]:=15010599.3;
IsotopeMasses[6].isotopemasses[8]:=16014701;
IsotopeMasses[6].isotopemasses[9]:=17022586;
IsotopeMasses[6].isotopemasses[10]:=18026760;
IsotopeMasses[6].isotopemasses[11]:=19034810;
IsotopeMasses[6].isotopemasses[12]:=20040300;
IsotopeMasses[6].isotopemasses[13]:=21049300;
IsotopeMasses[6].isotopemasses[14]:=22057200;
IsotopeMasses[7].firstisotope:=10;
IsotopeMasses[7].isotopescount:=16;
IsotopeMasses[7].isotopemasses[0]:=10041700;
IsotopeMasses[7].isotopemasses[1]:=11026090;
IsotopeMasses[7].isotopemasses[2]:=12018613.2;
IsotopeMasses[7].isotopemasses[3]:=13005738.6;
IsotopeMasses[7].isotopemasses[4]:=14003074.0048;
IsotopeMasses[7].isotopemasses[5]:=15000108.8982;
IsotopeMasses[7].isotopemasses[6]:=16006102;
IsotopeMasses[7].isotopemasses[7]:=17008450;
IsotopeMasses[7].isotopemasses[8]:=18014079;
IsotopeMasses[7].isotopemasses[9]:=19017029;
IsotopeMasses[7].isotopemasses[10]:=20023370;
IsotopeMasses[7].isotopemasses[11]:=21027110;
IsotopeMasses[7].isotopemasses[12]:=22034390;
IsotopeMasses[7].isotopemasses[13]:=23041200;
IsotopeMasses[7].isotopemasses[14]:=24051000;
IsotopeMasses[7].isotopemasses[15]:=25060700;
IsotopeMasses[8].firstisotope:=12;
IsotopeMasses[8].isotopescount:=17;
IsotopeMasses[8].isotopemasses[0]:=12034405;
IsotopeMasses[8].isotopemasses[1]:=13024812;
IsotopeMasses[8].isotopemasses[2]:=14008596.25;
IsotopeMasses[8].isotopemasses[3]:=15003065.6;
IsotopeMasses[8].isotopemasses[4]:=15994914.61956;
IsotopeMasses[8].isotopemasses[5]:=16999131.7;
IsotopeMasses[8].isotopemasses[6]:=17999161;
IsotopeMasses[8].isotopemasses[7]:=19003580;
IsotopeMasses[8].isotopemasses[8]:=20004076.7;
IsotopeMasses[8].isotopemasses[9]:=21008656;
IsotopeMasses[8].isotopemasses[10]:=22009970;
IsotopeMasses[8].isotopemasses[11]:=23015690;
IsotopeMasses[8].isotopemasses[12]:=24020470;
IsotopeMasses[8].isotopemasses[13]:=25029500;
IsotopeMasses[8].isotopemasses[14]:=26038300;
IsotopeMasses[8].isotopemasses[15]:=27048300;
IsotopeMasses[8].isotopemasses[16]:=28057800;
IsotopeMasses[9].firstisotope:=14;
IsotopeMasses[9].isotopescount:=18;
IsotopeMasses[9].isotopemasses[0]:=14035100;
IsotopeMasses[9].isotopemasses[1]:=15018010;
IsotopeMasses[9].isotopemasses[2]:=16011466;
IsotopeMasses[9].isotopemasses[3]:=17002095.2;
IsotopeMasses[9].isotopemasses[4]:=18000938;
IsotopeMasses[9].isotopemasses[5]:=18998403.22;
IsotopeMasses[9].isotopemasses[6]:=19999981.32;
IsotopeMasses[9].isotopemasses[7]:=20999949;
IsotopeMasses[9].isotopemasses[8]:=22002999;
IsotopeMasses[9].isotopemasses[9]:=23003570;
IsotopeMasses[9].isotopemasses[10]:=24008120;
IsotopeMasses[9].isotopemasses[11]:=25012100;
IsotopeMasses[9].isotopemasses[12]:=26019620;
IsotopeMasses[9].isotopemasses[13]:=27026800;
IsotopeMasses[9].isotopemasses[14]:=28035700;
IsotopeMasses[9].isotopemasses[15]:=29043300;
IsotopeMasses[9].isotopemasses[16]:=30052500;
IsotopeMasses[9].isotopemasses[17]:=31060400;
IsotopeMasses[10].firstisotope:=16;
IsotopeMasses[10].isotopescount:=19;
IsotopeMasses[10].isotopemasses[0]:=16025761;
IsotopeMasses[10].isotopemasses[1]:=17017670;
IsotopeMasses[10].isotopemasses[2]:=18005708.2;
IsotopeMasses[10].isotopemasses[3]:=19001880.2;
IsotopeMasses[10].isotopemasses[4]:=19992440.1754;
IsotopeMasses[10].isotopemasses[5]:=20993846.68;
IsotopeMasses[10].isotopemasses[6]:=21991385.113;
IsotopeMasses[10].isotopemasses[7]:=22994466.9;
IsotopeMasses[10].isotopemasses[8]:=23993610.8;
IsotopeMasses[10].isotopemasses[9]:=24997740;
IsotopeMasses[10].isotopemasses[10]:=26000460;
IsotopeMasses[10].isotopemasses[11]:=27007590;
IsotopeMasses[10].isotopemasses[12]:=28012070;
IsotopeMasses[10].isotopemasses[13]:=29019400;
IsotopeMasses[10].isotopemasses[14]:=30024800;
IsotopeMasses[10].isotopemasses[15]:=31033100;
IsotopeMasses[10].isotopemasses[16]:=32040000;
IsotopeMasses[10].isotopemasses[17]:=33049400;
IsotopeMasses[10].isotopemasses[18]:=34057000;
IsotopeMasses[11].firstisotope:=18;
IsotopeMasses[11].isotopescount:=20;
IsotopeMasses[11].isotopemasses[0]:=18025970;
IsotopeMasses[11].isotopemasses[1]:=19013877;
IsotopeMasses[11].isotopemasses[2]:=20007351;
IsotopeMasses[11].isotopemasses[3]:=20997655.2;
IsotopeMasses[11].isotopemasses[4]:=21994436.4;
IsotopeMasses[11].isotopemasses[5]:=22989769.281;
IsotopeMasses[11].isotopemasses[6]:=23990962.78;
IsotopeMasses[11].isotopemasses[7]:=24989954;
IsotopeMasses[11].isotopemasses[8]:=25992633;
IsotopeMasses[11].isotopemasses[9]:=26994077;
IsotopeMasses[11].isotopemasses[10]:=27998938;
IsotopeMasses[11].isotopemasses[11]:=29002861;
IsotopeMasses[11].isotopemasses[12]:=30008980;
IsotopeMasses[11].isotopemasses[13]:=31013590;
IsotopeMasses[11].isotopemasses[14]:=32020500;
IsotopeMasses[11].isotopemasses[15]:=33026700;
IsotopeMasses[11].isotopemasses[16]:=34035200;
IsotopeMasses[11].isotopemasses[17]:=35042500;
IsotopeMasses[11].isotopemasses[18]:=36051500;
IsotopeMasses[11].isotopemasses[19]:=37059300;
IsotopeMasses[12].firstisotope:=19;
IsotopeMasses[12].isotopescount:=22;
IsotopeMasses[12].isotopemasses[0]:=19035500;
IsotopeMasses[12].isotopemasses[1]:=20018860;
IsotopeMasses[12].isotopemasses[2]:=21011713;
IsotopeMasses[12].isotopemasses[3]:=21999573.8;
IsotopeMasses[12].isotopemasses[4]:=22994123.7;
IsotopeMasses[12].isotopemasses[5]:=23985041.699;
IsotopeMasses[12].isotopemasses[6]:=24985836.92;
IsotopeMasses[12].isotopemasses[7]:=25982592.93;
IsotopeMasses[12].isotopemasses[8]:=26984340.59;
IsotopeMasses[12].isotopemasses[9]:=27983876.8;
IsotopeMasses[12].isotopemasses[10]:=28988600;
IsotopeMasses[12].isotopemasses[11]:=29990434;
IsotopeMasses[12].isotopemasses[12]:=30996546;
IsotopeMasses[12].isotopemasses[13]:=31998975;
IsotopeMasses[12].isotopemasses[14]:=33005254;
IsotopeMasses[12].isotopemasses[15]:=34009460;
IsotopeMasses[12].isotopemasses[16]:=35017300;
IsotopeMasses[12].isotopemasses[17]:=36023000;
IsotopeMasses[12].isotopemasses[18]:=37031400;
IsotopeMasses[12].isotopemasses[19]:=38037600;
IsotopeMasses[12].isotopemasses[20]:=39046800;
IsotopeMasses[12].isotopemasses[21]:=40053900;
IsotopeMasses[13].firstisotope:=21;
IsotopeMasses[13].isotopescount:=22;
IsotopeMasses[13].isotopemasses[0]:=21028000;
IsotopeMasses[13].isotopemasses[1]:=22019520;
IsotopeMasses[13].isotopemasses[2]:=23007267;
IsotopeMasses[13].isotopemasses[3]:=23999939;
IsotopeMasses[13].isotopemasses[4]:=24990428.1;
IsotopeMasses[13].isotopemasses[5]:=25986891.69;
IsotopeMasses[13].isotopemasses[6]:=26981538.63;
IsotopeMasses[13].isotopemasses[7]:=27981910.31;
IsotopeMasses[13].isotopemasses[8]:=28980445;
IsotopeMasses[13].isotopemasses[9]:=29982960;
IsotopeMasses[13].isotopemasses[10]:=30983947;
IsotopeMasses[13].isotopemasses[11]:=31988120;
IsotopeMasses[13].isotopemasses[12]:=32990840;
IsotopeMasses[13].isotopemasses[13]:=33996850;
IsotopeMasses[13].isotopemasses[14]:=34999860;
IsotopeMasses[13].isotopemasses[15]:=36006210;
IsotopeMasses[13].isotopemasses[16]:=37010700;
IsotopeMasses[13].isotopemasses[17]:=38017200;
IsotopeMasses[13].isotopemasses[18]:=39023000;
IsotopeMasses[13].isotopemasses[19]:=40031500;
IsotopeMasses[13].isotopemasses[20]:=41038300;
IsotopeMasses[13].isotopemasses[21]:=42046900;
IsotopeMasses[14].firstisotope:=22;
IsotopeMasses[14].isotopescount:=23;
IsotopeMasses[14].isotopemasses[0]:=22034530;
IsotopeMasses[14].isotopemasses[1]:=23025520;
IsotopeMasses[14].isotopemasses[2]:=24011546;
IsotopeMasses[14].isotopemasses[3]:=25004106;
IsotopeMasses[14].isotopemasses[4]:=25992330;
IsotopeMasses[14].isotopemasses[5]:=26986704.91;
IsotopeMasses[14].isotopemasses[6]:=27976926.5325;
IsotopeMasses[14].isotopemasses[7]:=28976494.7;
IsotopeMasses[14].isotopemasses[8]:=29973770.17;
IsotopeMasses[14].isotopemasses[9]:=30975363.23;
IsotopeMasses[14].isotopemasses[10]:=31974148.08;
IsotopeMasses[14].isotopemasses[11]:=32978000;
IsotopeMasses[14].isotopemasses[12]:=33978576;
IsotopeMasses[14].isotopemasses[13]:=34984580;
IsotopeMasses[14].isotopemasses[14]:=35986600;
IsotopeMasses[14].isotopemasses[15]:=36992940;
IsotopeMasses[14].isotopemasses[16]:=37995630;
IsotopeMasses[14].isotopemasses[17]:=39002100;
IsotopeMasses[14].isotopemasses[18]:=40005900;
IsotopeMasses[14].isotopemasses[19]:=41014600;
IsotopeMasses[14].isotopemasses[20]:=42019800;
IsotopeMasses[14].isotopemasses[21]:=43028700;
IsotopeMasses[14].isotopemasses[22]:=44035300;
IsotopeMasses[15].firstisotope:=24;
IsotopeMasses[15].isotopescount:=23;
IsotopeMasses[15].isotopemasses[0]:=24034400;
IsotopeMasses[15].isotopemasses[1]:=25020260;
IsotopeMasses[15].isotopemasses[2]:=26011780;
IsotopeMasses[15].isotopemasses[3]:=26999230;
IsotopeMasses[15].isotopemasses[4]:=27992315;
IsotopeMasses[15].isotopemasses[5]:=28981800.6;
IsotopeMasses[15].isotopemasses[6]:=29978313.8;
IsotopeMasses[15].isotopemasses[7]:=30973761.63;
IsotopeMasses[15].isotopemasses[8]:=31973907.27;
IsotopeMasses[15].isotopemasses[9]:=32971725.5;
IsotopeMasses[15].isotopemasses[10]:=33973636;
IsotopeMasses[15].isotopemasses[11]:=34973314.1;
IsotopeMasses[15].isotopemasses[12]:=35978260;
IsotopeMasses[15].isotopemasses[13]:=36979610;
IsotopeMasses[15].isotopemasses[14]:=37984160;
IsotopeMasses[15].isotopemasses[15]:=38986180;
IsotopeMasses[15].isotopemasses[16]:=39991300;
IsotopeMasses[15].isotopemasses[17]:=40994340;
IsotopeMasses[15].isotopemasses[18]:=42001000;
IsotopeMasses[15].isotopemasses[19]:=43006200;
IsotopeMasses[15].isotopemasses[20]:=44013000;
IsotopeMasses[15].isotopemasses[21]:=45019200;
IsotopeMasses[15].isotopemasses[22]:=46027400;
IsotopeMasses[16].firstisotope:=26;
IsotopeMasses[16].isotopescount:=24;
IsotopeMasses[16].isotopemasses[0]:=26027900;
IsotopeMasses[16].isotopemasses[1]:=27018830;
IsotopeMasses[16].isotopemasses[2]:=28004370;
IsotopeMasses[16].isotopemasses[3]:=28996610;
IsotopeMasses[16].isotopemasses[4]:=29984903;
IsotopeMasses[16].isotopemasses[5]:=30979554.7;
IsotopeMasses[16].isotopemasses[6]:=31972071;
IsotopeMasses[16].isotopemasses[7]:=32971458.76;
IsotopeMasses[16].isotopemasses[8]:=33967866.9;
IsotopeMasses[16].isotopemasses[9]:=34969032.16;
IsotopeMasses[16].isotopemasses[10]:=35967080.76;
IsotopeMasses[16].isotopemasses[11]:=36971125.57;
IsotopeMasses[16].isotopemasses[12]:=37971163;
IsotopeMasses[16].isotopemasses[13]:=38975130;
IsotopeMasses[16].isotopemasses[14]:=39975450;
IsotopeMasses[16].isotopemasses[15]:=40979580;
IsotopeMasses[16].isotopemasses[16]:=41981020;
IsotopeMasses[16].isotopemasses[17]:=42987150;
IsotopeMasses[16].isotopemasses[18]:=43990200;
IsotopeMasses[16].isotopemasses[19]:=44996500;
IsotopeMasses[16].isotopemasses[20]:=46000800;
IsotopeMasses[16].isotopemasses[21]:=47008600;
IsotopeMasses[16].isotopemasses[22]:=48014200;
IsotopeMasses[16].isotopemasses[23]:=49023600;
IsotopeMasses[17].firstisotope:=28;
IsotopeMasses[17].isotopescount:=24;
IsotopeMasses[17].isotopemasses[0]:=28028500;
IsotopeMasses[17].isotopemasses[1]:=29014110;
IsotopeMasses[17].isotopemasses[2]:=30004770;
IsotopeMasses[17].isotopemasses[3]:=30992410;
IsotopeMasses[17].isotopemasses[4]:=31985690;
IsotopeMasses[17].isotopemasses[5]:=32977451.9;
IsotopeMasses[17].isotopemasses[6]:=33973762.82;
IsotopeMasses[17].isotopemasses[7]:=34968852.68;
IsotopeMasses[17].isotopemasses[8]:=35968306.98;
IsotopeMasses[17].isotopemasses[9]:=36965902.59;
IsotopeMasses[17].isotopemasses[10]:=37968010.42;
IsotopeMasses[17].isotopemasses[11]:=38968008.2;
IsotopeMasses[17].isotopemasses[12]:=39970420;
IsotopeMasses[17].isotopemasses[13]:=40970680;
IsotopeMasses[17].isotopemasses[14]:=41973250;
IsotopeMasses[17].isotopemasses[15]:=42974050;
IsotopeMasses[17].isotopemasses[16]:=43978280;
IsotopeMasses[17].isotopemasses[17]:=44980290;
IsotopeMasses[17].isotopemasses[18]:=45984200;
IsotopeMasses[17].isotopemasses[19]:=46988700;
IsotopeMasses[17].isotopemasses[20]:=47995000;
IsotopeMasses[17].isotopemasses[21]:=49000300;
IsotopeMasses[17].isotopemasses[22]:=50007800;
IsotopeMasses[17].isotopemasses[23]:=51014500;
IsotopeMasses[18].firstisotope:=30;
IsotopeMasses[18].isotopescount:=24;
IsotopeMasses[18].isotopemasses[0]:=30021600;
IsotopeMasses[18].isotopemasses[1]:=31012120;
IsotopeMasses[18].isotopemasses[2]:=31997638;
IsotopeMasses[18].isotopemasses[3]:=32989925.7;
IsotopeMasses[18].isotopemasses[4]:=33980271.2;
IsotopeMasses[18].isotopemasses[5]:=34975257.6;
IsotopeMasses[18].isotopemasses[6]:=35967545.1;
IsotopeMasses[18].isotopemasses[7]:=36966776.32;
IsotopeMasses[18].isotopemasses[8]:=37962732.4;
IsotopeMasses[18].isotopemasses[9]:=38964313;
IsotopeMasses[18].isotopemasses[10]:=39962383.123;
IsotopeMasses[18].isotopemasses[11]:=40964500.6;
IsotopeMasses[18].isotopemasses[12]:=41963046;
IsotopeMasses[18].isotopemasses[13]:=42965636;
IsotopeMasses[18].isotopemasses[14]:=43964924;
IsotopeMasses[18].isotopemasses[15]:=44968040;
IsotopeMasses[18].isotopemasses[16]:=45968090;
IsotopeMasses[18].isotopemasses[17]:=46972190;
IsotopeMasses[18].isotopemasses[18]:=47974500;
IsotopeMasses[18].isotopemasses[19]:=48980500;
IsotopeMasses[18].isotopemasses[20]:=49984400;
IsotopeMasses[18].isotopemasses[21]:=50991600;
IsotopeMasses[18].isotopemasses[22]:=51996800;
IsotopeMasses[18].isotopemasses[23]:=53004900;
IsotopeMasses[19].firstisotope:=32;
IsotopeMasses[19].isotopescount:=24;
IsotopeMasses[19].isotopemasses[0]:=32021900;
IsotopeMasses[19].isotopemasses[1]:=33007260;
IsotopeMasses[19].isotopemasses[2]:=33998400;
IsotopeMasses[19].isotopemasses[3]:=34988010;
IsotopeMasses[19].isotopemasses[4]:=35981292;
IsotopeMasses[19].isotopemasses[5]:=36973375.89;
IsotopeMasses[19].isotopemasses[6]:=37969081.2;
IsotopeMasses[19].isotopemasses[7]:=38963706.68;
IsotopeMasses[19].isotopemasses[8]:=39963998.48;
IsotopeMasses[19].isotopemasses[9]:=40961825.76;
IsotopeMasses[19].isotopemasses[10]:=41962402.81;
IsotopeMasses[19].isotopemasses[11]:=42960716;
IsotopeMasses[19].isotopemasses[12]:=43961560;
IsotopeMasses[19].isotopemasses[13]:=44960699;
IsotopeMasses[19].isotopemasses[14]:=45961977;
IsotopeMasses[19].isotopemasses[15]:=46961678;
IsotopeMasses[19].isotopemasses[16]:=47965510;
IsotopeMasses[19].isotopemasses[17]:=48967450;
IsotopeMasses[19].isotopemasses[18]:=49972800;
IsotopeMasses[19].isotopemasses[19]:=50976400;
IsotopeMasses[19].isotopemasses[20]:=51982600;
IsotopeMasses[19].isotopemasses[21]:=52987100;
IsotopeMasses[19].isotopemasses[22]:=53994200;
IsotopeMasses[19].isotopemasses[23]:=54999700;
IsotopeMasses[20].firstisotope:=34;
IsotopeMasses[20].isotopescount:=24;
IsotopeMasses[20].isotopemasses[0]:=34014100;
IsotopeMasses[20].isotopemasses[1]:=35004940;
IsotopeMasses[20].isotopemasses[2]:=35993090;
IsotopeMasses[20].isotopemasses[3]:=36985870;
IsotopeMasses[20].isotopemasses[4]:=37976318;
IsotopeMasses[20].isotopemasses[5]:=38970719.7;
IsotopeMasses[20].isotopemasses[6]:=39962590.98;
IsotopeMasses[20].isotopemasses[7]:=40962278.1;
IsotopeMasses[20].isotopemasses[8]:=41958618;
IsotopeMasses[20].isotopemasses[9]:=42958766.6;
IsotopeMasses[20].isotopemasses[10]:=43955481.8;
IsotopeMasses[20].isotopemasses[11]:=44956186.6;
IsotopeMasses[20].isotopemasses[12]:=45953692.6;
IsotopeMasses[20].isotopemasses[13]:=46954546;
IsotopeMasses[20].isotopemasses[14]:=47952534;
IsotopeMasses[20].isotopemasses[15]:=48955674;
IsotopeMasses[20].isotopemasses[16]:=49957519;
IsotopeMasses[20].isotopemasses[17]:=50961500;
IsotopeMasses[20].isotopemasses[18]:=51965100;
IsotopeMasses[20].isotopemasses[19]:=52970100;
IsotopeMasses[20].isotopemasses[20]:=53974400;
IsotopeMasses[20].isotopemasses[21]:=54980600;
IsotopeMasses[20].isotopemasses[22]:=55985600;
IsotopeMasses[20].isotopemasses[23]:=56992400;
IsotopeMasses[21].firstisotope:=36;
IsotopeMasses[21].isotopescount:=25;
IsotopeMasses[21].isotopemasses[0]:=36014900;
IsotopeMasses[21].isotopemasses[1]:=37003100;
IsotopeMasses[21].isotopemasses[2]:=37994700;
IsotopeMasses[21].isotopemasses[3]:=38984790;
IsotopeMasses[21].isotopemasses[4]:=39977967;
IsotopeMasses[21].isotopemasses[5]:=40969251.12;
IsotopeMasses[21].isotopemasses[6]:=41965516.4;
IsotopeMasses[21].isotopemasses[7]:=42961150.7;
IsotopeMasses[21].isotopemasses[8]:=43959402.8;
IsotopeMasses[21].isotopemasses[9]:=44955911.9;
IsotopeMasses[21].isotopemasses[10]:=45955171.9;
IsotopeMasses[21].isotopemasses[11]:=46952407.5;
IsotopeMasses[21].isotopemasses[12]:=47952231;
IsotopeMasses[21].isotopemasses[13]:=48950024;
IsotopeMasses[21].isotopemasses[14]:=49952188;
IsotopeMasses[21].isotopemasses[15]:=50953603;
IsotopeMasses[21].isotopemasses[16]:=51956680;
IsotopeMasses[21].isotopemasses[17]:=52959600;
IsotopeMasses[21].isotopemasses[18]:=53963300;
IsotopeMasses[21].isotopemasses[19]:=54968200;
IsotopeMasses[21].isotopemasses[20]:=55972900;
IsotopeMasses[21].isotopemasses[21]:=56977800;
IsotopeMasses[21].isotopemasses[22]:=57983700;
IsotopeMasses[21].isotopemasses[23]:=58989200;
IsotopeMasses[21].isotopemasses[24]:=59995700;
IsotopeMasses[22].firstisotope:=38;
IsotopeMasses[22].isotopescount:=26;
IsotopeMasses[22].isotopemasses[0]:=38009800;
IsotopeMasses[22].isotopemasses[1]:=39001610;
IsotopeMasses[22].isotopemasses[2]:=39990500;
IsotopeMasses[22].isotopemasses[3]:=40983150;
IsotopeMasses[22].isotopemasses[4]:=41973031;
IsotopeMasses[22].isotopemasses[5]:=42968522;
IsotopeMasses[22].isotopemasses[6]:=43959690.1;
IsotopeMasses[22].isotopemasses[7]:=44958125.6;
IsotopeMasses[22].isotopemasses[8]:=45952631.6;
IsotopeMasses[22].isotopemasses[9]:=46951763.1;
IsotopeMasses[22].isotopemasses[10]:=47947946.3;
IsotopeMasses[22].isotopemasses[11]:=48947870;
IsotopeMasses[22].isotopemasses[12]:=49944791.2;
IsotopeMasses[22].isotopemasses[13]:=50946615;
IsotopeMasses[22].isotopemasses[14]:=51946897;
IsotopeMasses[22].isotopemasses[15]:=52949730;
IsotopeMasses[22].isotopemasses[16]:=53951050;
IsotopeMasses[22].isotopemasses[17]:=54955270;
IsotopeMasses[22].isotopemasses[18]:=55958200;
IsotopeMasses[22].isotopemasses[19]:=56964000;
IsotopeMasses[22].isotopemasses[20]:=57967000;
IsotopeMasses[22].isotopemasses[21]:=58972900;
IsotopeMasses[22].isotopemasses[22]:=59976800;
IsotopeMasses[22].isotopemasses[23]:=60983200;
IsotopeMasses[22].isotopemasses[24]:=61987500;
IsotopeMasses[22].isotopemasses[25]:=62994400;
IsotopeMasses[23].firstisotope:=40;
IsotopeMasses[23].isotopescount:=26;
IsotopeMasses[23].isotopemasses[0]:=40011100;
IsotopeMasses[23].isotopemasses[1]:=40999780;
IsotopeMasses[23].isotopemasses[2]:=41991230;
IsotopeMasses[23].isotopemasses[3]:=42980650;
IsotopeMasses[23].isotopemasses[4]:=43974110;
IsotopeMasses[23].isotopemasses[5]:=44965776;
IsotopeMasses[23].isotopemasses[6]:=45960200.5;
IsotopeMasses[23].isotopemasses[7]:=46954908.9;
IsotopeMasses[23].isotopemasses[8]:=47952254;
IsotopeMasses[23].isotopemasses[9]:=48948516.1;
IsotopeMasses[23].isotopemasses[10]:=49947158.5;
IsotopeMasses[23].isotopemasses[11]:=50943959.5;
IsotopeMasses[23].isotopemasses[12]:=51944775.5;
IsotopeMasses[23].isotopemasses[13]:=52944338;
IsotopeMasses[23].isotopemasses[14]:=53946440;
IsotopeMasses[23].isotopemasses[15]:=54947230;
IsotopeMasses[23].isotopemasses[16]:=55950530;
IsotopeMasses[23].isotopemasses[17]:=56952560;
IsotopeMasses[23].isotopemasses[18]:=57956800;
IsotopeMasses[23].isotopemasses[19]:=58960200;
IsotopeMasses[23].isotopemasses[20]:=59965000;
IsotopeMasses[23].isotopemasses[21]:=60968500;
IsotopeMasses[23].isotopemasses[22]:=61973800;
IsotopeMasses[23].isotopemasses[23]:=62977600;
IsotopeMasses[23].isotopemasses[24]:=63983500;
IsotopeMasses[23].isotopemasses[25]:=64987900;
IsotopeMasses[24].firstisotope:=42;
IsotopeMasses[24].isotopescount:=26;
IsotopeMasses[24].isotopemasses[0]:=42006400;
IsotopeMasses[24].isotopemasses[1]:=42997710;
IsotopeMasses[24].isotopemasses[2]:=43985550;
IsotopeMasses[24].isotopemasses[3]:=44979600;
IsotopeMasses[24].isotopemasses[4]:=45968359;
IsotopeMasses[24].isotopemasses[5]:=46962900;
IsotopeMasses[24].isotopemasses[6]:=47954032;
IsotopeMasses[24].isotopemasses[7]:=48951336;
IsotopeMasses[24].isotopemasses[8]:=49946044.2;
IsotopeMasses[24].isotopemasses[9]:=50944767.4;
IsotopeMasses[24].isotopemasses[10]:=51940507.5;
IsotopeMasses[24].isotopemasses[11]:=52940649.4;
IsotopeMasses[24].isotopemasses[12]:=53938880.4;
IsotopeMasses[24].isotopemasses[13]:=54940839.7;
IsotopeMasses[24].isotopemasses[14]:=55940653.1;
IsotopeMasses[24].isotopemasses[15]:=56943613;
IsotopeMasses[24].isotopemasses[16]:=57944350;
IsotopeMasses[24].isotopemasses[17]:=58948600;
IsotopeMasses[24].isotopemasses[18]:=59950080;
IsotopeMasses[24].isotopemasses[19]:=60954700;
IsotopeMasses[24].isotopemasses[20]:=61956600;
IsotopeMasses[24].isotopemasses[21]:=62961900;
IsotopeMasses[24].isotopemasses[22]:=63964400;
IsotopeMasses[24].isotopemasses[23]:=64970200;
IsotopeMasses[24].isotopemasses[24]:=65973400;
IsotopeMasses[24].isotopemasses[25]:=66979600;
IsotopeMasses[25].firstisotope:=44;
IsotopeMasses[25].isotopescount:=26;
IsotopeMasses[25].isotopemasses[0]:=44006900;
IsotopeMasses[25].isotopemasses[1]:=44994500;
IsotopeMasses[25].isotopemasses[2]:=45986720;
IsotopeMasses[25].isotopemasses[3]:=46976100;
IsotopeMasses[25].isotopemasses[4]:=47968520;
IsotopeMasses[25].isotopemasses[5]:=48959620;
IsotopeMasses[25].isotopemasses[6]:=49954238.2;
IsotopeMasses[25].isotopemasses[7]:=50948210.8;
IsotopeMasses[25].isotopemasses[8]:=51945565.5;
IsotopeMasses[25].isotopemasses[9]:=52941290.1;
IsotopeMasses[25].isotopemasses[10]:=53940358.9;
IsotopeMasses[25].isotopemasses[11]:=54938045.1;
IsotopeMasses[25].isotopemasses[12]:=55938904.9;
IsotopeMasses[25].isotopemasses[13]:=56938285.4;
IsotopeMasses[25].isotopemasses[14]:=57939980;
IsotopeMasses[25].isotopemasses[15]:=58940440;
IsotopeMasses[25].isotopemasses[16]:=59942910;
IsotopeMasses[25].isotopemasses[17]:=60944650;
IsotopeMasses[25].isotopemasses[18]:=61948430;
IsotopeMasses[25].isotopemasses[19]:=62950200;
IsotopeMasses[25].isotopemasses[20]:=63954200;
IsotopeMasses[25].isotopemasses[21]:=64956300;
IsotopeMasses[25].isotopemasses[22]:=65961100;
IsotopeMasses[25].isotopemasses[23]:=66964100;
IsotopeMasses[25].isotopemasses[24]:=67969300;
IsotopeMasses[25].isotopemasses[25]:=68972800;
IsotopeMasses[26].firstisotope:=45;
IsotopeMasses[26].isotopescount:=28;
IsotopeMasses[26].isotopemasses[0]:=45014580;
IsotopeMasses[26].isotopemasses[1]:=46000800;
IsotopeMasses[26].isotopemasses[2]:=46992900;
IsotopeMasses[26].isotopemasses[3]:=47980500;
IsotopeMasses[26].isotopemasses[4]:=48973610;
IsotopeMasses[26].isotopemasses[5]:=49962990;
IsotopeMasses[26].isotopemasses[6]:=50956820;
IsotopeMasses[26].isotopemasses[7]:=51948114;
IsotopeMasses[26].isotopemasses[8]:=52945307.9;
IsotopeMasses[26].isotopemasses[9]:=53939610.5;
IsotopeMasses[26].isotopemasses[10]:=54938293.4;
IsotopeMasses[26].isotopemasses[11]:=55934937.5;
IsotopeMasses[26].isotopemasses[12]:=56935394;
IsotopeMasses[26].isotopemasses[13]:=57933275.6;
IsotopeMasses[26].isotopemasses[14]:=58934875.5;
IsotopeMasses[26].isotopemasses[15]:=59934072;
IsotopeMasses[26].isotopemasses[16]:=60936745;
IsotopeMasses[26].isotopemasses[17]:=61936767;
IsotopeMasses[26].isotopemasses[18]:=62940370;
IsotopeMasses[26].isotopemasses[19]:=63941200;
IsotopeMasses[26].isotopemasses[20]:=64945400;
IsotopeMasses[26].isotopemasses[21]:=65946800;
IsotopeMasses[26].isotopemasses[22]:=66950900;
IsotopeMasses[26].isotopemasses[23]:=67953700;
IsotopeMasses[26].isotopemasses[24]:=68958800;
IsotopeMasses[26].isotopemasses[25]:=69961500;
IsotopeMasses[26].isotopemasses[26]:=70966700;
IsotopeMasses[26].isotopemasses[27]:=71969600;
IsotopeMasses[27].firstisotope:=47;
IsotopeMasses[27].isotopescount:=29;
IsotopeMasses[27].isotopemasses[0]:=47011500;
IsotopeMasses[27].isotopemasses[1]:=48001800;
IsotopeMasses[27].isotopemasses[2]:=48989700;
IsotopeMasses[27].isotopemasses[3]:=49981540;
IsotopeMasses[27].isotopemasses[4]:=50970720;
IsotopeMasses[27].isotopemasses[5]:=51963590;
IsotopeMasses[27].isotopemasses[6]:=52954219;
IsotopeMasses[27].isotopemasses[7]:=53948459.6;
IsotopeMasses[27].isotopemasses[8]:=54941999;
IsotopeMasses[27].isotopemasses[9]:=55939839.3;
IsotopeMasses[27].isotopemasses[10]:=56936291.4;
IsotopeMasses[27].isotopemasses[11]:=57935752.8;
IsotopeMasses[27].isotopemasses[12]:=58933195;
IsotopeMasses[27].isotopemasses[13]:=59933817.1;
IsotopeMasses[27].isotopemasses[14]:=60932475.8;
IsotopeMasses[27].isotopemasses[15]:=61934051;
IsotopeMasses[27].isotopemasses[16]:=62933612;
IsotopeMasses[27].isotopemasses[17]:=63935810;
IsotopeMasses[27].isotopemasses[18]:=64936478;
IsotopeMasses[27].isotopemasses[19]:=65939800;
IsotopeMasses[27].isotopemasses[20]:=66940900;
IsotopeMasses[27].isotopemasses[21]:=67944900;
IsotopeMasses[27].isotopemasses[22]:=68946300;
IsotopeMasses[27].isotopemasses[23]:=69951000;
IsotopeMasses[27].isotopemasses[24]:=70952900;
IsotopeMasses[27].isotopemasses[25]:=71957800;
IsotopeMasses[27].isotopemasses[26]:=72960200;
IsotopeMasses[27].isotopemasses[27]:=73965400;
IsotopeMasses[27].isotopemasses[28]:=74968300;
IsotopeMasses[28].firstisotope:=48;
IsotopeMasses[28].isotopescount:=31;
IsotopeMasses[28].isotopemasses[0]:=48019800;
IsotopeMasses[28].isotopemasses[1]:=49009700;
IsotopeMasses[28].isotopemasses[2]:=49995900;
IsotopeMasses[28].isotopemasses[3]:=50987700;
IsotopeMasses[28].isotopemasses[4]:=51975680;
IsotopeMasses[28].isotopemasses[5]:=52968470;
IsotopeMasses[28].isotopemasses[6]:=53957910;
IsotopeMasses[28].isotopemasses[7]:=54951330;
IsotopeMasses[28].isotopemasses[8]:=55942132;
IsotopeMasses[28].isotopemasses[9]:=56939793.5;
IsotopeMasses[28].isotopemasses[10]:=57935342.9;
IsotopeMasses[28].isotopemasses[11]:=58934346.7;
IsotopeMasses[28].isotopemasses[12]:=59930786.4;
IsotopeMasses[28].isotopemasses[13]:=60931056;
IsotopeMasses[28].isotopemasses[14]:=61928345.1;
IsotopeMasses[28].isotopemasses[15]:=62929669.4;
IsotopeMasses[28].isotopemasses[16]:=63927966;
IsotopeMasses[28].isotopemasses[17]:=64930084.3;
IsotopeMasses[28].isotopemasses[18]:=65929139.3;
IsotopeMasses[28].isotopemasses[19]:=66931569;
IsotopeMasses[28].isotopemasses[20]:=67931869;
IsotopeMasses[28].isotopemasses[21]:=68935610;
IsotopeMasses[28].isotopemasses[22]:=69936500;
IsotopeMasses[28].isotopemasses[23]:=70940700;
IsotopeMasses[28].isotopemasses[24]:=71942100;
IsotopeMasses[28].isotopemasses[25]:=72946500;
IsotopeMasses[28].isotopemasses[26]:=73948100;
IsotopeMasses[28].isotopemasses[27]:=74952900;
IsotopeMasses[28].isotopemasses[28]:=75955300;
IsotopeMasses[28].isotopemasses[29]:=76960600;
IsotopeMasses[28].isotopemasses[30]:=77963200;
IsotopeMasses[29].firstisotope:=52;
IsotopeMasses[29].isotopescount:=29;
IsotopeMasses[29].isotopemasses[0]:=51997200;
IsotopeMasses[29].isotopemasses[1]:=52985600;
IsotopeMasses[29].isotopemasses[2]:=53976710;
IsotopeMasses[29].isotopemasses[3]:=54966100;
IsotopeMasses[29].isotopemasses[4]:=55958560;
IsotopeMasses[29].isotopemasses[5]:=56949211;
IsotopeMasses[29].isotopemasses[6]:=57944538.5;
IsotopeMasses[29].isotopemasses[7]:=58939498;
IsotopeMasses[29].isotopemasses[8]:=59937365;
IsotopeMasses[29].isotopemasses[9]:=60933457.8;
IsotopeMasses[29].isotopemasses[10]:=61932584;
IsotopeMasses[29].isotopemasses[11]:=62929597.5;
IsotopeMasses[29].isotopemasses[12]:=63929764.2;
IsotopeMasses[29].isotopemasses[13]:=64927789.5;
IsotopeMasses[29].isotopemasses[14]:=65928868.8;
IsotopeMasses[29].isotopemasses[15]:=66927730.3;
IsotopeMasses[29].isotopemasses[16]:=67929610.9;
IsotopeMasses[29].isotopemasses[17]:=68929429.3;
IsotopeMasses[29].isotopemasses[18]:=69932392.3;
IsotopeMasses[29].isotopemasses[19]:=70932676.8;
IsotopeMasses[29].isotopemasses[20]:=71935820.3;
IsotopeMasses[29].isotopemasses[21]:=72936675;
IsotopeMasses[29].isotopemasses[22]:=73939875;
IsotopeMasses[29].isotopemasses[23]:=74941900;
IsotopeMasses[29].isotopemasses[24]:=75945275;
IsotopeMasses[29].isotopemasses[25]:=76947900;
IsotopeMasses[29].isotopemasses[26]:=77952000;
IsotopeMasses[29].isotopemasses[27]:=78954600;
IsotopeMasses[29].isotopemasses[28]:=79960900;
IsotopeMasses[30].firstisotope:=54;
IsotopeMasses[30].isotopescount:=30;
IsotopeMasses[30].isotopemasses[0]:=53993000;
IsotopeMasses[30].isotopemasses[1]:=54984000;
IsotopeMasses[30].isotopemasses[2]:=55972400;
IsotopeMasses[30].isotopemasses[3]:=56964790;
IsotopeMasses[30].isotopemasses[4]:=57954590;
IsotopeMasses[30].isotopemasses[5]:=58949260;
IsotopeMasses[30].isotopemasses[6]:=59941827;
IsotopeMasses[30].isotopemasses[7]:=60939511;
IsotopeMasses[30].isotopemasses[8]:=61934330;
IsotopeMasses[30].isotopemasses[9]:=62933211.6;
IsotopeMasses[30].isotopemasses[10]:=63929142.2;
IsotopeMasses[30].isotopemasses[11]:=64929241;
IsotopeMasses[30].isotopemasses[12]:=65926033.4;
IsotopeMasses[30].isotopemasses[13]:=66927127.3;
IsotopeMasses[30].isotopemasses[14]:=67924844.2;
IsotopeMasses[30].isotopemasses[15]:=68926550.3;
IsotopeMasses[30].isotopemasses[16]:=69925319.3;
IsotopeMasses[30].isotopemasses[17]:=70927722;
IsotopeMasses[30].isotopemasses[18]:=71926858;
IsotopeMasses[30].isotopemasses[19]:=72929780;
IsotopeMasses[30].isotopemasses[20]:=73929460;
IsotopeMasses[30].isotopemasses[21]:=74932940;
IsotopeMasses[30].isotopemasses[22]:=75933290;
IsotopeMasses[30].isotopemasses[23]:=76936960;
IsotopeMasses[30].isotopemasses[24]:=77938440;
IsotopeMasses[30].isotopemasses[25]:=78942700;
IsotopeMasses[30].isotopemasses[26]:=79944340;
IsotopeMasses[30].isotopemasses[27]:=80950500;
IsotopeMasses[30].isotopemasses[28]:=81954400;
IsotopeMasses[30].isotopemasses[29]:=82961000;
IsotopeMasses[31].firstisotope:=56;
IsotopeMasses[31].isotopescount:=31;
IsotopeMasses[31].isotopemasses[0]:=55994900;
IsotopeMasses[31].isotopemasses[1]:=56982900;
IsotopeMasses[31].isotopemasses[2]:=57974250;
IsotopeMasses[31].isotopemasses[3]:=58963370;
IsotopeMasses[31].isotopemasses[4]:=59957060;
IsotopeMasses[31].isotopemasses[5]:=60949450;
IsotopeMasses[31].isotopemasses[6]:=61944180;
IsotopeMasses[31].isotopemasses[7]:=62939294.2;
IsotopeMasses[31].isotopemasses[8]:=63936838.7;
IsotopeMasses[31].isotopemasses[9]:=64932734.8;
IsotopeMasses[31].isotopemasses[10]:=65931589;
IsotopeMasses[31].isotopemasses[11]:=66928201.7;
IsotopeMasses[31].isotopemasses[12]:=67927980.1;
IsotopeMasses[31].isotopemasses[13]:=68925573.6;
IsotopeMasses[31].isotopemasses[14]:=69926022;
IsotopeMasses[31].isotopemasses[15]:=70924701.3;
IsotopeMasses[31].isotopemasses[16]:=71926366.3;
IsotopeMasses[31].isotopemasses[17]:=72925174.7;
IsotopeMasses[31].isotopemasses[18]:=73926946;
IsotopeMasses[31].isotopemasses[19]:=74926500;
IsotopeMasses[31].isotopemasses[20]:=75928827.6;
IsotopeMasses[31].isotopemasses[21]:=76929154;
IsotopeMasses[31].isotopemasses[22]:=77931608;
IsotopeMasses[31].isotopemasses[23]:=78932890;
IsotopeMasses[31].isotopemasses[24]:=79936520;
IsotopeMasses[31].isotopemasses[25]:=80937750;
IsotopeMasses[31].isotopemasses[26]:=81943000;
IsotopeMasses[31].isotopemasses[27]:=82947000;
IsotopeMasses[31].isotopemasses[28]:=83952700;
IsotopeMasses[31].isotopemasses[29]:=84957000;
IsotopeMasses[31].isotopemasses[30]:=85963100;
IsotopeMasses[32].firstisotope:=58;
IsotopeMasses[32].isotopescount:=32;
IsotopeMasses[32].isotopemasses[0]:=57991000;
IsotopeMasses[32].isotopemasses[1]:=58981800;
IsotopeMasses[32].isotopemasses[2]:=59970190;
IsotopeMasses[32].isotopemasses[3]:=60963800;
IsotopeMasses[32].isotopemasses[4]:=61954650;
IsotopeMasses[32].isotopemasses[5]:=62949640;
IsotopeMasses[32].isotopemasses[6]:=63941650;
IsotopeMasses[32].isotopemasses[7]:=64939440;
IsotopeMasses[32].isotopemasses[8]:=65933840;
IsotopeMasses[32].isotopemasses[9]:=66932734;
IsotopeMasses[32].isotopemasses[10]:=67928094;
IsotopeMasses[32].isotopemasses[11]:=68927964.5;
IsotopeMasses[32].isotopemasses[12]:=69924247.4;
IsotopeMasses[32].isotopemasses[13]:=70924951;
IsotopeMasses[32].isotopemasses[14]:=71922075.8;
IsotopeMasses[32].isotopemasses[15]:=72923458.9;
IsotopeMasses[32].isotopemasses[16]:=73921177.8;
IsotopeMasses[32].isotopemasses[17]:=74922858.9;
IsotopeMasses[32].isotopemasses[18]:=75921402.6;
IsotopeMasses[32].isotopemasses[19]:=76923548.6;
IsotopeMasses[32].isotopemasses[20]:=77922853;
IsotopeMasses[32].isotopemasses[21]:=78925400;
IsotopeMasses[32].isotopemasses[22]:=79925370;
IsotopeMasses[32].isotopemasses[23]:=80928820;
IsotopeMasses[32].isotopemasses[24]:=81929500;
IsotopeMasses[32].isotopemasses[25]:=82934620;
IsotopeMasses[32].isotopemasses[26]:=83937500;
IsotopeMasses[32].isotopemasses[27]:=84943000;
IsotopeMasses[32].isotopemasses[28]:=85946500;
IsotopeMasses[32].isotopemasses[29]:=86952500;
IsotopeMasses[32].isotopemasses[30]:=87956900;
IsotopeMasses[32].isotopemasses[31]:=88963800;
IsotopeMasses[33].firstisotope:=60;
IsotopeMasses[33].isotopescount:=33;
IsotopeMasses[33].isotopemasses[0]:=59993100;
IsotopeMasses[33].isotopemasses[1]:=60980600;
IsotopeMasses[33].isotopemasses[2]:=61973200;
IsotopeMasses[33].isotopemasses[3]:=62963700;
IsotopeMasses[33].isotopemasses[4]:=63957600;
IsotopeMasses[33].isotopemasses[5]:=64949600;
IsotopeMasses[33].isotopemasses[6]:=65944700;
IsotopeMasses[33].isotopemasses[7]:=66939190;
IsotopeMasses[33].isotopemasses[8]:=67936770;
IsotopeMasses[33].isotopemasses[9]:=68932270;
IsotopeMasses[33].isotopemasses[10]:=69930920;
IsotopeMasses[33].isotopemasses[11]:=70927112;
IsotopeMasses[33].isotopemasses[12]:=71926752;
IsotopeMasses[33].isotopemasses[13]:=72923825;
IsotopeMasses[33].isotopemasses[14]:=73923928.7;
IsotopeMasses[33].isotopemasses[15]:=74921596.5;
IsotopeMasses[33].isotopemasses[16]:=75922394;
IsotopeMasses[33].isotopemasses[17]:=76920647.3;
IsotopeMasses[33].isotopemasses[18]:=77921827;
IsotopeMasses[33].isotopemasses[19]:=78920948;
IsotopeMasses[33].isotopemasses[20]:=79922534;
IsotopeMasses[33].isotopemasses[21]:=80922132;
IsotopeMasses[33].isotopemasses[22]:=81924500;
IsotopeMasses[33].isotopemasses[23]:=82924980;
IsotopeMasses[33].isotopemasses[24]:=83929100;
IsotopeMasses[33].isotopemasses[25]:=84932020;
IsotopeMasses[33].isotopemasses[26]:=85936500;
IsotopeMasses[33].isotopemasses[27]:=86939900;
IsotopeMasses[33].isotopemasses[28]:=87944900;
IsotopeMasses[33].isotopemasses[29]:=88949400;
IsotopeMasses[33].isotopemasses[30]:=89955500;
IsotopeMasses[33].isotopemasses[31]:=90960400;
IsotopeMasses[33].isotopemasses[32]:=91966800;
IsotopeMasses[34].firstisotope:=65;
IsotopeMasses[34].isotopescount:=30;
IsotopeMasses[34].isotopemasses[0]:=64964700;
IsotopeMasses[34].isotopemasses[1]:=65955200;
IsotopeMasses[34].isotopemasses[2]:=66950090;
IsotopeMasses[34].isotopemasses[3]:=67941800;
IsotopeMasses[34].isotopemasses[4]:=68939560;
IsotopeMasses[34].isotopemasses[5]:=69933390;
IsotopeMasses[34].isotopemasses[6]:=70932240;
IsotopeMasses[34].isotopemasses[7]:=71927112;
IsotopeMasses[34].isotopemasses[8]:=72926765;
IsotopeMasses[34].isotopemasses[9]:=73922476.4;
IsotopeMasses[34].isotopemasses[10]:=74922523.4;
IsotopeMasses[34].isotopemasses[11]:=75919213.6;
IsotopeMasses[34].isotopemasses[12]:=76919914;
IsotopeMasses[34].isotopemasses[13]:=77917309.1;
IsotopeMasses[34].isotopemasses[14]:=78918499.1;
IsotopeMasses[34].isotopemasses[15]:=79916521.3;
IsotopeMasses[34].isotopemasses[16]:=80917992.5;
IsotopeMasses[34].isotopemasses[17]:=81916699.4;
IsotopeMasses[34].isotopemasses[18]:=82919118;
IsotopeMasses[34].isotopemasses[19]:=83918462;
IsotopeMasses[34].isotopemasses[20]:=84922250;
IsotopeMasses[34].isotopemasses[21]:=85924272;
IsotopeMasses[34].isotopemasses[22]:=86928520;
IsotopeMasses[34].isotopemasses[23]:=87931420;
IsotopeMasses[34].isotopemasses[24]:=88936500;
IsotopeMasses[34].isotopemasses[25]:=89940000;
IsotopeMasses[34].isotopemasses[26]:=90946000;
IsotopeMasses[34].isotopemasses[27]:=91949900;
IsotopeMasses[34].isotopemasses[28]:=92956300;
IsotopeMasses[34].isotopemasses[29]:=93960500;
IsotopeMasses[35].firstisotope:=67;
IsotopeMasses[35].isotopescount:=31;
IsotopeMasses[35].isotopemasses[0]:=66964800;
IsotopeMasses[35].isotopemasses[1]:=67958500;
IsotopeMasses[35].isotopemasses[2]:=68950110;
IsotopeMasses[35].isotopemasses[3]:=69944800;
IsotopeMasses[35].isotopemasses[4]:=70938700;
IsotopeMasses[35].isotopemasses[5]:=71936640;
IsotopeMasses[35].isotopemasses[6]:=72931690;
IsotopeMasses[35].isotopemasses[7]:=73929891;
IsotopeMasses[35].isotopemasses[8]:=74925776;
IsotopeMasses[35].isotopemasses[9]:=75924541;
IsotopeMasses[35].isotopemasses[10]:=76921379;
IsotopeMasses[35].isotopemasses[11]:=77921146;
IsotopeMasses[35].isotopemasses[12]:=78918337.1;
IsotopeMasses[35].isotopemasses[13]:=79918529.3;
IsotopeMasses[35].isotopemasses[14]:=80916290.6;
IsotopeMasses[35].isotopemasses[15]:=81916804.1;
IsotopeMasses[35].isotopemasses[16]:=82915180;
IsotopeMasses[35].isotopemasses[17]:=83916479;
IsotopeMasses[35].isotopemasses[18]:=84915608;
IsotopeMasses[35].isotopemasses[19]:=85918798;
IsotopeMasses[35].isotopemasses[20]:=86920711;
IsotopeMasses[35].isotopemasses[21]:=87924070;
IsotopeMasses[35].isotopemasses[22]:=88926390;
IsotopeMasses[35].isotopemasses[23]:=89930630;
IsotopeMasses[35].isotopemasses[24]:=90933970;
IsotopeMasses[35].isotopemasses[25]:=91939260;
IsotopeMasses[35].isotopemasses[26]:=92943100;
IsotopeMasses[35].isotopemasses[27]:=93948700;
IsotopeMasses[35].isotopemasses[28]:=94952900;
IsotopeMasses[35].isotopemasses[29]:=95958500;
IsotopeMasses[35].isotopemasses[30]:=96962800;
IsotopeMasses[36].firstisotope:=69;
IsotopeMasses[36].isotopescount:=32;
IsotopeMasses[36].isotopemasses[0]:=68965200;
IsotopeMasses[36].isotopemasses[1]:=69955300;
IsotopeMasses[36].isotopemasses[2]:=70949600;
IsotopeMasses[36].isotopemasses[3]:=71942092;
IsotopeMasses[36].isotopemasses[4]:=72939289;
IsotopeMasses[36].isotopemasses[5]:=73933084.4;
IsotopeMasses[36].isotopemasses[6]:=74930946;
IsotopeMasses[36].isotopemasses[7]:=75925910;
IsotopeMasses[36].isotopemasses[8]:=76924670;
IsotopeMasses[36].isotopemasses[9]:=77920364.8;
IsotopeMasses[36].isotopemasses[10]:=78920082;
IsotopeMasses[36].isotopemasses[11]:=79916379;
IsotopeMasses[36].isotopemasses[12]:=80916592;
IsotopeMasses[36].isotopemasses[13]:=81913483.6;
IsotopeMasses[36].isotopemasses[14]:=82914136;
IsotopeMasses[36].isotopemasses[15]:=83911507;
IsotopeMasses[36].isotopemasses[16]:=84912527.3;
IsotopeMasses[36].isotopemasses[17]:=85910610.73;
IsotopeMasses[36].isotopemasses[18]:=86913354.9;
IsotopeMasses[36].isotopemasses[19]:=87914447;
IsotopeMasses[36].isotopemasses[20]:=88917630;
IsotopeMasses[36].isotopemasses[21]:=89919517;
IsotopeMasses[36].isotopemasses[22]:=90923450;
IsotopeMasses[36].isotopemasses[23]:=91926156;
IsotopeMasses[36].isotopemasses[24]:=92931270;
IsotopeMasses[36].isotopemasses[25]:=93934400;
IsotopeMasses[36].isotopemasses[26]:=94939800;
IsotopeMasses[36].isotopemasses[27]:=95943100;
IsotopeMasses[36].isotopemasses[28]:=96948600;
IsotopeMasses[36].isotopemasses[29]:=97951900;
IsotopeMasses[36].isotopemasses[30]:=98957600;
IsotopeMasses[36].isotopemasses[31]:=99961100;
IsotopeMasses[37].firstisotope:=71;
IsotopeMasses[37].isotopescount:=32;
IsotopeMasses[37].isotopemasses[0]:=70965300;
IsotopeMasses[37].isotopemasses[1]:=71959100;
IsotopeMasses[37].isotopemasses[2]:=72950560;
IsotopeMasses[37].isotopemasses[3]:=73944265;
IsotopeMasses[37].isotopemasses[4]:=74938570;
IsotopeMasses[37].isotopemasses[5]:=75935072.2;
IsotopeMasses[37].isotopemasses[6]:=76930408;
IsotopeMasses[37].isotopemasses[7]:=77928141;
IsotopeMasses[37].isotopemasses[8]:=78923989;
IsotopeMasses[37].isotopemasses[9]:=79922519;
IsotopeMasses[37].isotopemasses[10]:=80918996;
IsotopeMasses[37].isotopemasses[11]:=81918209;
IsotopeMasses[37].isotopemasses[12]:=82915110;
IsotopeMasses[37].isotopemasses[13]:=83914385;
IsotopeMasses[37].isotopemasses[14]:=84911789.737;
IsotopeMasses[37].isotopemasses[15]:=85911167.42;
IsotopeMasses[37].isotopemasses[16]:=86909180.526;
IsotopeMasses[37].isotopemasses[17]:=87911315.59;
IsotopeMasses[37].isotopemasses[18]:=88912278;
IsotopeMasses[37].isotopemasses[19]:=89914802;
IsotopeMasses[37].isotopemasses[20]:=90916537;
IsotopeMasses[37].isotopemasses[21]:=91919729;
IsotopeMasses[37].isotopemasses[22]:=92922042;
IsotopeMasses[37].isotopemasses[23]:=93926405;
IsotopeMasses[37].isotopemasses[24]:=94929303;
IsotopeMasses[37].isotopemasses[25]:=95934270;
IsotopeMasses[37].isotopemasses[26]:=96937350;
IsotopeMasses[37].isotopemasses[27]:=97941790;
IsotopeMasses[37].isotopemasses[28]:=98945380;
IsotopeMasses[37].isotopemasses[29]:=99949900;
IsotopeMasses[37].isotopemasses[30]:=100953200;
IsotopeMasses[37].isotopemasses[31]:=101958900;
IsotopeMasses[38].firstisotope:=73;
IsotopeMasses[38].isotopescount:=33;
IsotopeMasses[38].isotopemasses[0]:=72966000;
IsotopeMasses[38].isotopemasses[1]:=73956300;
IsotopeMasses[38].isotopemasses[2]:=74949950;
IsotopeMasses[38].isotopemasses[3]:=75941770;
IsotopeMasses[38].isotopemasses[4]:=76937945;
IsotopeMasses[38].isotopemasses[5]:=77932180;
IsotopeMasses[38].isotopemasses[6]:=78929708;
IsotopeMasses[38].isotopemasses[7]:=79924521;
IsotopeMasses[38].isotopemasses[8]:=80923212;
IsotopeMasses[38].isotopemasses[9]:=81918402;
IsotopeMasses[38].isotopemasses[10]:=82917557;
IsotopeMasses[38].isotopemasses[11]:=83913425;
IsotopeMasses[38].isotopemasses[12]:=84912933;
IsotopeMasses[38].isotopemasses[13]:=85909260.2;
IsotopeMasses[38].isotopemasses[14]:=86908877.1;
IsotopeMasses[38].isotopemasses[15]:=87905612.1;
IsotopeMasses[38].isotopemasses[16]:=88907450.7;
IsotopeMasses[38].isotopemasses[17]:=89907738;
IsotopeMasses[38].isotopemasses[18]:=90910203;
IsotopeMasses[38].isotopemasses[19]:=91911038;
IsotopeMasses[38].isotopemasses[20]:=92914026;
IsotopeMasses[38].isotopemasses[21]:=93915361;
IsotopeMasses[38].isotopemasses[22]:=94919359;
IsotopeMasses[38].isotopemasses[23]:=95921700;
IsotopeMasses[38].isotopemasses[24]:=96926153;
IsotopeMasses[38].isotopemasses[25]:=97928450;
IsotopeMasses[38].isotopemasses[26]:=98933240;
IsotopeMasses[38].isotopemasses[27]:=99935350;
IsotopeMasses[38].isotopemasses[28]:=100940520;
IsotopeMasses[38].isotopemasses[29]:=101943020;
IsotopeMasses[38].isotopemasses[30]:=102949000;
IsotopeMasses[38].isotopemasses[31]:=103952300;
IsotopeMasses[38].isotopemasses[32]:=104958600;
IsotopeMasses[39].firstisotope:=76;
IsotopeMasses[39].isotopescount:=33;
IsotopeMasses[39].isotopemasses[0]:=75958500;
IsotopeMasses[39].isotopemasses[1]:=76949650;
IsotopeMasses[39].isotopemasses[2]:=77943600;
IsotopeMasses[39].isotopemasses[3]:=78937400;
IsotopeMasses[39].isotopemasses[4]:=79934280;
IsotopeMasses[39].isotopemasses[5]:=80929130;
IsotopeMasses[39].isotopemasses[6]:=81926790;
IsotopeMasses[39].isotopemasses[7]:=82922350;
IsotopeMasses[39].isotopemasses[8]:=83920390;
IsotopeMasses[39].isotopemasses[9]:=84916433;
IsotopeMasses[39].isotopemasses[10]:=85914886;
IsotopeMasses[39].isotopemasses[11]:=86910875.7;
IsotopeMasses[39].isotopemasses[12]:=87909501.1;
IsotopeMasses[39].isotopemasses[13]:=88905848;
IsotopeMasses[39].isotopemasses[14]:=89907152;
IsotopeMasses[39].isotopemasses[15]:=90907305;
IsotopeMasses[39].isotopemasses[16]:=91908949;
IsotopeMasses[39].isotopemasses[17]:=92909583;
IsotopeMasses[39].isotopemasses[18]:=93911595;
IsotopeMasses[39].isotopemasses[19]:=94912821;
IsotopeMasses[39].isotopemasses[20]:=95915891;
IsotopeMasses[39].isotopemasses[21]:=96918134;
IsotopeMasses[39].isotopemasses[22]:=97922200;
IsotopeMasses[39].isotopemasses[23]:=98924640;
IsotopeMasses[39].isotopemasses[24]:=99927760;
IsotopeMasses[39].isotopemasses[25]:=100930310;
IsotopeMasses[39].isotopemasses[26]:=101933560;
IsotopeMasses[39].isotopemasses[27]:=102936700;
IsotopeMasses[39].isotopemasses[28]:=103941100;
IsotopeMasses[39].isotopemasses[29]:=104944900;
IsotopeMasses[39].isotopemasses[30]:=105949800;
IsotopeMasses[39].isotopemasses[31]:=106954100;
IsotopeMasses[39].isotopemasses[32]:=107959500;
IsotopeMasses[40].firstisotope:=78;
IsotopeMasses[40].isotopescount:=33;
IsotopeMasses[40].isotopemasses[0]:=77955200;
IsotopeMasses[40].isotopemasses[1]:=78949200;
IsotopeMasses[40].isotopemasses[2]:=79940400;
IsotopeMasses[40].isotopemasses[3]:=80937210;
IsotopeMasses[40].isotopemasses[4]:=81931090;
IsotopeMasses[40].isotopemasses[5]:=82928650;
IsotopeMasses[40].isotopemasses[6]:=83923250;
IsotopeMasses[40].isotopemasses[7]:=84921470;
IsotopeMasses[40].isotopemasses[8]:=85916470;
IsotopeMasses[40].isotopemasses[9]:=86914816;
IsotopeMasses[40].isotopemasses[10]:=87910227;
IsotopeMasses[40].isotopemasses[11]:=88908889;
IsotopeMasses[40].isotopemasses[12]:=89904704.4;
IsotopeMasses[40].isotopemasses[13]:=90905645.8;
IsotopeMasses[40].isotopemasses[14]:=91905040.8;
IsotopeMasses[40].isotopemasses[15]:=92906476;
IsotopeMasses[40].isotopemasses[16]:=93906315;
IsotopeMasses[40].isotopemasses[17]:=94908043;
IsotopeMasses[40].isotopemasses[18]:=95908273;
IsotopeMasses[40].isotopemasses[19]:=96910953;
IsotopeMasses[40].isotopemasses[20]:=97912735;
IsotopeMasses[40].isotopemasses[21]:=98916512;
IsotopeMasses[40].isotopemasses[22]:=99917760;
IsotopeMasses[40].isotopemasses[23]:=100921140;
IsotopeMasses[40].isotopemasses[24]:=101922980;
IsotopeMasses[40].isotopemasses[25]:=102926600;
IsotopeMasses[40].isotopemasses[26]:=103928800;
IsotopeMasses[40].isotopemasses[27]:=104933100;
IsotopeMasses[40].isotopemasses[28]:=105935900;
IsotopeMasses[40].isotopemasses[29]:=106940800;
IsotopeMasses[40].isotopemasses[30]:=107944000;
IsotopeMasses[40].isotopemasses[31]:=108949200;
IsotopeMasses[40].isotopemasses[32]:=109952900;
IsotopeMasses[41].firstisotope:=81;
IsotopeMasses[41].isotopescount:=33;
IsotopeMasses[41].isotopemasses[0]:=80949000;
IsotopeMasses[41].isotopemasses[1]:=81943100;
IsotopeMasses[41].isotopemasses[2]:=82936700;
IsotopeMasses[41].isotopemasses[3]:=83933600;
IsotopeMasses[41].isotopemasses[4]:=84927910;
IsotopeMasses[41].isotopemasses[5]:=85925040;
IsotopeMasses[41].isotopemasses[6]:=86920360;
IsotopeMasses[41].isotopemasses[7]:=87918330;
IsotopeMasses[41].isotopemasses[8]:=88913420;
IsotopeMasses[41].isotopemasses[9]:=89911265;
IsotopeMasses[41].isotopemasses[10]:=90906996;
IsotopeMasses[41].isotopemasses[11]:=91907194;
IsotopeMasses[41].isotopemasses[12]:=92906378;
IsotopeMasses[41].isotopemasses[13]:=93907284;
IsotopeMasses[41].isotopemasses[14]:=94906835.8;
IsotopeMasses[41].isotopemasses[15]:=95908101;
IsotopeMasses[41].isotopemasses[16]:=96908099;
IsotopeMasses[41].isotopemasses[17]:=97910328;
IsotopeMasses[41].isotopemasses[18]:=98911618;
IsotopeMasses[41].isotopemasses[19]:=99914180;
IsotopeMasses[41].isotopemasses[20]:=100915252;
IsotopeMasses[41].isotopemasses[21]:=101918040;
IsotopeMasses[41].isotopemasses[22]:=102919140;
IsotopeMasses[41].isotopemasses[23]:=103922460;
IsotopeMasses[41].isotopemasses[24]:=104923940;
IsotopeMasses[41].isotopemasses[25]:=105927970;
IsotopeMasses[41].isotopemasses[26]:=106930300;
IsotopeMasses[41].isotopemasses[27]:=107934800;
IsotopeMasses[41].isotopemasses[28]:=108937600;
IsotopeMasses[41].isotopemasses[29]:=109942400;
IsotopeMasses[41].isotopemasses[30]:=110945700;
IsotopeMasses[41].isotopemasses[31]:=111950800;
IsotopeMasses[41].isotopemasses[32]:=112954700;
IsotopeMasses[42].firstisotope:=83;
IsotopeMasses[42].isotopescount:=33;
IsotopeMasses[42].isotopemasses[0]:=82948700;
IsotopeMasses[42].isotopemasses[1]:=83940100;
IsotopeMasses[42].isotopemasses[2]:=84936600;
IsotopeMasses[42].isotopemasses[3]:=85930700;
IsotopeMasses[42].isotopemasses[4]:=86927330;
IsotopeMasses[42].isotopemasses[5]:=87921953;
IsotopeMasses[42].isotopemasses[6]:=88919480;
IsotopeMasses[42].isotopemasses[7]:=89913937;
IsotopeMasses[42].isotopemasses[8]:=90911750;
IsotopeMasses[42].isotopemasses[9]:=91906811;
IsotopeMasses[42].isotopemasses[10]:=92906813;
IsotopeMasses[42].isotopemasses[11]:=93905088.3;
IsotopeMasses[42].isotopemasses[12]:=94905842.1;
IsotopeMasses[42].isotopemasses[13]:=95904679.5;
IsotopeMasses[42].isotopemasses[14]:=96906021.5;
IsotopeMasses[42].isotopemasses[15]:=97905408.2;
IsotopeMasses[42].isotopemasses[16]:=98907711.9;
IsotopeMasses[42].isotopemasses[17]:=99907477;
IsotopeMasses[42].isotopemasses[18]:=100910347;
IsotopeMasses[42].isotopemasses[19]:=101910297;
IsotopeMasses[42].isotopemasses[20]:=102913210;
IsotopeMasses[42].isotopemasses[21]:=103913760;
IsotopeMasses[42].isotopemasses[22]:=104916970;
IsotopeMasses[42].isotopemasses[23]:=105918137;
IsotopeMasses[42].isotopemasses[24]:=106921690;
IsotopeMasses[42].isotopemasses[25]:=107923450;
IsotopeMasses[42].isotopemasses[26]:=108927800;
IsotopeMasses[42].isotopemasses[27]:=109929700;
IsotopeMasses[42].isotopemasses[28]:=110934400;
IsotopeMasses[42].isotopemasses[29]:=111936800;
IsotopeMasses[42].isotopemasses[30]:=112941900;
IsotopeMasses[42].isotopemasses[31]:=113944900;
IsotopeMasses[42].isotopemasses[32]:=114950300;
IsotopeMasses[43].firstisotope:=85;
IsotopeMasses[43].isotopescount:=34;
IsotopeMasses[43].isotopemasses[0]:=84948800;
IsotopeMasses[43].isotopemasses[1]:=85942900;
IsotopeMasses[43].isotopemasses[2]:=86936500;
IsotopeMasses[43].isotopemasses[3]:=87932680;
IsotopeMasses[43].isotopemasses[4]:=88927170;
IsotopeMasses[43].isotopemasses[5]:=89923600;
IsotopeMasses[43].isotopemasses[6]:=90918430;
IsotopeMasses[43].isotopemasses[7]:=91915260;
IsotopeMasses[43].isotopemasses[8]:=92910249;
IsotopeMasses[43].isotopemasses[9]:=93909657;
IsotopeMasses[43].isotopemasses[10]:=94907657;
IsotopeMasses[43].isotopemasses[11]:=95907871;
IsotopeMasses[43].isotopemasses[12]:=96906365;
IsotopeMasses[43].isotopemasses[13]:=97907216;
IsotopeMasses[43].isotopemasses[14]:=98906254.7;
IsotopeMasses[43].isotopemasses[15]:=99907657.8;
IsotopeMasses[43].isotopemasses[16]:=100907310;
IsotopeMasses[43].isotopemasses[17]:=101909215;
IsotopeMasses[43].isotopemasses[18]:=102909181;
IsotopeMasses[43].isotopemasses[19]:=103911450;
IsotopeMasses[43].isotopemasses[20]:=104911660;
IsotopeMasses[43].isotopemasses[21]:=105914358;
IsotopeMasses[43].isotopemasses[22]:=106915080;
IsotopeMasses[43].isotopemasses[23]:=107918460;
IsotopeMasses[43].isotopemasses[24]:=108919980;
IsotopeMasses[43].isotopemasses[25]:=109923820;
IsotopeMasses[43].isotopemasses[26]:=110925690;
IsotopeMasses[43].isotopemasses[27]:=111929150;
IsotopeMasses[43].isotopemasses[28]:=112931600;
IsotopeMasses[43].isotopemasses[29]:=113935900;
IsotopeMasses[43].isotopemasses[30]:=114938700;
IsotopeMasses[43].isotopemasses[31]:=115943400;
IsotopeMasses[43].isotopemasses[32]:=116946500;
IsotopeMasses[43].isotopemasses[33]:=117951500;
IsotopeMasses[44].firstisotope:=87;
IsotopeMasses[44].isotopescount:=34;
IsotopeMasses[44].isotopemasses[0]:=86949200;
IsotopeMasses[44].isotopemasses[1]:=87940300;
IsotopeMasses[44].isotopemasses[2]:=88936100;
IsotopeMasses[44].isotopemasses[3]:=89929900;
IsotopeMasses[44].isotopemasses[4]:=90926300;
IsotopeMasses[44].isotopemasses[5]:=91920100;
IsotopeMasses[44].isotopemasses[6]:=92917050;
IsotopeMasses[44].isotopemasses[7]:=93911360;
IsotopeMasses[44].isotopemasses[8]:=94910413;
IsotopeMasses[44].isotopemasses[9]:=95907598;
IsotopeMasses[44].isotopemasses[10]:=96907555;
IsotopeMasses[44].isotopemasses[11]:=97905287;
IsotopeMasses[44].isotopemasses[12]:=98905939.3;
IsotopeMasses[44].isotopemasses[13]:=99904219.5;
IsotopeMasses[44].isotopemasses[14]:=100905582.1;
IsotopeMasses[44].isotopemasses[15]:=101904349.3;
IsotopeMasses[44].isotopemasses[16]:=102906323.8;
IsotopeMasses[44].isotopemasses[17]:=103905433;
IsotopeMasses[44].isotopemasses[18]:=104907753;
IsotopeMasses[44].isotopemasses[19]:=105907329;
IsotopeMasses[44].isotopemasses[20]:=106909910;
IsotopeMasses[44].isotopemasses[21]:=107910170;
IsotopeMasses[44].isotopemasses[22]:=108913200;
IsotopeMasses[44].isotopemasses[23]:=109914140;
IsotopeMasses[44].isotopemasses[24]:=110917700;
IsotopeMasses[44].isotopemasses[25]:=111918970;
IsotopeMasses[44].isotopemasses[26]:=112922490;
IsotopeMasses[44].isotopemasses[27]:=113924280;
IsotopeMasses[44].isotopemasses[28]:=114928690;
IsotopeMasses[44].isotopemasses[29]:=115930800;
IsotopeMasses[44].isotopemasses[30]:=116935600;
IsotopeMasses[44].isotopemasses[31]:=117937800;
IsotopeMasses[44].isotopemasses[32]:=118942800;
IsotopeMasses[44].isotopemasses[33]:=119945300;
IsotopeMasses[45].firstisotope:=89;
IsotopeMasses[45].isotopescount:=34;
IsotopeMasses[45].isotopemasses[0]:=88948800;
IsotopeMasses[45].isotopemasses[1]:=89942900;
IsotopeMasses[45].isotopemasses[2]:=90936600;
IsotopeMasses[45].isotopemasses[3]:=91932000;
IsotopeMasses[45].isotopemasses[4]:=92925700;
IsotopeMasses[45].isotopemasses[5]:=93921700;
IsotopeMasses[45].isotopemasses[6]:=94915900;
IsotopeMasses[45].isotopemasses[7]:=95914461;
IsotopeMasses[45].isotopemasses[8]:=96911340;
IsotopeMasses[45].isotopemasses[9]:=97910708;
IsotopeMasses[45].isotopemasses[10]:=98908132;
IsotopeMasses[45].isotopemasses[11]:=99908122;
IsotopeMasses[45].isotopemasses[12]:=100906164;
IsotopeMasses[45].isotopemasses[13]:=101906843;
IsotopeMasses[45].isotopemasses[14]:=102905504;
IsotopeMasses[45].isotopemasses[15]:=103906656;
IsotopeMasses[45].isotopemasses[16]:=104905694;
IsotopeMasses[45].isotopemasses[17]:=105907287;
IsotopeMasses[45].isotopemasses[18]:=106906748;
IsotopeMasses[45].isotopemasses[19]:=107908730;
IsotopeMasses[45].isotopemasses[20]:=108908737;
IsotopeMasses[45].isotopemasses[21]:=109911140;
IsotopeMasses[45].isotopemasses[22]:=110911590;
IsotopeMasses[45].isotopemasses[23]:=111914390;
IsotopeMasses[45].isotopemasses[24]:=112915530;
IsotopeMasses[45].isotopemasses[25]:=113918810;
IsotopeMasses[45].isotopemasses[26]:=114920330;
IsotopeMasses[45].isotopemasses[27]:=115924060;
IsotopeMasses[45].isotopemasses[28]:=116926000;
IsotopeMasses[45].isotopemasses[29]:=117930100;
IsotopeMasses[45].isotopemasses[30]:=118932100;
IsotopeMasses[45].isotopemasses[31]:=119936400;
IsotopeMasses[45].isotopemasses[32]:=120938700;
IsotopeMasses[45].isotopemasses[33]:=121943200;
IsotopeMasses[46].firstisotope:=91;
IsotopeMasses[46].isotopescount:=34;
IsotopeMasses[46].isotopemasses[0]:=90949100;
IsotopeMasses[46].isotopemasses[1]:=91940400;
IsotopeMasses[46].isotopemasses[2]:=92935900;
IsotopeMasses[46].isotopemasses[3]:=93928800;
IsotopeMasses[46].isotopemasses[4]:=94924700;
IsotopeMasses[46].isotopemasses[5]:=95918160;
IsotopeMasses[46].isotopemasses[6]:=96916500;
IsotopeMasses[46].isotopemasses[7]:=97912721;
IsotopeMasses[46].isotopemasses[8]:=98911768;
IsotopeMasses[46].isotopemasses[9]:=99908506;
IsotopeMasses[46].isotopemasses[10]:=100908289;
IsotopeMasses[46].isotopemasses[11]:=101905609;
IsotopeMasses[46].isotopemasses[12]:=102906087;
IsotopeMasses[46].isotopemasses[13]:=103904036;
IsotopeMasses[46].isotopemasses[14]:=104905085;
IsotopeMasses[46].isotopemasses[15]:=105903486;
IsotopeMasses[46].isotopemasses[16]:=106905133;
IsotopeMasses[46].isotopemasses[17]:=107903892;
IsotopeMasses[46].isotopemasses[18]:=108905950;
IsotopeMasses[46].isotopemasses[19]:=109905153;
IsotopeMasses[46].isotopemasses[20]:=110907671;
IsotopeMasses[46].isotopemasses[21]:=111907314;
IsotopeMasses[46].isotopemasses[22]:=112910150;
IsotopeMasses[46].isotopemasses[23]:=113910363;
IsotopeMasses[46].isotopemasses[24]:=114913680;
IsotopeMasses[46].isotopemasses[25]:=115914160;
IsotopeMasses[46].isotopemasses[26]:=116917840;
IsotopeMasses[46].isotopemasses[27]:=117918980;
IsotopeMasses[46].isotopemasses[28]:=118923100;
IsotopeMasses[46].isotopemasses[29]:=119924690;
IsotopeMasses[46].isotopemasses[30]:=120928900;
IsotopeMasses[46].isotopemasses[31]:=121930600;
IsotopeMasses[46].isotopemasses[32]:=122934900;
IsotopeMasses[46].isotopemasses[33]:=123936900;
IsotopeMasses[47].firstisotope:=93;
IsotopeMasses[47].isotopescount:=38;
IsotopeMasses[47].isotopemasses[0]:=92949800;
IsotopeMasses[47].isotopemasses[1]:=93942800;
IsotopeMasses[47].isotopemasses[2]:=94935500;
IsotopeMasses[47].isotopemasses[3]:=95930700;
IsotopeMasses[47].isotopemasses[4]:=96924000;
IsotopeMasses[47].isotopemasses[5]:=97921570;
IsotopeMasses[47].isotopemasses[6]:=98917600;
IsotopeMasses[47].isotopemasses[7]:=99916100;
IsotopeMasses[47].isotopemasses[8]:=100912800;
IsotopeMasses[47].isotopemasses[9]:=101911690;
IsotopeMasses[47].isotopemasses[10]:=102908973;
IsotopeMasses[47].isotopemasses[11]:=103908629;
IsotopeMasses[47].isotopemasses[12]:=104906529;
IsotopeMasses[47].isotopemasses[13]:=105906669;
IsotopeMasses[47].isotopemasses[14]:=106905097;
IsotopeMasses[47].isotopemasses[15]:=107905956;
IsotopeMasses[47].isotopemasses[16]:=108904752;
IsotopeMasses[47].isotopemasses[17]:=109906107;
IsotopeMasses[47].isotopemasses[18]:=110905291;
IsotopeMasses[47].isotopemasses[19]:=111907005;
IsotopeMasses[47].isotopemasses[20]:=112906567;
IsotopeMasses[47].isotopemasses[21]:=113908800;
IsotopeMasses[47].isotopemasses[22]:=114908760;
IsotopeMasses[47].isotopemasses[23]:=115911360;
IsotopeMasses[47].isotopemasses[24]:=116911680;
IsotopeMasses[47].isotopemasses[25]:=117914580;
IsotopeMasses[47].isotopemasses[26]:=118915670;
IsotopeMasses[47].isotopemasses[27]:=119918790;
IsotopeMasses[47].isotopemasses[28]:=120919850;
IsotopeMasses[47].isotopemasses[29]:=121923530;
IsotopeMasses[47].isotopemasses[30]:=122924900;
IsotopeMasses[47].isotopemasses[31]:=123928640;
IsotopeMasses[47].isotopemasses[32]:=124930400;
IsotopeMasses[47].isotopemasses[33]:=125934500;
IsotopeMasses[47].isotopemasses[34]:=126936800;
IsotopeMasses[47].isotopemasses[35]:=127941200;
IsotopeMasses[47].isotopemasses[36]:=128943700;
IsotopeMasses[47].isotopemasses[37]:=129950400;
IsotopeMasses[48].firstisotope:=95;
IsotopeMasses[48].isotopescount:=38;
IsotopeMasses[48].isotopemasses[0]:=94949900;
IsotopeMasses[48].isotopemasses[1]:=95939800;
IsotopeMasses[48].isotopemasses[2]:=96934900;
IsotopeMasses[48].isotopemasses[3]:=97927400;
IsotopeMasses[48].isotopemasses[4]:=98925010;
IsotopeMasses[48].isotopemasses[5]:=99920290;
IsotopeMasses[48].isotopemasses[6]:=100918680;
IsotopeMasses[48].isotopemasses[7]:=101914460;
IsotopeMasses[48].isotopemasses[8]:=102913419;
IsotopeMasses[48].isotopemasses[9]:=103909849;
IsotopeMasses[48].isotopemasses[10]:=104909468;
IsotopeMasses[48].isotopemasses[11]:=105906459;
IsotopeMasses[48].isotopemasses[12]:=106906618;
IsotopeMasses[48].isotopemasses[13]:=107904184;
IsotopeMasses[48].isotopemasses[14]:=108904982;
IsotopeMasses[48].isotopemasses[15]:=109903002;
IsotopeMasses[48].isotopemasses[16]:=110904178;
IsotopeMasses[48].isotopemasses[17]:=111902758;
IsotopeMasses[48].isotopemasses[18]:=112904402;
IsotopeMasses[48].isotopemasses[19]:=113903359;
IsotopeMasses[48].isotopemasses[20]:=114905431;
IsotopeMasses[48].isotopemasses[21]:=115904756;
IsotopeMasses[48].isotopemasses[22]:=116907219;
IsotopeMasses[48].isotopemasses[23]:=117906915;
IsotopeMasses[48].isotopemasses[24]:=118909920;
IsotopeMasses[48].isotopemasses[25]:=119909850;
IsotopeMasses[48].isotopemasses[26]:=120912980;
IsotopeMasses[48].isotopemasses[27]:=121913330;
IsotopeMasses[48].isotopemasses[28]:=122917000;
IsotopeMasses[48].isotopemasses[29]:=123917650;
IsotopeMasses[48].isotopemasses[30]:=124921250;
IsotopeMasses[48].isotopemasses[31]:=125922350;
IsotopeMasses[48].isotopemasses[32]:=126926440;
IsotopeMasses[48].isotopemasses[33]:=127927800;
IsotopeMasses[48].isotopemasses[34]:=128932200;
IsotopeMasses[48].isotopemasses[35]:=129933900;
IsotopeMasses[48].isotopemasses[36]:=130940700;
IsotopeMasses[48].isotopemasses[37]:=131945600;
IsotopeMasses[49].firstisotope:=97;
IsotopeMasses[49].isotopescount:=39;
IsotopeMasses[49].isotopemasses[0]:=96949500;
IsotopeMasses[49].isotopemasses[1]:=97942140;
IsotopeMasses[49].isotopemasses[2]:=98934200;
IsotopeMasses[49].isotopemasses[3]:=99931100;
IsotopeMasses[49].isotopemasses[4]:=100926300;
IsotopeMasses[49].isotopemasses[5]:=101924090;
IsotopeMasses[49].isotopemasses[6]:=102919910;
IsotopeMasses[49].isotopemasses[7]:=103918300;
IsotopeMasses[49].isotopemasses[8]:=104914674;
IsotopeMasses[49].isotopemasses[9]:=105913465;
IsotopeMasses[49].isotopemasses[10]:=106910295;
IsotopeMasses[49].isotopemasses[11]:=107909698;
IsotopeMasses[49].isotopemasses[12]:=108907151;
IsotopeMasses[49].isotopemasses[13]:=109907165;
IsotopeMasses[49].isotopemasses[14]:=110905103;
IsotopeMasses[49].isotopemasses[15]:=111905532;
IsotopeMasses[49].isotopemasses[16]:=112904058;
IsotopeMasses[49].isotopemasses[17]:=113904914;
IsotopeMasses[49].isotopemasses[18]:=114903878;
IsotopeMasses[49].isotopemasses[19]:=115905260;
IsotopeMasses[49].isotopemasses[20]:=116904514;
IsotopeMasses[49].isotopemasses[21]:=117906354;
IsotopeMasses[49].isotopemasses[22]:=118905845;
IsotopeMasses[49].isotopemasses[23]:=119907960;
IsotopeMasses[49].isotopemasses[24]:=120907850;
IsotopeMasses[49].isotopemasses[25]:=121910280;
IsotopeMasses[49].isotopemasses[26]:=122910440;
IsotopeMasses[49].isotopemasses[27]:=123913180;
IsotopeMasses[49].isotopemasses[28]:=124913600;
IsotopeMasses[49].isotopemasses[29]:=125916460;
IsotopeMasses[49].isotopemasses[30]:=126917350;
IsotopeMasses[49].isotopemasses[31]:=127920170;
IsotopeMasses[49].isotopemasses[32]:=128921700;
IsotopeMasses[49].isotopemasses[33]:=129924970;
IsotopeMasses[49].isotopemasses[34]:=130926850;
IsotopeMasses[49].isotopemasses[35]:=131932990;
IsotopeMasses[49].isotopemasses[36]:=132937800;
IsotopeMasses[49].isotopemasses[37]:=133944200;
IsotopeMasses[49].isotopemasses[38]:=134949300;
IsotopeMasses[50].firstisotope:=99;
IsotopeMasses[50].isotopescount:=39;
IsotopeMasses[50].isotopemasses[0]:=98949300;
IsotopeMasses[50].isotopemasses[1]:=99939000;
IsotopeMasses[50].isotopemasses[2]:=100936100;
IsotopeMasses[50].isotopemasses[3]:=101930300;
IsotopeMasses[50].isotopemasses[4]:=102928100;
IsotopeMasses[50].isotopemasses[5]:=103923140;
IsotopeMasses[50].isotopemasses[6]:=104921350;
IsotopeMasses[50].isotopemasses[7]:=105916880;
IsotopeMasses[50].isotopemasses[8]:=106915640;
IsotopeMasses[50].isotopemasses[9]:=107911925;
IsotopeMasses[50].isotopemasses[10]:=108911283;
IsotopeMasses[50].isotopemasses[11]:=109907843;
IsotopeMasses[50].isotopemasses[12]:=110907734;
IsotopeMasses[50].isotopemasses[13]:=111904818;
IsotopeMasses[50].isotopemasses[14]:=112905171;
IsotopeMasses[50].isotopemasses[15]:=113902779;
IsotopeMasses[50].isotopemasses[16]:=114903342;
IsotopeMasses[50].isotopemasses[17]:=115901741;
IsotopeMasses[50].isotopemasses[18]:=116902952;
IsotopeMasses[50].isotopemasses[19]:=117901603;
IsotopeMasses[50].isotopemasses[20]:=118903308;
IsotopeMasses[50].isotopemasses[21]:=119902195;
IsotopeMasses[50].isotopemasses[22]:=120904235;
IsotopeMasses[50].isotopemasses[23]:=121903439;
IsotopeMasses[50].isotopemasses[24]:=122905721;
IsotopeMasses[50].isotopemasses[25]:=123905273.9;
IsotopeMasses[50].isotopemasses[26]:=124907784.1;
IsotopeMasses[50].isotopemasses[27]:=125907653;
IsotopeMasses[50].isotopemasses[28]:=126910360;
IsotopeMasses[50].isotopemasses[29]:=127910540;
IsotopeMasses[50].isotopemasses[30]:=128913480;
IsotopeMasses[50].isotopemasses[31]:=129913967;
IsotopeMasses[50].isotopemasses[32]:=130917000;
IsotopeMasses[50].isotopemasses[33]:=131917816;
IsotopeMasses[50].isotopemasses[34]:=132923830;
IsotopeMasses[50].isotopemasses[35]:=133928290;
IsotopeMasses[50].isotopemasses[36]:=134934700;
IsotopeMasses[50].isotopemasses[37]:=135939300;
IsotopeMasses[50].isotopemasses[38]:=136946000;
IsotopeMasses[51].firstisotope:=103;
IsotopeMasses[51].isotopescount:=37;
IsotopeMasses[51].isotopemasses[0]:=102939700;
IsotopeMasses[51].isotopemasses[1]:=103936500;
IsotopeMasses[51].isotopemasses[2]:=104931490;
IsotopeMasses[51].isotopemasses[3]:=105928800;
IsotopeMasses[51].isotopemasses[4]:=106924200;
IsotopeMasses[51].isotopemasses[5]:=107922160;
IsotopeMasses[51].isotopemasses[6]:=108918132;
IsotopeMasses[51].isotopemasses[7]:=109916750;
IsotopeMasses[51].isotopemasses[8]:=110913160;
IsotopeMasses[51].isotopemasses[9]:=111912398;
IsotopeMasses[51].isotopemasses[10]:=112909372;
IsotopeMasses[51].isotopemasses[11]:=113909270;
IsotopeMasses[51].isotopemasses[12]:=114906598;
IsotopeMasses[51].isotopemasses[13]:=115906794;
IsotopeMasses[51].isotopemasses[14]:=116904836;
IsotopeMasses[51].isotopemasses[15]:=117905529;
IsotopeMasses[51].isotopemasses[16]:=118903942;
IsotopeMasses[51].isotopemasses[17]:=119905072;
IsotopeMasses[51].isotopemasses[18]:=120903815.7;
IsotopeMasses[51].isotopemasses[19]:=121905173.7;
IsotopeMasses[51].isotopemasses[20]:=122904214;
IsotopeMasses[51].isotopemasses[21]:=123905935.7;
IsotopeMasses[51].isotopemasses[22]:=124905254;
IsotopeMasses[51].isotopemasses[23]:=125907250;
IsotopeMasses[51].isotopemasses[24]:=126906924;
IsotopeMasses[51].isotopemasses[25]:=127909170;
IsotopeMasses[51].isotopemasses[26]:=128909148;
IsotopeMasses[51].isotopemasses[27]:=129911656;
IsotopeMasses[51].isotopemasses[28]:=130911982;
IsotopeMasses[51].isotopemasses[29]:=131914467;
IsotopeMasses[51].isotopemasses[30]:=132915250;
IsotopeMasses[51].isotopemasses[31]:=133920380;
IsotopeMasses[51].isotopemasses[32]:=134925170;
IsotopeMasses[51].isotopemasses[33]:=135930400;
IsotopeMasses[51].isotopemasses[34]:=136935300;
IsotopeMasses[51].isotopemasses[35]:=137940800;
IsotopeMasses[51].isotopemasses[36]:=138946000;
IsotopeMasses[52].firstisotope:=105;
IsotopeMasses[52].isotopescount:=38;
IsotopeMasses[52].isotopemasses[0]:=104943600;
IsotopeMasses[52].isotopemasses[1]:=105937500;
IsotopeMasses[52].isotopemasses[2]:=106935000;
IsotopeMasses[52].isotopemasses[3]:=107929440;
IsotopeMasses[52].isotopemasses[4]:=108927420;
IsotopeMasses[52].isotopemasses[5]:=109922410;
IsotopeMasses[52].isotopemasses[6]:=110921110;
IsotopeMasses[52].isotopemasses[7]:=111917010;
IsotopeMasses[52].isotopemasses[8]:=112915890;
IsotopeMasses[52].isotopemasses[9]:=113912090;
IsotopeMasses[52].isotopemasses[10]:=114911900;
IsotopeMasses[52].isotopemasses[11]:=115908460;
IsotopeMasses[52].isotopemasses[12]:=116908645;
IsotopeMasses[52].isotopemasses[13]:=117905828;
IsotopeMasses[52].isotopemasses[14]:=118906404;
IsotopeMasses[52].isotopemasses[15]:=119904020;
IsotopeMasses[52].isotopemasses[16]:=120904940;
IsotopeMasses[52].isotopemasses[17]:=121903043.9;
IsotopeMasses[52].isotopemasses[18]:=122904270;
IsotopeMasses[52].isotopemasses[19]:=123902817.9;
IsotopeMasses[52].isotopemasses[20]:=124904430.7;
IsotopeMasses[52].isotopemasses[21]:=125903311.7;
IsotopeMasses[52].isotopemasses[22]:=126905226.3;
IsotopeMasses[52].isotopemasses[23]:=127904463.1;
IsotopeMasses[52].isotopemasses[24]:=128906598.2;
IsotopeMasses[52].isotopemasses[25]:=129906224.4;
IsotopeMasses[52].isotopemasses[26]:=130908523.9;
IsotopeMasses[52].isotopemasses[27]:=131908553;
IsotopeMasses[52].isotopemasses[28]:=132910960;
IsotopeMasses[52].isotopemasses[29]:=133911369;
IsotopeMasses[52].isotopemasses[30]:=134916450;
IsotopeMasses[52].isotopemasses[31]:=135920100;
IsotopeMasses[52].isotopemasses[32]:=136925320;
IsotopeMasses[52].isotopemasses[33]:=137929220;
IsotopeMasses[52].isotopemasses[34]:=138934700;
IsotopeMasses[52].isotopemasses[35]:=139938900;
IsotopeMasses[52].isotopemasses[36]:=140944700;
IsotopeMasses[52].isotopemasses[37]:=141949100;
IsotopeMasses[53].firstisotope:=108;
IsotopeMasses[53].isotopescount:=37;
IsotopeMasses[53].isotopemasses[0]:=107943500;
IsotopeMasses[53].isotopemasses[1]:=108938150;
IsotopeMasses[53].isotopemasses[2]:=109935200;
IsotopeMasses[53].isotopemasses[3]:=110930300;
IsotopeMasses[53].isotopemasses[4]:=111927970;
IsotopeMasses[53].isotopemasses[5]:=112923640;
IsotopeMasses[53].isotopemasses[6]:=113921900;
IsotopeMasses[53].isotopemasses[7]:=114918050;
IsotopeMasses[53].isotopemasses[8]:=115916810;
IsotopeMasses[53].isotopemasses[9]:=116913650;
IsotopeMasses[53].isotopemasses[10]:=117913074;
IsotopeMasses[53].isotopemasses[11]:=118910070;
IsotopeMasses[53].isotopemasses[12]:=119910048;
IsotopeMasses[53].isotopemasses[13]:=120907367;
IsotopeMasses[53].isotopemasses[14]:=121907589;
IsotopeMasses[53].isotopemasses[15]:=122905589;
IsotopeMasses[53].isotopemasses[16]:=123906209.9;
IsotopeMasses[53].isotopemasses[17]:=124904630.2;
IsotopeMasses[53].isotopemasses[18]:=125905624;
IsotopeMasses[53].isotopemasses[19]:=126904473;
IsotopeMasses[53].isotopemasses[20]:=127905809;
IsotopeMasses[53].isotopemasses[21]:=128904988;
IsotopeMasses[53].isotopemasses[22]:=129906674;
IsotopeMasses[53].isotopemasses[23]:=130906124.6;
IsotopeMasses[53].isotopemasses[24]:=131907997;
IsotopeMasses[53].isotopemasses[25]:=132907797;
IsotopeMasses[53].isotopemasses[26]:=133909744;
IsotopeMasses[53].isotopemasses[27]:=134910048;
IsotopeMasses[53].isotopemasses[28]:=135914650;
IsotopeMasses[53].isotopemasses[29]:=136917870;
IsotopeMasses[53].isotopemasses[30]:=137922350;
IsotopeMasses[53].isotopemasses[31]:=138926100;
IsotopeMasses[53].isotopemasses[32]:=139931000;
IsotopeMasses[53].isotopemasses[33]:=140935030;
IsotopeMasses[53].isotopemasses[34]:=141940200;
IsotopeMasses[53].isotopemasses[35]:=142944600;
IsotopeMasses[53].isotopemasses[36]:=143950000;
IsotopeMasses[54].firstisotope:=110;
IsotopeMasses[54].isotopescount:=38;
IsotopeMasses[54].isotopemasses[0]:=109944280;
IsotopeMasses[54].isotopemasses[1]:=110941600;
IsotopeMasses[54].isotopemasses[2]:=111935620;
IsotopeMasses[54].isotopemasses[3]:=112933340;
IsotopeMasses[54].isotopemasses[4]:=113927980;
IsotopeMasses[54].isotopemasses[5]:=114926294;
IsotopeMasses[54].isotopemasses[6]:=115921581;
IsotopeMasses[54].isotopemasses[7]:=116920359;
IsotopeMasses[54].isotopemasses[8]:=117916179;
IsotopeMasses[54].isotopemasses[9]:=118915411;
IsotopeMasses[54].isotopemasses[10]:=119911784;
IsotopeMasses[54].isotopemasses[11]:=120911462;
IsotopeMasses[54].isotopemasses[12]:=121908368;
IsotopeMasses[54].isotopemasses[13]:=122908482;
IsotopeMasses[54].isotopemasses[14]:=123905893;
IsotopeMasses[54].isotopemasses[15]:=124906395.5;
IsotopeMasses[54].isotopemasses[16]:=125904274;
IsotopeMasses[54].isotopemasses[17]:=126905184;
IsotopeMasses[54].isotopemasses[18]:=127903531.3;
IsotopeMasses[54].isotopemasses[19]:=128904779.4;
IsotopeMasses[54].isotopemasses[20]:=129903508;
IsotopeMasses[54].isotopemasses[21]:=130905082.4;
IsotopeMasses[54].isotopemasses[22]:=131904153.5;
IsotopeMasses[54].isotopemasses[23]:=132905911;
IsotopeMasses[54].isotopemasses[24]:=133905394.5;
IsotopeMasses[54].isotopemasses[25]:=134907227;
IsotopeMasses[54].isotopemasses[26]:=135907219;
IsotopeMasses[54].isotopemasses[27]:=136911562;
IsotopeMasses[54].isotopemasses[28]:=137913950;
IsotopeMasses[54].isotopemasses[29]:=138918793;
IsotopeMasses[54].isotopemasses[30]:=139921640;
IsotopeMasses[54].isotopemasses[31]:=140926650;
IsotopeMasses[54].isotopemasses[32]:=141929710;
IsotopeMasses[54].isotopemasses[33]:=142935110;
IsotopeMasses[54].isotopemasses[34]:=143938500;
IsotopeMasses[54].isotopemasses[35]:=144944100;
IsotopeMasses[54].isotopemasses[36]:=145947800;
IsotopeMasses[54].isotopemasses[37]:=146953600;
IsotopeMasses[55].firstisotope:=112;
IsotopeMasses[55].isotopescount:=40;
IsotopeMasses[55].isotopemasses[0]:=111950300;
IsotopeMasses[55].isotopemasses[1]:=112944490;
IsotopeMasses[55].isotopemasses[2]:=113941500;
IsotopeMasses[55].isotopemasses[3]:=114935900;
IsotopeMasses[55].isotopemasses[4]:=115933370;
IsotopeMasses[55].isotopemasses[5]:=116928670;
IsotopeMasses[55].isotopemasses[6]:=117926559;
IsotopeMasses[55].isotopemasses[7]:=118922377;
IsotopeMasses[55].isotopemasses[8]:=119920677;
IsotopeMasses[55].isotopemasses[9]:=120917229;
IsotopeMasses[55].isotopemasses[10]:=121916110;
IsotopeMasses[55].isotopemasses[11]:=122912996;
IsotopeMasses[55].isotopemasses[12]:=123912258;
IsotopeMasses[55].isotopemasses[13]:=124909728;
IsotopeMasses[55].isotopemasses[14]:=125909452;
IsotopeMasses[55].isotopemasses[15]:=126907418;
IsotopeMasses[55].isotopemasses[16]:=127907749;
IsotopeMasses[55].isotopemasses[17]:=128906064;
IsotopeMasses[55].isotopemasses[18]:=129906709;
IsotopeMasses[55].isotopemasses[19]:=130905464;
IsotopeMasses[55].isotopemasses[20]:=131906434.3;
IsotopeMasses[55].isotopemasses[21]:=132905451.932;
IsotopeMasses[55].isotopemasses[22]:=133906718.48;
IsotopeMasses[55].isotopemasses[23]:=134905977;
IsotopeMasses[55].isotopemasses[24]:=135907311.6;
IsotopeMasses[55].isotopemasses[25]:=136907089.5;
IsotopeMasses[55].isotopemasses[26]:=137911017;
IsotopeMasses[55].isotopemasses[27]:=138913364;
IsotopeMasses[55].isotopemasses[28]:=139917282;
IsotopeMasses[55].isotopemasses[29]:=140920046;
IsotopeMasses[55].isotopemasses[30]:=141924299;
IsotopeMasses[55].isotopemasses[31]:=142927352;
IsotopeMasses[55].isotopemasses[32]:=143932080;
IsotopeMasses[55].isotopemasses[33]:=144935526;
IsotopeMasses[55].isotopemasses[34]:=145940290;
IsotopeMasses[55].isotopemasses[35]:=146944160;
IsotopeMasses[55].isotopemasses[36]:=147949200;
IsotopeMasses[55].isotopemasses[37]:=148952930;
IsotopeMasses[55].isotopemasses[38]:=149958200;
IsotopeMasses[55].isotopemasses[39]:=150962200;
IsotopeMasses[56].firstisotope:=114;
IsotopeMasses[56].isotopescount:=40;
IsotopeMasses[56].isotopemasses[0]:=113950680;
IsotopeMasses[56].isotopemasses[1]:=114947400;
IsotopeMasses[56].isotopemasses[2]:=115941400;
IsotopeMasses[56].isotopemasses[3]:=116938500;
IsotopeMasses[56].isotopemasses[4]:=117933040;
IsotopeMasses[56].isotopemasses[5]:=118930660;
IsotopeMasses[56].isotopemasses[6]:=119926000;
IsotopeMasses[56].isotopemasses[7]:=120924050;
IsotopeMasses[56].isotopemasses[8]:=121919900;
IsotopeMasses[56].isotopemasses[9]:=122918781;
IsotopeMasses[56].isotopemasses[10]:=123915094;
IsotopeMasses[56].isotopemasses[11]:=124914473;
IsotopeMasses[56].isotopemasses[12]:=125911250;
IsotopeMasses[56].isotopemasses[13]:=126911094;
IsotopeMasses[56].isotopemasses[14]:=127908318;
IsotopeMasses[56].isotopemasses[15]:=128908679;
IsotopeMasses[56].isotopemasses[16]:=129906321;
IsotopeMasses[56].isotopemasses[17]:=130906941;
IsotopeMasses[56].isotopemasses[18]:=131905061.3;
IsotopeMasses[56].isotopemasses[19]:=132906007.5;
IsotopeMasses[56].isotopemasses[20]:=133904508.4;
IsotopeMasses[56].isotopemasses[21]:=134905688.6;
IsotopeMasses[56].isotopemasses[22]:=135904575.9;
IsotopeMasses[56].isotopemasses[23]:=136905827.4;
IsotopeMasses[56].isotopemasses[24]:=137905247.2;
IsotopeMasses[56].isotopemasses[25]:=138908841.3;
IsotopeMasses[56].isotopemasses[26]:=139910605;
IsotopeMasses[56].isotopemasses[27]:=140914411;
IsotopeMasses[56].isotopemasses[28]:=141916453;
IsotopeMasses[56].isotopemasses[29]:=142920627;
IsotopeMasses[56].isotopemasses[30]:=143922953;
IsotopeMasses[56].isotopemasses[31]:=144927630;
IsotopeMasses[56].isotopemasses[32]:=145930220;
IsotopeMasses[56].isotopemasses[33]:=146934950;
IsotopeMasses[56].isotopemasses[34]:=147937720;
IsotopeMasses[56].isotopemasses[35]:=148942580;
IsotopeMasses[56].isotopemasses[36]:=149945700;
IsotopeMasses[56].isotopemasses[37]:=150950800;
IsotopeMasses[56].isotopemasses[38]:=151954300;
IsotopeMasses[56].isotopemasses[39]:=152959600;
IsotopeMasses[57].firstisotope:=117;
IsotopeMasses[57].isotopescount:=39;
IsotopeMasses[57].isotopemasses[0]:=116950100;
IsotopeMasses[57].isotopemasses[1]:=117946700;
IsotopeMasses[57].isotopemasses[2]:=118941000;
IsotopeMasses[57].isotopemasses[3]:=119938100;
IsotopeMasses[57].isotopemasses[4]:=120933000;
IsotopeMasses[57].isotopemasses[5]:=121930700;
IsotopeMasses[57].isotopemasses[6]:=122926240;
IsotopeMasses[57].isotopemasses[7]:=123924570;
IsotopeMasses[57].isotopemasses[8]:=124920820;
IsotopeMasses[57].isotopemasses[9]:=125919510;
IsotopeMasses[57].isotopemasses[10]:=126916380;
IsotopeMasses[57].isotopemasses[11]:=127915590;
IsotopeMasses[57].isotopemasses[12]:=128912693;
IsotopeMasses[57].isotopemasses[13]:=129912370;
IsotopeMasses[57].isotopemasses[14]:=130910070;
IsotopeMasses[57].isotopemasses[15]:=131910100;
IsotopeMasses[57].isotopemasses[16]:=132908220;
IsotopeMasses[57].isotopemasses[17]:=133908514;
IsotopeMasses[57].isotopemasses[18]:=134906977;
IsotopeMasses[57].isotopemasses[19]:=135907640;
IsotopeMasses[57].isotopemasses[20]:=136906494;
IsotopeMasses[57].isotopemasses[21]:=137907112;
IsotopeMasses[57].isotopemasses[22]:=138906353;
IsotopeMasses[57].isotopemasses[23]:=139909478;
IsotopeMasses[57].isotopemasses[24]:=140910962;
IsotopeMasses[57].isotopemasses[25]:=141914079;
IsotopeMasses[57].isotopemasses[26]:=142916063;
IsotopeMasses[57].isotopemasses[27]:=143919600;
IsotopeMasses[57].isotopemasses[28]:=144921650;
IsotopeMasses[57].isotopemasses[29]:=145925790;
IsotopeMasses[57].isotopemasses[30]:=146928240;
IsotopeMasses[57].isotopemasses[31]:=147932230;
IsotopeMasses[57].isotopemasses[32]:=148934700;
IsotopeMasses[57].isotopemasses[33]:=149938800;
IsotopeMasses[57].isotopemasses[34]:=150941700;
IsotopeMasses[57].isotopemasses[35]:=151946300;
IsotopeMasses[57].isotopemasses[36]:=152949600;
IsotopeMasses[57].isotopemasses[37]:=153954500;
IsotopeMasses[57].isotopemasses[38]:=154958400;
IsotopeMasses[58].firstisotope:=119;
IsotopeMasses[58].isotopescount:=39;
IsotopeMasses[58].isotopemasses[0]:=118952800;
IsotopeMasses[58].isotopemasses[1]:=119946600;
IsotopeMasses[58].isotopemasses[2]:=120943400;
IsotopeMasses[58].isotopemasses[3]:=121937900;
IsotopeMasses[58].isotopemasses[4]:=122935400;
IsotopeMasses[58].isotopemasses[5]:=123930400;
IsotopeMasses[58].isotopemasses[6]:=124928440;
IsotopeMasses[58].isotopemasses[7]:=125923970;
IsotopeMasses[58].isotopemasses[8]:=126922730;
IsotopeMasses[58].isotopemasses[9]:=127918910;
IsotopeMasses[58].isotopemasses[10]:=128918100;
IsotopeMasses[58].isotopemasses[11]:=129914740;
IsotopeMasses[58].isotopemasses[12]:=130914420;
IsotopeMasses[58].isotopemasses[13]:=131911460;
IsotopeMasses[58].isotopemasses[14]:=132911515;
IsotopeMasses[58].isotopemasses[15]:=133908925;
IsotopeMasses[58].isotopemasses[16]:=134909151;
IsotopeMasses[58].isotopemasses[17]:=135907172;
IsotopeMasses[58].isotopemasses[18]:=136907806;
IsotopeMasses[58].isotopemasses[19]:=137905991;
IsotopeMasses[58].isotopemasses[20]:=138906653;
IsotopeMasses[58].isotopemasses[21]:=139905439;
IsotopeMasses[58].isotopemasses[22]:=140908276;
IsotopeMasses[58].isotopemasses[23]:=141909244;
IsotopeMasses[58].isotopemasses[24]:=142912386;
IsotopeMasses[58].isotopemasses[25]:=143913647;
IsotopeMasses[58].isotopemasses[26]:=144917230;
IsotopeMasses[58].isotopemasses[27]:=145918760;
IsotopeMasses[58].isotopemasses[28]:=146922670;
IsotopeMasses[58].isotopemasses[29]:=147924430;
IsotopeMasses[58].isotopemasses[30]:=148928400;
IsotopeMasses[58].isotopemasses[31]:=149930410;
IsotopeMasses[58].isotopemasses[32]:=150933980;
IsotopeMasses[58].isotopemasses[33]:=151936540;
IsotopeMasses[58].isotopemasses[34]:=152940600;
IsotopeMasses[58].isotopemasses[35]:=153943400;
IsotopeMasses[58].isotopemasses[36]:=154948000;
IsotopeMasses[58].isotopemasses[37]:=155951300;
IsotopeMasses[58].isotopemasses[38]:=156956300;
IsotopeMasses[59].firstisotope:=121;
IsotopeMasses[59].isotopescount:=39;
IsotopeMasses[59].isotopemasses[0]:=120955400;
IsotopeMasses[59].isotopemasses[1]:=121951800;
IsotopeMasses[59].isotopemasses[2]:=122946000;
IsotopeMasses[59].isotopemasses[3]:=123943000;
IsotopeMasses[59].isotopemasses[4]:=124937800;
IsotopeMasses[59].isotopemasses[5]:=125935310;
IsotopeMasses[59].isotopemasses[6]:=126930830;
IsotopeMasses[59].isotopemasses[7]:=127928790;
IsotopeMasses[59].isotopemasses[8]:=128925100;
IsotopeMasses[59].isotopemasses[9]:=129923590;
IsotopeMasses[59].isotopemasses[10]:=130920260;
IsotopeMasses[59].isotopemasses[11]:=131919260;
IsotopeMasses[59].isotopemasses[12]:=132916331;
IsotopeMasses[59].isotopemasses[13]:=133915710;
IsotopeMasses[59].isotopemasses[14]:=134913112;
IsotopeMasses[59].isotopemasses[15]:=135912692;
IsotopeMasses[59].isotopemasses[16]:=136910705;
IsotopeMasses[59].isotopemasses[17]:=137910755;
IsotopeMasses[59].isotopemasses[18]:=138908938;
IsotopeMasses[59].isotopemasses[19]:=139909076;
IsotopeMasses[59].isotopemasses[20]:=140907653;
IsotopeMasses[59].isotopemasses[21]:=141910045;
IsotopeMasses[59].isotopemasses[22]:=142910817;
IsotopeMasses[59].isotopemasses[23]:=143913305;
IsotopeMasses[59].isotopemasses[24]:=144914512;
IsotopeMasses[59].isotopemasses[25]:=145917640;
IsotopeMasses[59].isotopemasses[26]:=146918996;
IsotopeMasses[59].isotopemasses[27]:=147922140;
IsotopeMasses[59].isotopemasses[28]:=148923720;
IsotopeMasses[59].isotopemasses[29]:=149926670;
IsotopeMasses[59].isotopemasses[30]:=150928319;
IsotopeMasses[59].isotopemasses[31]:=151931500;
IsotopeMasses[59].isotopemasses[32]:=152933840;
IsotopeMasses[59].isotopemasses[33]:=153937520;
IsotopeMasses[59].isotopemasses[34]:=154940100;
IsotopeMasses[59].isotopemasses[35]:=155944300;
IsotopeMasses[59].isotopemasses[36]:=156947400;
IsotopeMasses[59].isotopemasses[37]:=157952000;
IsotopeMasses[59].isotopemasses[38]:=158955500;
IsotopeMasses[60].firstisotope:=124;
IsotopeMasses[60].isotopescount:=38;
IsotopeMasses[60].isotopemasses[0]:=123952200;
IsotopeMasses[60].isotopemasses[1]:=124948900;
IsotopeMasses[60].isotopemasses[2]:=125943200;
IsotopeMasses[60].isotopemasses[3]:=126940500;
IsotopeMasses[60].isotopemasses[4]:=127935390;
IsotopeMasses[60].isotopemasses[5]:=128933190;
IsotopeMasses[60].isotopemasses[6]:=129928510;
IsotopeMasses[60].isotopemasses[7]:=130927250;
IsotopeMasses[60].isotopemasses[8]:=131923320;
IsotopeMasses[60].isotopemasses[9]:=132922350;
IsotopeMasses[60].isotopemasses[10]:=133918790;
IsotopeMasses[60].isotopemasses[11]:=134918181;
IsotopeMasses[60].isotopemasses[12]:=135914976;
IsotopeMasses[60].isotopemasses[13]:=136914567;
IsotopeMasses[60].isotopemasses[14]:=137911950;
IsotopeMasses[60].isotopemasses[15]:=138911980;
IsotopeMasses[60].isotopemasses[16]:=139909550;
IsotopeMasses[60].isotopemasses[17]:=140909610;
IsotopeMasses[60].isotopemasses[18]:=141907723.3;
IsotopeMasses[60].isotopemasses[19]:=142909814.3;
IsotopeMasses[60].isotopemasses[20]:=143910087.3;
IsotopeMasses[60].isotopemasses[21]:=144912573.6;
IsotopeMasses[60].isotopemasses[22]:=145913116.9;
IsotopeMasses[60].isotopemasses[23]:=146916100.4;
IsotopeMasses[60].isotopemasses[24]:=147916893;
IsotopeMasses[60].isotopemasses[25]:=148920149;
IsotopeMasses[60].isotopemasses[26]:=149920891;
IsotopeMasses[60].isotopemasses[27]:=150923829;
IsotopeMasses[60].isotopemasses[28]:=151924680;
IsotopeMasses[60].isotopemasses[29]:=152927700;
IsotopeMasses[60].isotopemasses[30]:=153929480;
IsotopeMasses[60].isotopemasses[31]:=154932930;
IsotopeMasses[60].isotopemasses[32]:=155935020;
IsotopeMasses[60].isotopemasses[33]:=156939030;
IsotopeMasses[60].isotopemasses[34]:=157941600;
IsotopeMasses[60].isotopemasses[35]:=158946100;
IsotopeMasses[60].isotopemasses[36]:=159949100;
IsotopeMasses[60].isotopemasses[37]:=160953900;
IsotopeMasses[61].firstisotope:=126;
IsotopeMasses[61].isotopescount:=38;
IsotopeMasses[61].isotopemasses[0]:=125957500;
IsotopeMasses[61].isotopemasses[1]:=126951600;
IsotopeMasses[61].isotopemasses[2]:=127948400;
IsotopeMasses[61].isotopemasses[3]:=128943200;
IsotopeMasses[61].isotopemasses[4]:=129940500;
IsotopeMasses[61].isotopemasses[5]:=130935870;
IsotopeMasses[61].isotopemasses[6]:=131933750;
IsotopeMasses[61].isotopemasses[7]:=132929780;
IsotopeMasses[61].isotopemasses[8]:=133928350;
IsotopeMasses[61].isotopemasses[9]:=134924880;
IsotopeMasses[61].isotopemasses[10]:=135923570;
IsotopeMasses[61].isotopemasses[11]:=136920479;
IsotopeMasses[61].isotopemasses[12]:=137919550;
IsotopeMasses[61].isotopemasses[13]:=138916804;
IsotopeMasses[61].isotopemasses[14]:=139916040;
IsotopeMasses[61].isotopemasses[15]:=140913555;
IsotopeMasses[61].isotopemasses[16]:=141912870;
IsotopeMasses[61].isotopemasses[17]:=142910933;
IsotopeMasses[61].isotopemasses[18]:=143912591;
IsotopeMasses[61].isotopemasses[19]:=144912749;
IsotopeMasses[61].isotopemasses[20]:=145914696;
IsotopeMasses[61].isotopemasses[21]:=146915139;
IsotopeMasses[61].isotopemasses[22]:=147917475;
IsotopeMasses[61].isotopemasses[23]:=148918334;
IsotopeMasses[61].isotopemasses[24]:=149920984;
IsotopeMasses[61].isotopemasses[25]:=150921207;
IsotopeMasses[61].isotopemasses[26]:=151923500;
IsotopeMasses[61].isotopemasses[27]:=152924117;
IsotopeMasses[61].isotopemasses[28]:=153926460;
IsotopeMasses[61].isotopemasses[29]:=154928100;
IsotopeMasses[61].isotopemasses[30]:=155931060;
IsotopeMasses[61].isotopemasses[31]:=156933040;
IsotopeMasses[61].isotopemasses[32]:=157936560;
IsotopeMasses[61].isotopemasses[33]:=158938970;
IsotopeMasses[61].isotopemasses[34]:=159943000;
IsotopeMasses[61].isotopemasses[35]:=160945900;
IsotopeMasses[61].isotopemasses[36]:=161950300;
IsotopeMasses[61].isotopemasses[37]:=162953700;
IsotopeMasses[62].firstisotope:=128;
IsotopeMasses[62].isotopescount:=38;
IsotopeMasses[62].isotopemasses[0]:=127958100;
IsotopeMasses[62].isotopemasses[1]:=128954600;
IsotopeMasses[62].isotopemasses[2]:=129948900;
IsotopeMasses[62].isotopemasses[3]:=130946100;
IsotopeMasses[62].isotopemasses[4]:=131940700;
IsotopeMasses[62].isotopemasses[5]:=132938670;
IsotopeMasses[62].isotopemasses[6]:=133933970;
IsotopeMasses[62].isotopemasses[7]:=134932520;
IsotopeMasses[62].isotopemasses[8]:=135928276;
IsotopeMasses[62].isotopemasses[9]:=136926970;
IsotopeMasses[62].isotopemasses[10]:=137923244;
IsotopeMasses[62].isotopemasses[11]:=138922297;
IsotopeMasses[62].isotopemasses[12]:=139918995;
IsotopeMasses[62].isotopemasses[13]:=140918476;
IsotopeMasses[62].isotopemasses[14]:=141915198;
IsotopeMasses[62].isotopemasses[15]:=142914628;
IsotopeMasses[62].isotopemasses[16]:=143911999;
IsotopeMasses[62].isotopemasses[17]:=144913410;
IsotopeMasses[62].isotopemasses[18]:=145913041;
IsotopeMasses[62].isotopemasses[19]:=146914898;
IsotopeMasses[62].isotopemasses[20]:=147914823;
IsotopeMasses[62].isotopemasses[21]:=148917185;
IsotopeMasses[62].isotopemasses[22]:=149917276;
IsotopeMasses[62].isotopemasses[23]:=150919932;
IsotopeMasses[62].isotopemasses[24]:=151919732;
IsotopeMasses[62].isotopemasses[25]:=152922097;
IsotopeMasses[62].isotopemasses[26]:=153922209;
IsotopeMasses[62].isotopemasses[27]:=154924640;
IsotopeMasses[62].isotopemasses[28]:=155925528;
IsotopeMasses[62].isotopemasses[29]:=156928360;
IsotopeMasses[62].isotopemasses[30]:=157929990;
IsotopeMasses[62].isotopemasses[31]:=158933210;
IsotopeMasses[62].isotopemasses[32]:=159935140;
IsotopeMasses[62].isotopemasses[33]:=160938800;
IsotopeMasses[62].isotopemasses[34]:=161941200;
IsotopeMasses[62].isotopemasses[35]:=162945400;
IsotopeMasses[62].isotopemasses[36]:=163948300;
IsotopeMasses[62].isotopemasses[37]:=164953000;
IsotopeMasses[63].firstisotope:=130;
IsotopeMasses[63].isotopescount:=38;
IsotopeMasses[63].isotopemasses[0]:=129963600;
IsotopeMasses[63].isotopemasses[1]:=130957800;
IsotopeMasses[63].isotopemasses[2]:=131954400;
IsotopeMasses[63].isotopemasses[3]:=132949200;
IsotopeMasses[63].isotopemasses[4]:=133946510;
IsotopeMasses[63].isotopemasses[5]:=134941800;
IsotopeMasses[63].isotopemasses[6]:=135939600;
IsotopeMasses[63].isotopemasses[7]:=136935570;
IsotopeMasses[63].isotopemasses[8]:=137933710;
IsotopeMasses[63].isotopemasses[9]:=138929792;
IsotopeMasses[63].isotopemasses[10]:=139928090;
IsotopeMasses[63].isotopemasses[11]:=140924931;
IsotopeMasses[63].isotopemasses[12]:=141923430;
IsotopeMasses[63].isotopemasses[13]:=142920298;
IsotopeMasses[63].isotopemasses[14]:=143918817;
IsotopeMasses[63].isotopemasses[15]:=144916265;
IsotopeMasses[63].isotopemasses[16]:=145917206;
IsotopeMasses[63].isotopemasses[17]:=146916746;
IsotopeMasses[63].isotopemasses[18]:=147918086;
IsotopeMasses[63].isotopemasses[19]:=148917931;
IsotopeMasses[63].isotopemasses[20]:=149919702;
IsotopeMasses[63].isotopemasses[21]:=150919850;
IsotopeMasses[63].isotopemasses[22]:=151921745;
IsotopeMasses[63].isotopemasses[23]:=152921230;
IsotopeMasses[63].isotopemasses[24]:=153922979;
IsotopeMasses[63].isotopemasses[25]:=154922893;
IsotopeMasses[63].isotopemasses[26]:=155924752;
IsotopeMasses[63].isotopemasses[27]:=156925424;
IsotopeMasses[63].isotopemasses[28]:=157927850;
IsotopeMasses[63].isotopemasses[29]:=158929089;
IsotopeMasses[63].isotopemasses[30]:=159931970;
IsotopeMasses[63].isotopemasses[31]:=160933700;
IsotopeMasses[63].isotopemasses[32]:=161937000;
IsotopeMasses[63].isotopemasses[33]:=162939200;
IsotopeMasses[63].isotopemasses[34]:=163943000;
IsotopeMasses[63].isotopemasses[35]:=164945700;
IsotopeMasses[63].isotopemasses[36]:=165950000;
IsotopeMasses[63].isotopemasses[37]:=166953200;
IsotopeMasses[64].firstisotope:=134;
IsotopeMasses[64].isotopescount:=36;
IsotopeMasses[64].isotopemasses[0]:=133955400;
IsotopeMasses[64].isotopemasses[1]:=134952600;
IsotopeMasses[64].isotopemasses[2]:=135947300;
IsotopeMasses[64].isotopemasses[3]:=136945000;
IsotopeMasses[64].isotopemasses[4]:=137940120;
IsotopeMasses[64].isotopemasses[5]:=138938240;
IsotopeMasses[64].isotopemasses[6]:=139933670;
IsotopeMasses[64].isotopemasses[7]:=140932126;
IsotopeMasses[64].isotopemasses[8]:=141928120;
IsotopeMasses[64].isotopemasses[9]:=142926750;
IsotopeMasses[64].isotopemasses[10]:=143922960;
IsotopeMasses[64].isotopemasses[11]:=144921709;
IsotopeMasses[64].isotopemasses[12]:=145918311;
IsotopeMasses[64].isotopemasses[13]:=146919094;
IsotopeMasses[64].isotopemasses[14]:=147918115;
IsotopeMasses[64].isotopemasses[15]:=148919341;
IsotopeMasses[64].isotopemasses[16]:=149918659;
IsotopeMasses[64].isotopemasses[17]:=150920348;
IsotopeMasses[64].isotopemasses[18]:=151919791;
IsotopeMasses[64].isotopemasses[19]:=152921750;
IsotopeMasses[64].isotopemasses[20]:=153920866;
IsotopeMasses[64].isotopemasses[21]:=154922622;
IsotopeMasses[64].isotopemasses[22]:=155922123;
IsotopeMasses[64].isotopemasses[23]:=156923960;
IsotopeMasses[64].isotopemasses[24]:=157924104;
IsotopeMasses[64].isotopemasses[25]:=158926389;
IsotopeMasses[64].isotopemasses[26]:=159927054;
IsotopeMasses[64].isotopemasses[27]:=160929669;
IsotopeMasses[64].isotopemasses[28]:=161930985;
IsotopeMasses[64].isotopemasses[29]:=162934000;
IsotopeMasses[64].isotopemasses[30]:=163935900;
IsotopeMasses[64].isotopemasses[31]:=164939400;
IsotopeMasses[64].isotopemasses[32]:=165941600;
IsotopeMasses[64].isotopemasses[33]:=166945600;
IsotopeMasses[64].isotopemasses[34]:=167948400;
IsotopeMasses[64].isotopemasses[35]:=168952900;
IsotopeMasses[65].firstisotope:=136;
IsotopeMasses[65].isotopescount:=36;
IsotopeMasses[65].isotopemasses[0]:=135961400;
IsotopeMasses[65].isotopemasses[1]:=136956000;
IsotopeMasses[65].isotopemasses[2]:=137953200;
IsotopeMasses[65].isotopemasses[3]:=138948300;
IsotopeMasses[65].isotopemasses[4]:=139945800;
IsotopeMasses[65].isotopemasses[5]:=140941450;
IsotopeMasses[65].isotopemasses[6]:=141938700;
IsotopeMasses[65].isotopemasses[7]:=142935120;
IsotopeMasses[65].isotopemasses[8]:=143933050;
IsotopeMasses[65].isotopemasses[9]:=144929270;
IsotopeMasses[65].isotopemasses[10]:=145927250;
IsotopeMasses[65].isotopemasses[11]:=146924045;
IsotopeMasses[65].isotopemasses[12]:=147924272;
IsotopeMasses[65].isotopemasses[13]:=148923246;
IsotopeMasses[65].isotopemasses[14]:=149923660;
IsotopeMasses[65].isotopemasses[15]:=150923103;
IsotopeMasses[65].isotopemasses[16]:=151924070;
IsotopeMasses[65].isotopemasses[17]:=152923435;
IsotopeMasses[65].isotopemasses[18]:=153924680;
IsotopeMasses[65].isotopemasses[19]:=154923505;
IsotopeMasses[65].isotopemasses[20]:=155924747;
IsotopeMasses[65].isotopemasses[21]:=156924025;
IsotopeMasses[65].isotopemasses[22]:=157925413;
IsotopeMasses[65].isotopemasses[23]:=158925347;
IsotopeMasses[65].isotopemasses[24]:=159927168;
IsotopeMasses[65].isotopemasses[25]:=160927570;
IsotopeMasses[65].isotopemasses[26]:=161929490;
IsotopeMasses[65].isotopemasses[27]:=162930648;
IsotopeMasses[65].isotopemasses[28]:=163933350;
IsotopeMasses[65].isotopemasses[29]:=164934880;
IsotopeMasses[65].isotopemasses[30]:=165937990;
IsotopeMasses[65].isotopemasses[31]:=166940100;
IsotopeMasses[65].isotopemasses[32]:=167943600;
IsotopeMasses[65].isotopemasses[33]:=168946200;
IsotopeMasses[65].isotopemasses[34]:=169950300;
IsotopeMasses[65].isotopemasses[35]:=170953300;
IsotopeMasses[66].firstisotope:=138;
IsotopeMasses[66].isotopescount:=36;
IsotopeMasses[66].isotopemasses[0]:=137962500;
IsotopeMasses[66].isotopemasses[1]:=138959500;
IsotopeMasses[66].isotopemasses[2]:=139954000;
IsotopeMasses[66].isotopemasses[3]:=140951400;
IsotopeMasses[66].isotopemasses[4]:=141946400;
IsotopeMasses[66].isotopemasses[5]:=142943830;
IsotopeMasses[66].isotopemasses[6]:=143939250;
IsotopeMasses[66].isotopemasses[7]:=144937430;
IsotopeMasses[66].isotopemasses[8]:=145932850;
IsotopeMasses[66].isotopemasses[9]:=146931092;
IsotopeMasses[66].isotopemasses[10]:=147927150;
IsotopeMasses[66].isotopemasses[11]:=148927305;
IsotopeMasses[66].isotopemasses[12]:=149925585;
IsotopeMasses[66].isotopemasses[13]:=150926185;
IsotopeMasses[66].isotopemasses[14]:=151924718;
IsotopeMasses[66].isotopemasses[15]:=152925765;
IsotopeMasses[66].isotopemasses[16]:=153924424;
IsotopeMasses[66].isotopemasses[17]:=154925754;
IsotopeMasses[66].isotopemasses[18]:=155924283;
IsotopeMasses[66].isotopemasses[19]:=156925466;
IsotopeMasses[66].isotopemasses[20]:=157924409;
IsotopeMasses[66].isotopemasses[21]:=158925739;
IsotopeMasses[66].isotopemasses[22]:=159925198;
IsotopeMasses[66].isotopemasses[23]:=160926933;
IsotopeMasses[66].isotopemasses[24]:=161926798;
IsotopeMasses[66].isotopemasses[25]:=162928731;
IsotopeMasses[66].isotopemasses[26]:=163929175;
IsotopeMasses[66].isotopemasses[27]:=164931703;
IsotopeMasses[66].isotopemasses[28]:=165932807;
IsotopeMasses[66].isotopemasses[29]:=166935660;
IsotopeMasses[66].isotopemasses[30]:=167937130;
IsotopeMasses[66].isotopemasses[31]:=168940300;
IsotopeMasses[66].isotopemasses[32]:=169942390;
IsotopeMasses[66].isotopemasses[33]:=170946200;
IsotopeMasses[66].isotopemasses[34]:=171948800;
IsotopeMasses[66].isotopemasses[35]:=172953000;
IsotopeMasses[67].firstisotope:=140;
IsotopeMasses[67].isotopescount:=36;
IsotopeMasses[67].isotopemasses[0]:=139968500;
IsotopeMasses[67].isotopemasses[1]:=140963100;
IsotopeMasses[67].isotopemasses[2]:=141959800;
IsotopeMasses[67].isotopemasses[3]:=142954600;
IsotopeMasses[67].isotopemasses[4]:=143951500;
IsotopeMasses[67].isotopemasses[5]:=144947200;
IsotopeMasses[67].isotopemasses[6]:=145944640;
IsotopeMasses[67].isotopemasses[7]:=146940060;
IsotopeMasses[67].isotopemasses[8]:=147937720;
IsotopeMasses[67].isotopemasses[9]:=148933775;
IsotopeMasses[67].isotopemasses[10]:=149933496;
IsotopeMasses[67].isotopemasses[11]:=150931688;
IsotopeMasses[67].isotopemasses[12]:=151931714;
IsotopeMasses[67].isotopemasses[13]:=152930199;
IsotopeMasses[67].isotopemasses[14]:=153930602;
IsotopeMasses[67].isotopemasses[15]:=154929103;
IsotopeMasses[67].isotopemasses[16]:=155929840;
IsotopeMasses[67].isotopemasses[17]:=156928260;
IsotopeMasses[67].isotopemasses[18]:=157928940;
IsotopeMasses[67].isotopemasses[19]:=158927712;
IsotopeMasses[67].isotopemasses[20]:=159928729;
IsotopeMasses[67].isotopemasses[21]:=160927855;
IsotopeMasses[67].isotopemasses[22]:=161929096;
IsotopeMasses[67].isotopemasses[23]:=162928734;
IsotopeMasses[67].isotopemasses[24]:=163930234;
IsotopeMasses[67].isotopemasses[25]:=164930322;
IsotopeMasses[67].isotopemasses[26]:=165932284;
IsotopeMasses[67].isotopemasses[27]:=166933133;
IsotopeMasses[67].isotopemasses[28]:=167935520;
IsotopeMasses[67].isotopemasses[29]:=168936872;
IsotopeMasses[67].isotopemasses[30]:=169939620;
IsotopeMasses[67].isotopemasses[31]:=170941500;
IsotopeMasses[67].isotopemasses[32]:=171944800;
IsotopeMasses[67].isotopemasses[33]:=172947300;
IsotopeMasses[67].isotopemasses[34]:=173951200;
IsotopeMasses[67].isotopemasses[35]:=174954100;
IsotopeMasses[68].firstisotope:=143;
IsotopeMasses[68].isotopescount:=35;
IsotopeMasses[68].isotopemasses[0]:=142966300;
IsotopeMasses[68].isotopemasses[1]:=143960400;
IsotopeMasses[68].isotopemasses[2]:=144957400;
IsotopeMasses[68].isotopemasses[3]:=145952000;
IsotopeMasses[68].isotopemasses[4]:=146949500;
IsotopeMasses[68].isotopemasses[5]:=147944550;
IsotopeMasses[68].isotopemasses[6]:=148942310;
IsotopeMasses[68].isotopemasses[7]:=149937914;
IsotopeMasses[68].isotopemasses[8]:=150937449;
IsotopeMasses[68].isotopemasses[9]:=151935050;
IsotopeMasses[68].isotopemasses[10]:=152935063;
IsotopeMasses[68].isotopemasses[11]:=153932783;
IsotopeMasses[68].isotopemasses[12]:=154933209;
IsotopeMasses[68].isotopemasses[13]:=155931060;
IsotopeMasses[68].isotopemasses[14]:=156931920;
IsotopeMasses[68].isotopemasses[15]:=157929890;
IsotopeMasses[68].isotopemasses[16]:=158930684;
IsotopeMasses[68].isotopemasses[17]:=159929080;
IsotopeMasses[68].isotopemasses[18]:=160929995;
IsotopeMasses[68].isotopemasses[19]:=161928778;
IsotopeMasses[68].isotopemasses[20]:=162930033;
IsotopeMasses[68].isotopemasses[21]:=163929200;
IsotopeMasses[68].isotopemasses[22]:=164930726;
IsotopeMasses[68].isotopemasses[23]:=165930293;
IsotopeMasses[68].isotopemasses[24]:=166932048;
IsotopeMasses[68].isotopemasses[25]:=167932370;
IsotopeMasses[68].isotopemasses[26]:=168934590;
IsotopeMasses[68].isotopemasses[27]:=169935464;
IsotopeMasses[68].isotopemasses[28]:=170938030;
IsotopeMasses[68].isotopemasses[29]:=171939356;
IsotopeMasses[68].isotopemasses[30]:=172942400;
IsotopeMasses[68].isotopemasses[31]:=173944200;
IsotopeMasses[68].isotopemasses[32]:=174947800;
IsotopeMasses[68].isotopemasses[33]:=175950100;
IsotopeMasses[68].isotopemasses[34]:=176954100;
IsotopeMasses[69].firstisotope:=145;
IsotopeMasses[69].isotopescount:=35;
IsotopeMasses[69].isotopemasses[0]:=144970100;
IsotopeMasses[69].isotopemasses[1]:=145966400;
IsotopeMasses[69].isotopemasses[2]:=146961000;
IsotopeMasses[69].isotopemasses[3]:=147957800;
IsotopeMasses[69].isotopemasses[4]:=148952700;
IsotopeMasses[69].isotopemasses[5]:=149949960;
IsotopeMasses[69].isotopemasses[6]:=150945483;
IsotopeMasses[69].isotopemasses[7]:=151944420;
IsotopeMasses[69].isotopemasses[8]:=152942012;
IsotopeMasses[69].isotopemasses[9]:=153941568;
IsotopeMasses[69].isotopemasses[10]:=154939199;
IsotopeMasses[69].isotopemasses[11]:=155938980;
IsotopeMasses[69].isotopemasses[12]:=156936970;
IsotopeMasses[69].isotopemasses[13]:=157936980;
IsotopeMasses[69].isotopemasses[14]:=158934980;
IsotopeMasses[69].isotopemasses[15]:=159935260;
IsotopeMasses[69].isotopemasses[16]:=160933550;
IsotopeMasses[69].isotopemasses[17]:=161933990;
IsotopeMasses[69].isotopemasses[18]:=162932651;
IsotopeMasses[69].isotopemasses[19]:=163933560;
IsotopeMasses[69].isotopemasses[20]:=164932435;
IsotopeMasses[69].isotopemasses[21]:=165933554;
IsotopeMasses[69].isotopemasses[22]:=166932852;
IsotopeMasses[69].isotopemasses[23]:=167934173;
IsotopeMasses[69].isotopemasses[24]:=168934213;
IsotopeMasses[69].isotopemasses[25]:=169935801;
IsotopeMasses[69].isotopemasses[26]:=170936429;
IsotopeMasses[69].isotopemasses[27]:=171938400;
IsotopeMasses[69].isotopemasses[28]:=172939604;
IsotopeMasses[69].isotopemasses[29]:=173942170;
IsotopeMasses[69].isotopemasses[30]:=174943840;
IsotopeMasses[69].isotopemasses[31]:=175946990;
IsotopeMasses[69].isotopemasses[32]:=176949000;
IsotopeMasses[69].isotopemasses[33]:=177952600;
IsotopeMasses[69].isotopemasses[34]:=178955300;
IsotopeMasses[70].firstisotope:=148;
IsotopeMasses[70].isotopescount:=34;
IsotopeMasses[70].isotopemasses[0]:=147967400;
IsotopeMasses[70].isotopemasses[1]:=148964000;
IsotopeMasses[70].isotopemasses[2]:=149958400;
IsotopeMasses[70].isotopemasses[3]:=150955400;
IsotopeMasses[70].isotopemasses[4]:=151950290;
IsotopeMasses[70].isotopemasses[5]:=152949480;
IsotopeMasses[70].isotopemasses[6]:=153946394;
IsotopeMasses[70].isotopemasses[7]:=154945782;
IsotopeMasses[70].isotopemasses[8]:=155942818;
IsotopeMasses[70].isotopemasses[9]:=156942628;
IsotopeMasses[70].isotopemasses[10]:=157939866;
IsotopeMasses[70].isotopemasses[11]:=158940050;
IsotopeMasses[70].isotopemasses[12]:=159937552;
IsotopeMasses[70].isotopemasses[13]:=160937902;
IsotopeMasses[70].isotopemasses[14]:=161935768;
IsotopeMasses[70].isotopemasses[15]:=162936334;
IsotopeMasses[70].isotopemasses[16]:=163934489;
IsotopeMasses[70].isotopemasses[17]:=164935280;
IsotopeMasses[70].isotopemasses[18]:=165933882;
IsotopeMasses[70].isotopemasses[19]:=166934950;
IsotopeMasses[70].isotopemasses[20]:=167933897;
IsotopeMasses[70].isotopemasses[21]:=168935190;
IsotopeMasses[70].isotopemasses[22]:=169934762;
IsotopeMasses[70].isotopemasses[23]:=170936326;
IsotopeMasses[70].isotopemasses[24]:=171936381;
IsotopeMasses[70].isotopemasses[25]:=172938211;
IsotopeMasses[70].isotopemasses[26]:=173938862;
IsotopeMasses[70].isotopemasses[27]:=174941276;
IsotopeMasses[70].isotopemasses[28]:=175942572;
IsotopeMasses[70].isotopemasses[29]:=176945261;
IsotopeMasses[70].isotopemasses[30]:=177946647;
IsotopeMasses[70].isotopemasses[31]:=178950200;
IsotopeMasses[70].isotopemasses[32]:=179952300;
IsotopeMasses[70].isotopemasses[33]:=180956200;
IsotopeMasses[71].firstisotope:=150;
IsotopeMasses[71].isotopescount:=35;
IsotopeMasses[71].isotopemasses[0]:=149973200;
IsotopeMasses[71].isotopemasses[1]:=150967600;
IsotopeMasses[71].isotopemasses[2]:=151964120;
IsotopeMasses[71].isotopemasses[3]:=152958770;
IsotopeMasses[71].isotopemasses[4]:=153957520;
IsotopeMasses[71].isotopemasses[5]:=154954316;
IsotopeMasses[71].isotopemasses[6]:=155953030;
IsotopeMasses[71].isotopemasses[7]:=156950098;
IsotopeMasses[71].isotopemasses[8]:=157949313;
IsotopeMasses[71].isotopemasses[9]:=158946630;
IsotopeMasses[71].isotopemasses[10]:=159946030;
IsotopeMasses[71].isotopemasses[11]:=160943570;
IsotopeMasses[71].isotopemasses[12]:=161943280;
IsotopeMasses[71].isotopemasses[13]:=162941180;
IsotopeMasses[71].isotopemasses[14]:=163941340;
IsotopeMasses[71].isotopemasses[15]:=164939410;
IsotopeMasses[71].isotopemasses[16]:=165939860;
IsotopeMasses[71].isotopemasses[17]:=166938270;
IsotopeMasses[71].isotopemasses[18]:=167938740;
IsotopeMasses[71].isotopemasses[19]:=168937651;
IsotopeMasses[71].isotopemasses[20]:=169938475;
IsotopeMasses[71].isotopemasses[21]:=170937913;
IsotopeMasses[71].isotopemasses[22]:=171939086;
IsotopeMasses[71].isotopemasses[23]:=172938931;
IsotopeMasses[71].isotopemasses[24]:=173940337;
IsotopeMasses[71].isotopemasses[25]:=174940771.8;
IsotopeMasses[71].isotopemasses[26]:=175942686.3;
IsotopeMasses[71].isotopemasses[27]:=176943758.1;
IsotopeMasses[71].isotopemasses[28]:=177945955;
IsotopeMasses[71].isotopemasses[29]:=178947327;
IsotopeMasses[71].isotopemasses[30]:=179949880;
IsotopeMasses[71].isotopemasses[31]:=180952000;
IsotopeMasses[71].isotopemasses[32]:=181955040;
IsotopeMasses[71].isotopemasses[33]:=182957600;
IsotopeMasses[71].isotopemasses[34]:=183960900;
IsotopeMasses[72].firstisotope:=153;
IsotopeMasses[72].isotopescount:=36;
IsotopeMasses[72].isotopemasses[0]:=152970700;
IsotopeMasses[72].isotopemasses[1]:=153964900;
IsotopeMasses[72].isotopemasses[2]:=154963400;
IsotopeMasses[72].isotopemasses[3]:=155959360;
IsotopeMasses[72].isotopemasses[4]:=156958400;
IsotopeMasses[72].isotopemasses[5]:=157954799;
IsotopeMasses[72].isotopemasses[6]:=158953995;
IsotopeMasses[72].isotopemasses[7]:=159950684;
IsotopeMasses[72].isotopemasses[8]:=160950275;
IsotopeMasses[72].isotopemasses[9]:=161947210;
IsotopeMasses[72].isotopemasses[10]:=162947090;
IsotopeMasses[72].isotopemasses[11]:=163944367;
IsotopeMasses[72].isotopemasses[12]:=164944570;
IsotopeMasses[72].isotopemasses[13]:=165942180;
IsotopeMasses[72].isotopemasses[14]:=166942600;
IsotopeMasses[72].isotopemasses[15]:=167940570;
IsotopeMasses[72].isotopemasses[16]:=168941260;
IsotopeMasses[72].isotopemasses[17]:=169939610;
IsotopeMasses[72].isotopemasses[18]:=170940490;
IsotopeMasses[72].isotopemasses[19]:=171939450;
IsotopeMasses[72].isotopemasses[20]:=172940510;
IsotopeMasses[72].isotopemasses[21]:=173940046;
IsotopeMasses[72].isotopemasses[22]:=174941509;
IsotopeMasses[72].isotopemasses[23]:=175941408.6;
IsotopeMasses[72].isotopemasses[24]:=176943220.7;
IsotopeMasses[72].isotopemasses[25]:=177943698.8;
IsotopeMasses[72].isotopemasses[26]:=178945816.1;
IsotopeMasses[72].isotopemasses[27]:=179946550;
IsotopeMasses[72].isotopemasses[28]:=180949101.2;
IsotopeMasses[72].isotopemasses[29]:=181950554;
IsotopeMasses[72].isotopemasses[30]:=182953530;
IsotopeMasses[72].isotopemasses[31]:=183955450;
IsotopeMasses[72].isotopemasses[32]:=184958820;
IsotopeMasses[72].isotopemasses[33]:=185960900;
IsotopeMasses[72].isotopemasses[34]:=186964600;
IsotopeMasses[72].isotopemasses[35]:=187966900;
IsotopeMasses[73].firstisotope:=155;
IsotopeMasses[73].isotopescount:=36;
IsotopeMasses[73].isotopemasses[0]:=154974600;
IsotopeMasses[73].isotopemasses[1]:=155972300;
IsotopeMasses[73].isotopemasses[2]:=156968190;
IsotopeMasses[73].isotopemasses[3]:=157966700;
IsotopeMasses[73].isotopemasses[4]:=158963018;
IsotopeMasses[73].isotopemasses[5]:=159961490;
IsotopeMasses[73].isotopemasses[6]:=160958420;
IsotopeMasses[73].isotopemasses[7]:=161957290;
IsotopeMasses[73].isotopemasses[8]:=162954330;
IsotopeMasses[73].isotopemasses[9]:=163953530;
IsotopeMasses[73].isotopemasses[10]:=164950773;
IsotopeMasses[73].isotopemasses[11]:=165950510;
IsotopeMasses[73].isotopemasses[12]:=166948090;
IsotopeMasses[73].isotopemasses[13]:=167948050;
IsotopeMasses[73].isotopemasses[14]:=168946010;
IsotopeMasses[73].isotopemasses[15]:=169946180;
IsotopeMasses[73].isotopemasses[16]:=170944480;
IsotopeMasses[73].isotopemasses[17]:=171944900;
IsotopeMasses[73].isotopemasses[18]:=172943750;
IsotopeMasses[73].isotopemasses[19]:=173944450;
IsotopeMasses[73].isotopemasses[20]:=174943740;
IsotopeMasses[73].isotopemasses[21]:=175944860;
IsotopeMasses[73].isotopemasses[22]:=176944472;
IsotopeMasses[73].isotopemasses[23]:=177945778;
IsotopeMasses[73].isotopemasses[24]:=178945929.5;
IsotopeMasses[73].isotopemasses[25]:=179947464.8;
IsotopeMasses[73].isotopemasses[26]:=180947995.8;
IsotopeMasses[73].isotopemasses[27]:=181950151.8;
IsotopeMasses[73].isotopemasses[28]:=182951372.6;
IsotopeMasses[73].isotopemasses[29]:=183954010;
IsotopeMasses[73].isotopemasses[30]:=184955559;
IsotopeMasses[73].isotopemasses[31]:=185958550;
IsotopeMasses[73].isotopemasses[32]:=186960530;
IsotopeMasses[73].isotopemasses[33]:=187963700;
IsotopeMasses[73].isotopemasses[34]:=188965800;
IsotopeMasses[73].isotopemasses[35]:=189969200;
IsotopeMasses[74].firstisotope:=158;
IsotopeMasses[74].isotopescount:=35;
IsotopeMasses[74].isotopemasses[0]:=157974600;
IsotopeMasses[74].isotopemasses[1]:=158972900;
IsotopeMasses[74].isotopemasses[2]:=159968480;
IsotopeMasses[74].isotopemasses[3]:=160967360;
IsotopeMasses[74].isotopemasses[4]:=161963497;
IsotopeMasses[74].isotopemasses[5]:=162962520;
IsotopeMasses[74].isotopemasses[6]:=163958954;
IsotopeMasses[74].isotopemasses[7]:=164958280;
IsotopeMasses[74].isotopemasses[8]:=165955027;
IsotopeMasses[74].isotopemasses[9]:=166954816;
IsotopeMasses[74].isotopemasses[10]:=167951808;
IsotopeMasses[74].isotopemasses[11]:=168951779;
IsotopeMasses[74].isotopemasses[12]:=169949228;
IsotopeMasses[74].isotopemasses[13]:=170949450;
IsotopeMasses[74].isotopemasses[14]:=171947290;
IsotopeMasses[74].isotopemasses[15]:=172947690;
IsotopeMasses[74].isotopemasses[16]:=173946080;
IsotopeMasses[74].isotopemasses[17]:=174946720;
IsotopeMasses[74].isotopemasses[18]:=175945630;
IsotopeMasses[74].isotopemasses[19]:=176946640;
IsotopeMasses[74].isotopemasses[20]:=177945876;
IsotopeMasses[74].isotopemasses[21]:=178947070;
IsotopeMasses[74].isotopemasses[22]:=179946704;
IsotopeMasses[74].isotopemasses[23]:=180948197;
IsotopeMasses[74].isotopemasses[24]:=181948204.2;
IsotopeMasses[74].isotopemasses[25]:=182950223;
IsotopeMasses[74].isotopemasses[26]:=183950931.2;
IsotopeMasses[74].isotopemasses[27]:=184953419.3;
IsotopeMasses[74].isotopemasses[28]:=185954364.1;
IsotopeMasses[74].isotopemasses[29]:=186957160.5;
IsotopeMasses[74].isotopemasses[30]:=187958489;
IsotopeMasses[74].isotopemasses[31]:=188961910;
IsotopeMasses[74].isotopemasses[32]:=189963180;
IsotopeMasses[74].isotopemasses[33]:=190966600;
IsotopeMasses[74].isotopemasses[34]:=191968200;
IsotopeMasses[75].firstisotope:=160;
IsotopeMasses[75].isotopescount:=35;
IsotopeMasses[75].isotopemasses[0]:=159982100;
IsotopeMasses[75].isotopemasses[1]:=160977590;
IsotopeMasses[75].isotopemasses[2]:=161976000;
IsotopeMasses[75].isotopemasses[3]:=162972081;
IsotopeMasses[75].isotopemasses[4]:=163970320;
IsotopeMasses[75].isotopemasses[5]:=164967090;
IsotopeMasses[75].isotopemasses[6]:=165965810;
IsotopeMasses[75].isotopemasses[7]:=166962600;
IsotopeMasses[75].isotopemasses[8]:=167961570;
IsotopeMasses[75].isotopemasses[9]:=168958790;
IsotopeMasses[75].isotopemasses[10]:=169958220;
IsotopeMasses[75].isotopemasses[11]:=170955720;
IsotopeMasses[75].isotopemasses[12]:=171955420;
IsotopeMasses[75].isotopemasses[13]:=172953240;
IsotopeMasses[75].isotopemasses[14]:=173953120;
IsotopeMasses[75].isotopemasses[15]:=174951380;
IsotopeMasses[75].isotopemasses[16]:=175951620;
IsotopeMasses[75].isotopemasses[17]:=176950330;
IsotopeMasses[75].isotopemasses[18]:=177950990;
IsotopeMasses[75].isotopemasses[19]:=178949990;
IsotopeMasses[75].isotopemasses[20]:=179950789;
IsotopeMasses[75].isotopemasses[21]:=180950068;
IsotopeMasses[75].isotopemasses[22]:=181951210;
IsotopeMasses[75].isotopemasses[23]:=182950820;
IsotopeMasses[75].isotopemasses[24]:=183952521;
IsotopeMasses[75].isotopemasses[25]:=184952955;
IsotopeMasses[75].isotopemasses[26]:=185954986.1;
IsotopeMasses[75].isotopemasses[27]:=186955753.1;
IsotopeMasses[75].isotopemasses[28]:=187958114.4;
IsotopeMasses[75].isotopemasses[29]:=188959229;
IsotopeMasses[75].isotopemasses[30]:=189961820;
IsotopeMasses[75].isotopemasses[31]:=190963125;
IsotopeMasses[75].isotopemasses[32]:=191965960;
IsotopeMasses[75].isotopemasses[33]:=192967470;
IsotopeMasses[75].isotopemasses[34]:=193970400;
IsotopeMasses[76].firstisotope:=162;
IsotopeMasses[76].isotopescount:=35;
IsotopeMasses[76].isotopemasses[0]:=161984400;
IsotopeMasses[76].isotopemasses[1]:=162982700;
IsotopeMasses[76].isotopemasses[2]:=163978040;
IsotopeMasses[76].isotopemasses[3]:=164976760;
IsotopeMasses[76].isotopemasses[4]:=165972691;
IsotopeMasses[76].isotopemasses[5]:=166971550;
IsotopeMasses[76].isotopemasses[6]:=167967804;
IsotopeMasses[76].isotopemasses[7]:=168967020;
IsotopeMasses[76].isotopemasses[8]:=169963577;
IsotopeMasses[76].isotopemasses[9]:=170963185;
IsotopeMasses[76].isotopemasses[10]:=171960023;
IsotopeMasses[76].isotopemasses[11]:=172959808;
IsotopeMasses[76].isotopemasses[12]:=173957062;
IsotopeMasses[76].isotopemasses[13]:=174956946;
IsotopeMasses[76].isotopemasses[14]:=175954810;
IsotopeMasses[76].isotopemasses[15]:=176954965;
IsotopeMasses[76].isotopemasses[16]:=177953251;
IsotopeMasses[76].isotopemasses[17]:=178953816;
IsotopeMasses[76].isotopemasses[18]:=179952379;
IsotopeMasses[76].isotopemasses[19]:=180953240;
IsotopeMasses[76].isotopemasses[20]:=181952110;
IsotopeMasses[76].isotopemasses[21]:=182953130;
IsotopeMasses[76].isotopemasses[22]:=183952489.1;
IsotopeMasses[76].isotopemasses[23]:=184954042.3;
IsotopeMasses[76].isotopemasses[24]:=185953838.2;
IsotopeMasses[76].isotopemasses[25]:=186955750.5;
IsotopeMasses[76].isotopemasses[26]:=187955838.2;
IsotopeMasses[76].isotopemasses[27]:=188958147.5;
IsotopeMasses[76].isotopemasses[28]:=189958447;
IsotopeMasses[76].isotopemasses[29]:=190960929.7;
IsotopeMasses[76].isotopemasses[30]:=191961481;
IsotopeMasses[76].isotopemasses[31]:=192964152;
IsotopeMasses[76].isotopemasses[32]:=193965182;
IsotopeMasses[76].isotopemasses[33]:=194968100;
IsotopeMasses[76].isotopemasses[34]:=195969640;
IsotopeMasses[77].firstisotope:=164;
IsotopeMasses[77].isotopescount:=36;
IsotopeMasses[77].isotopemasses[0]:=163992200;
IsotopeMasses[77].isotopemasses[1]:=164987520;
IsotopeMasses[77].isotopemasses[2]:=165985820;
IsotopeMasses[77].isotopemasses[3]:=166981665;
IsotopeMasses[77].isotopemasses[4]:=167979880;
IsotopeMasses[77].isotopemasses[5]:=168976290;
IsotopeMasses[77].isotopemasses[6]:=169974970;
IsotopeMasses[77].isotopemasses[7]:=170971630;
IsotopeMasses[77].isotopemasses[8]:=171970460;
IsotopeMasses[77].isotopemasses[9]:=172967502;
IsotopeMasses[77].isotopemasses[10]:=173966860;
IsotopeMasses[77].isotopemasses[11]:=174964113;
IsotopeMasses[77].isotopemasses[12]:=175963649;
IsotopeMasses[77].isotopemasses[13]:=176961302;
IsotopeMasses[77].isotopemasses[14]:=177961082;
IsotopeMasses[77].isotopemasses[15]:=178959122;
IsotopeMasses[77].isotopemasses[16]:=179959229;
IsotopeMasses[77].isotopemasses[17]:=180957630;
IsotopeMasses[77].isotopemasses[18]:=181958076;
IsotopeMasses[77].isotopemasses[19]:=182956850;
IsotopeMasses[77].isotopemasses[20]:=183957480;
IsotopeMasses[77].isotopemasses[21]:=184956700;
IsotopeMasses[77].isotopemasses[22]:=185957946;
IsotopeMasses[77].isotopemasses[23]:=186957363;
IsotopeMasses[77].isotopemasses[24]:=187958853;
IsotopeMasses[77].isotopemasses[25]:=188958719;
IsotopeMasses[77].isotopemasses[26]:=189960546;
IsotopeMasses[77].isotopemasses[27]:=190960594;
IsotopeMasses[77].isotopemasses[28]:=191962605;
IsotopeMasses[77].isotopemasses[29]:=192962926.4;
IsotopeMasses[77].isotopemasses[30]:=193965078.4;
IsotopeMasses[77].isotopemasses[31]:=194965979.6;
IsotopeMasses[77].isotopemasses[32]:=195968400;
IsotopeMasses[77].isotopemasses[33]:=196969653;
IsotopeMasses[77].isotopemasses[34]:=197972280;
IsotopeMasses[77].isotopemasses[35]:=198973800;
IsotopeMasses[78].firstisotope:=166;
IsotopeMasses[78].isotopescount:=37;
IsotopeMasses[78].isotopemasses[0]:=165994900;
IsotopeMasses[78].isotopemasses[1]:=166993000;
IsotopeMasses[78].isotopemasses[2]:=167988150;
IsotopeMasses[78].isotopemasses[3]:=168986720;
IsotopeMasses[78].isotopemasses[4]:=169982495;
IsotopeMasses[78].isotopemasses[5]:=170981240;
IsotopeMasses[78].isotopemasses[6]:=171977347;
IsotopeMasses[78].isotopemasses[7]:=172976440;
IsotopeMasses[78].isotopemasses[8]:=173972819;
IsotopeMasses[78].isotopemasses[9]:=174972421;
IsotopeMasses[78].isotopemasses[10]:=175968945;
IsotopeMasses[78].isotopemasses[11]:=176968469;
IsotopeMasses[78].isotopemasses[12]:=177965649;
IsotopeMasses[78].isotopemasses[13]:=178965363;
IsotopeMasses[78].isotopemasses[14]:=179963031;
IsotopeMasses[78].isotopemasses[15]:=180963097;
IsotopeMasses[78].isotopemasses[16]:=181961171;
IsotopeMasses[78].isotopemasses[17]:=182961597;
IsotopeMasses[78].isotopemasses[18]:=183959922;
IsotopeMasses[78].isotopemasses[19]:=184960620;
IsotopeMasses[78].isotopemasses[20]:=185959351;
IsotopeMasses[78].isotopemasses[21]:=186960590;
IsotopeMasses[78].isotopemasses[22]:=187959395;
IsotopeMasses[78].isotopemasses[23]:=188960834;
IsotopeMasses[78].isotopemasses[24]:=189959932;
IsotopeMasses[78].isotopemasses[25]:=190961677;
IsotopeMasses[78].isotopemasses[26]:=191961038;
IsotopeMasses[78].isotopemasses[27]:=192962987.4;
IsotopeMasses[78].isotopemasses[28]:=193962680.3;
IsotopeMasses[78].isotopemasses[29]:=194964791.1;
IsotopeMasses[78].isotopemasses[30]:=195964951.5;
IsotopeMasses[78].isotopemasses[31]:=196967340.2;
IsotopeMasses[78].isotopemasses[32]:=197967893;
IsotopeMasses[78].isotopemasses[33]:=198970593;
IsotopeMasses[78].isotopemasses[34]:=199971441;
IsotopeMasses[78].isotopemasses[35]:=200974510;
IsotopeMasses[78].isotopemasses[36]:=201975700;
IsotopeMasses[79].firstisotope:=169;
IsotopeMasses[79].isotopescount:=37;
IsotopeMasses[79].isotopemasses[0]:=168998100;
IsotopeMasses[79].isotopemasses[1]:=169996120;
IsotopeMasses[79].isotopemasses[2]:=170991880;
IsotopeMasses[79].isotopemasses[3]:=171990040;
IsotopeMasses[79].isotopemasses[4]:=172986240;
IsotopeMasses[79].isotopemasses[5]:=173984760;
IsotopeMasses[79].isotopemasses[6]:=174981270;
IsotopeMasses[79].isotopemasses[7]:=175980100;
IsotopeMasses[79].isotopemasses[8]:=176976865;
IsotopeMasses[79].isotopemasses[9]:=177976030;
IsotopeMasses[79].isotopemasses[10]:=178973213;
IsotopeMasses[79].isotopemasses[11]:=179972521;
IsotopeMasses[79].isotopemasses[12]:=180970079;
IsotopeMasses[79].isotopemasses[13]:=181969618;
IsotopeMasses[79].isotopemasses[14]:=182967593;
IsotopeMasses[79].isotopemasses[15]:=183967452;
IsotopeMasses[79].isotopemasses[16]:=184965790;
IsotopeMasses[79].isotopemasses[17]:=185965953;
IsotopeMasses[79].isotopemasses[18]:=186964570;
IsotopeMasses[79].isotopemasses[19]:=187965324;
IsotopeMasses[79].isotopemasses[20]:=188963948;
IsotopeMasses[79].isotopemasses[21]:=189964700;
IsotopeMasses[79].isotopemasses[22]:=190963700;
IsotopeMasses[79].isotopemasses[23]:=191964813;
IsotopeMasses[79].isotopemasses[24]:=192964150;
IsotopeMasses[79].isotopemasses[25]:=193965365;
IsotopeMasses[79].isotopemasses[26]:=194965034.6;
IsotopeMasses[79].isotopemasses[27]:=195966570;
IsotopeMasses[79].isotopemasses[28]:=196966568.7;
IsotopeMasses[79].isotopemasses[29]:=197968242.3;
IsotopeMasses[79].isotopemasses[30]:=198968765.2;
IsotopeMasses[79].isotopemasses[31]:=199970730;
IsotopeMasses[79].isotopemasses[32]:=200971657;
IsotopeMasses[79].isotopemasses[33]:=201973810;
IsotopeMasses[79].isotopemasses[34]:=202975155;
IsotopeMasses[79].isotopemasses[35]:=203977720;
IsotopeMasses[79].isotopemasses[36]:=204979900;
IsotopeMasses[80].firstisotope:=171;
IsotopeMasses[80].isotopescount:=40;
IsotopeMasses[80].isotopemasses[0]:=171003800;
IsotopeMasses[80].isotopemasses[1]:=171998830;
IsotopeMasses[80].isotopemasses[2]:=172997240;
IsotopeMasses[80].isotopemasses[3]:=173992864;
IsotopeMasses[80].isotopemasses[4]:=174991420;
IsotopeMasses[80].isotopemasses[5]:=175987355;
IsotopeMasses[80].isotopemasses[6]:=176986280;
IsotopeMasses[80].isotopemasses[7]:=177982483;
IsotopeMasses[80].isotopemasses[8]:=178981830;
IsotopeMasses[80].isotopemasses[9]:=179978266;
IsotopeMasses[80].isotopemasses[10]:=180977819;
IsotopeMasses[80].isotopemasses[11]:=181974690;
IsotopeMasses[80].isotopemasses[12]:=182974450;
IsotopeMasses[80].isotopemasses[13]:=183971713;
IsotopeMasses[80].isotopemasses[14]:=184971899;
IsotopeMasses[80].isotopemasses[15]:=185969362;
IsotopeMasses[80].isotopemasses[16]:=186969814;
IsotopeMasses[80].isotopemasses[17]:=187967577;
IsotopeMasses[80].isotopemasses[18]:=188968190;
IsotopeMasses[80].isotopemasses[19]:=189966322;
IsotopeMasses[80].isotopemasses[20]:=190967157;
IsotopeMasses[80].isotopemasses[21]:=191965634;
IsotopeMasses[80].isotopemasses[22]:=192966665;
IsotopeMasses[80].isotopemasses[23]:=193965439;
IsotopeMasses[80].isotopemasses[24]:=194966720;
IsotopeMasses[80].isotopemasses[25]:=195965833;
IsotopeMasses[80].isotopemasses[26]:=196967213;
IsotopeMasses[80].isotopemasses[27]:=197966769;
IsotopeMasses[80].isotopemasses[28]:=198968279.9;
IsotopeMasses[80].isotopemasses[29]:=199968326;
IsotopeMasses[80].isotopemasses[30]:=200970302.3;
IsotopeMasses[80].isotopemasses[31]:=201970643;
IsotopeMasses[80].isotopemasses[32]:=202972872.5;
IsotopeMasses[80].isotopemasses[33]:=203973493.9;
IsotopeMasses[80].isotopemasses[34]:=204976073;
IsotopeMasses[80].isotopemasses[35]:=205977514;
IsotopeMasses[80].isotopemasses[36]:=206982590;
IsotopeMasses[80].isotopemasses[37]:=207985900;
IsotopeMasses[80].isotopemasses[38]:=208991040;
IsotopeMasses[80].isotopemasses[39]:=209994500;
IsotopeMasses[81].firstisotope:=176;
IsotopeMasses[81].isotopescount:=37;
IsotopeMasses[81].isotopemasses[0]:=176000590;
IsotopeMasses[81].isotopemasses[1]:=176996430;
IsotopeMasses[81].isotopemasses[2]:=177994900;
IsotopeMasses[81].isotopemasses[3]:=178991090;
IsotopeMasses[81].isotopemasses[4]:=179989910;
IsotopeMasses[81].isotopemasses[5]:=180986257;
IsotopeMasses[81].isotopemasses[6]:=181985670;
IsotopeMasses[81].isotopemasses[7]:=182982193;
IsotopeMasses[81].isotopemasses[8]:=183981870;
IsotopeMasses[81].isotopemasses[9]:=184978790;
IsotopeMasses[81].isotopemasses[10]:=185978330;
IsotopeMasses[81].isotopemasses[11]:=186975906;
IsotopeMasses[81].isotopemasses[12]:=187976010;
IsotopeMasses[81].isotopemasses[13]:=188973588;
IsotopeMasses[81].isotopemasses[14]:=189973880;
IsotopeMasses[81].isotopemasses[15]:=190971786;
IsotopeMasses[81].isotopemasses[16]:=191972230;
IsotopeMasses[81].isotopemasses[17]:=192970670;
IsotopeMasses[81].isotopemasses[18]:=193971200;
IsotopeMasses[81].isotopemasses[19]:=194969774;
IsotopeMasses[81].isotopemasses[20]:=195970481;
IsotopeMasses[81].isotopemasses[21]:=196969575;
IsotopeMasses[81].isotopemasses[22]:=197970480;
IsotopeMasses[81].isotopemasses[23]:=198969880;
IsotopeMasses[81].isotopemasses[24]:=199970963;
IsotopeMasses[81].isotopemasses[25]:=200970819;
IsotopeMasses[81].isotopemasses[26]:=201972106;
IsotopeMasses[81].isotopemasses[27]:=202972344.2;
IsotopeMasses[81].isotopemasses[28]:=203973863.5;
IsotopeMasses[81].isotopemasses[29]:=204974427.5;
IsotopeMasses[81].isotopemasses[30]:=205976110.3;
IsotopeMasses[81].isotopemasses[31]:=206977419;
IsotopeMasses[81].isotopemasses[32]:=207982018.7;
IsotopeMasses[81].isotopemasses[33]:=208985359;
IsotopeMasses[81].isotopemasses[34]:=209990074;
IsotopeMasses[81].isotopemasses[35]:=210993480;
IsotopeMasses[81].isotopemasses[36]:=211998200;
IsotopeMasses[82].firstisotope:=178;
IsotopeMasses[82].isotopescount:=38;
IsotopeMasses[82].isotopemasses[0]:=178003830;
IsotopeMasses[82].isotopemasses[1]:=179002150;
IsotopeMasses[82].isotopemasses[2]:=179997918;
IsotopeMasses[82].isotopemasses[3]:=180996620;
IsotopeMasses[82].isotopemasses[4]:=181992672;
IsotopeMasses[82].isotopemasses[5]:=182991870;
IsotopeMasses[82].isotopemasses[6]:=183988142;
IsotopeMasses[82].isotopemasses[7]:=184987610;
IsotopeMasses[82].isotopemasses[8]:=185984239;
IsotopeMasses[82].isotopemasses[9]:=186983918;
IsotopeMasses[82].isotopemasses[10]:=187980874;
IsotopeMasses[82].isotopemasses[11]:=188980810;
IsotopeMasses[82].isotopemasses[12]:=189978082;
IsotopeMasses[82].isotopemasses[13]:=190978270;
IsotopeMasses[82].isotopemasses[14]:=191975785;
IsotopeMasses[82].isotopemasses[15]:=192976170;
IsotopeMasses[82].isotopemasses[16]:=193974012;
IsotopeMasses[82].isotopemasses[17]:=194974542;
IsotopeMasses[82].isotopemasses[18]:=195972774;
IsotopeMasses[82].isotopemasses[19]:=196973431;
IsotopeMasses[82].isotopemasses[20]:=197972034;
IsotopeMasses[82].isotopemasses[21]:=198972920;
IsotopeMasses[82].isotopemasses[22]:=199971827;
IsotopeMasses[82].isotopemasses[23]:=200972885;
IsotopeMasses[82].isotopemasses[24]:=201972159;
IsotopeMasses[82].isotopemasses[25]:=202973391;
IsotopeMasses[82].isotopemasses[26]:=203973043.6;
IsotopeMasses[82].isotopemasses[27]:=204974481.8;
IsotopeMasses[82].isotopemasses[28]:=205974465.3;
IsotopeMasses[82].isotopemasses[29]:=206975896.9;
IsotopeMasses[82].isotopemasses[30]:=207976652.1;
IsotopeMasses[82].isotopemasses[31]:=208981090.1;
IsotopeMasses[82].isotopemasses[32]:=209984188.5;
IsotopeMasses[82].isotopemasses[33]:=210988737;
IsotopeMasses[82].isotopemasses[34]:=211991897.5;
IsotopeMasses[82].isotopemasses[35]:=212996581;
IsotopeMasses[82].isotopemasses[36]:=213999805;
IsotopeMasses[82].isotopemasses[37]:=215004800;
IsotopeMasses[83].firstisotope:=184;
IsotopeMasses[83].isotopescount:=35;
IsotopeMasses[83].isotopemasses[0]:=184001120;
IsotopeMasses[83].isotopemasses[1]:=184997630;
IsotopeMasses[83].isotopemasses[2]:=185996600;
IsotopeMasses[83].isotopemasses[3]:=186993158;
IsotopeMasses[83].isotopemasses[4]:=187992270;
IsotopeMasses[83].isotopemasses[5]:=188989200;
IsotopeMasses[83].isotopemasses[6]:=189988300;
IsotopeMasses[83].isotopemasses[7]:=190985786;
IsotopeMasses[83].isotopemasses[8]:=191985460;
IsotopeMasses[83].isotopemasses[9]:=192982960;
IsotopeMasses[83].isotopemasses[10]:=193982830;
IsotopeMasses[83].isotopemasses[11]:=194980651;
IsotopeMasses[83].isotopemasses[12]:=195980670;
IsotopeMasses[83].isotopemasses[13]:=196978864;
IsotopeMasses[83].isotopemasses[14]:=197979210;
IsotopeMasses[83].isotopemasses[15]:=198977672;
IsotopeMasses[83].isotopemasses[16]:=199978130;
IsotopeMasses[83].isotopemasses[17]:=200977009;
IsotopeMasses[83].isotopemasses[18]:=201977742;
IsotopeMasses[83].isotopemasses[19]:=202976876;
IsotopeMasses[83].isotopemasses[20]:=203977810;
IsotopeMasses[83].isotopemasses[21]:=204977389;
IsotopeMasses[83].isotopemasses[22]:=205978499;
IsotopeMasses[83].isotopemasses[23]:=206978471;
IsotopeMasses[83].isotopemasses[24]:=207979742.2;
IsotopeMasses[83].isotopemasses[25]:=208980398.7;
IsotopeMasses[83].isotopemasses[26]:=209984120.4;
IsotopeMasses[83].isotopemasses[27]:=210987269;
IsotopeMasses[83].isotopemasses[28]:=211991285.7;
IsotopeMasses[83].isotopemasses[29]:=212994385;
IsotopeMasses[83].isotopemasses[30]:=213998712;
IsotopeMasses[83].isotopemasses[31]:=215001770;
IsotopeMasses[83].isotopemasses[32]:=216006306;
IsotopeMasses[83].isotopemasses[33]:=217009470;
IsotopeMasses[83].isotopemasses[34]:=218014300;
IsotopeMasses[84].firstisotope:=188;
IsotopeMasses[84].isotopescount:=33;
IsotopeMasses[84].isotopemasses[0]:=187999422;
IsotopeMasses[84].isotopemasses[1]:=188998481;
IsotopeMasses[84].isotopemasses[2]:=189995101;
IsotopeMasses[84].isotopemasses[3]:=190994574;
IsotopeMasses[84].isotopemasses[4]:=191991335;
IsotopeMasses[84].isotopemasses[5]:=192991030;
IsotopeMasses[84].isotopemasses[6]:=193988186;
IsotopeMasses[84].isotopemasses[7]:=194988110;
IsotopeMasses[84].isotopemasses[8]:=195985535;
IsotopeMasses[84].isotopemasses[9]:=196985660;
IsotopeMasses[84].isotopemasses[10]:=197983389;
IsotopeMasses[84].isotopemasses[11]:=198983666;
IsotopeMasses[84].isotopemasses[12]:=199981799;
IsotopeMasses[84].isotopemasses[13]:=200982260;
IsotopeMasses[84].isotopemasses[14]:=201980758;
IsotopeMasses[84].isotopemasses[15]:=202981420;
IsotopeMasses[84].isotopemasses[16]:=203980318;
IsotopeMasses[84].isotopemasses[17]:=204981203;
IsotopeMasses[84].isotopemasses[18]:=205980481;
IsotopeMasses[84].isotopemasses[19]:=206981593;
IsotopeMasses[84].isotopemasses[20]:=207981245.7;
IsotopeMasses[84].isotopemasses[21]:=208982430.4;
IsotopeMasses[84].isotopemasses[22]:=209982873.7;
IsotopeMasses[84].isotopemasses[23]:=210986653.2;
IsotopeMasses[84].isotopemasses[24]:=211988868;
IsotopeMasses[84].isotopemasses[25]:=212992857;
IsotopeMasses[84].isotopemasses[26]:=213995201.3;
IsotopeMasses[84].isotopemasses[27]:=214999420;
IsotopeMasses[84].isotopemasses[28]:=216001915;
IsotopeMasses[84].isotopemasses[29]:=217006335;
IsotopeMasses[84].isotopemasses[30]:=218008973;
IsotopeMasses[84].isotopemasses[31]:=219013700;
IsotopeMasses[84].isotopemasses[32]:=220016600;
IsotopeMasses[85].firstisotope:=193;
IsotopeMasses[85].isotopescount:=31;
IsotopeMasses[85].isotopemasses[0]:=192999840;
IsotopeMasses[85].isotopemasses[1]:=193998730;
IsotopeMasses[85].isotopemasses[2]:=194996268;
IsotopeMasses[85].isotopemasses[3]:=195995790;
IsotopeMasses[85].isotopemasses[4]:=196993190;
IsotopeMasses[85].isotopemasses[5]:=197992840;
IsotopeMasses[85].isotopemasses[6]:=198990530;
IsotopeMasses[85].isotopemasses[7]:=199990350;
IsotopeMasses[85].isotopemasses[8]:=200988417;
IsotopeMasses[85].isotopemasses[9]:=201988630;
IsotopeMasses[85].isotopemasses[10]:=202986942;
IsotopeMasses[85].isotopemasses[11]:=203987250;
IsotopeMasses[85].isotopemasses[12]:=204986074;
IsotopeMasses[85].isotopemasses[13]:=205986667;
IsotopeMasses[85].isotopemasses[14]:=206985784;
IsotopeMasses[85].isotopemasses[15]:=207986590;
IsotopeMasses[85].isotopemasses[16]:=208986173;
IsotopeMasses[85].isotopemasses[17]:=209987148;
IsotopeMasses[85].isotopemasses[18]:=210987496;
IsotopeMasses[85].isotopemasses[19]:=211990745;
IsotopeMasses[85].isotopemasses[20]:=212992937;
IsotopeMasses[85].isotopemasses[21]:=213996372;
IsotopeMasses[85].isotopemasses[22]:=214998653;
IsotopeMasses[85].isotopemasses[23]:=216002423;
IsotopeMasses[85].isotopemasses[24]:=217004719;
IsotopeMasses[85].isotopemasses[25]:=218008694;
IsotopeMasses[85].isotopemasses[26]:=219011162;
IsotopeMasses[85].isotopemasses[27]:=220015410;
IsotopeMasses[85].isotopemasses[28]:=221018050;
IsotopeMasses[85].isotopemasses[29]:=222022300;
IsotopeMasses[85].isotopemasses[30]:=223025200;
IsotopeMasses[86].firstisotope:=195;
IsotopeMasses[86].isotopescount:=34;
IsotopeMasses[86].isotopemasses[0]:=195005440;
IsotopeMasses[86].isotopemasses[1]:=196002115;
IsotopeMasses[86].isotopemasses[2]:=197001580;
IsotopeMasses[86].isotopemasses[3]:=197998679;
IsotopeMasses[86].isotopemasses[4]:=198998370;
IsotopeMasses[86].isotopemasses[5]:=199995699;
IsotopeMasses[86].isotopemasses[6]:=200995630;
IsotopeMasses[86].isotopemasses[7]:=201993263;
IsotopeMasses[86].isotopemasses[8]:=202993387;
IsotopeMasses[86].isotopemasses[9]:=203991429;
IsotopeMasses[86].isotopemasses[10]:=204991720;
IsotopeMasses[86].isotopemasses[11]:=205990214;
IsotopeMasses[86].isotopemasses[12]:=206990730;
IsotopeMasses[86].isotopemasses[13]:=207989642;
IsotopeMasses[86].isotopemasses[14]:=208990415;
IsotopeMasses[86].isotopemasses[15]:=209989696;
IsotopeMasses[86].isotopemasses[16]:=210990601;
IsotopeMasses[86].isotopemasses[17]:=211990704;
IsotopeMasses[86].isotopemasses[18]:=212993883;
IsotopeMasses[86].isotopemasses[19]:=213995363;
IsotopeMasses[86].isotopemasses[20]:=214998745;
IsotopeMasses[86].isotopemasses[21]:=216000274;
IsotopeMasses[86].isotopemasses[22]:=217003928;
IsotopeMasses[86].isotopemasses[23]:=218005601.3;
IsotopeMasses[86].isotopemasses[24]:=219009480;
IsotopeMasses[86].isotopemasses[25]:=220011394;
IsotopeMasses[86].isotopemasses[26]:=221015537;
IsotopeMasses[86].isotopemasses[27]:=222017577.7;
IsotopeMasses[86].isotopemasses[28]:=223021800;
IsotopeMasses[86].isotopemasses[29]:=224024100;
IsotopeMasses[86].isotopemasses[30]:=225028400;
IsotopeMasses[86].isotopemasses[31]:=226030900;
IsotopeMasses[86].isotopemasses[32]:=227035400;
IsotopeMasses[86].isotopemasses[33]:=228038000;
IsotopeMasses[87].firstisotope:=199;
IsotopeMasses[87].isotopescount:=34;
IsotopeMasses[87].isotopemasses[0]:=199007260;
IsotopeMasses[87].isotopemasses[1]:=200006570;
IsotopeMasses[87].isotopemasses[2]:=201003860;
IsotopeMasses[87].isotopemasses[3]:=202003370;
IsotopeMasses[87].isotopemasses[4]:=203000925;
IsotopeMasses[87].isotopemasses[5]:=204000650;
IsotopeMasses[87].isotopemasses[6]:=204998594;
IsotopeMasses[87].isotopemasses[7]:=205998670;
IsotopeMasses[87].isotopemasses[8]:=206996950;
IsotopeMasses[87].isotopemasses[9]:=207997140;
IsotopeMasses[87].isotopemasses[10]:=208995954;
IsotopeMasses[87].isotopemasses[11]:=209996408;
IsotopeMasses[87].isotopemasses[12]:=210995537;
IsotopeMasses[87].isotopemasses[13]:=211996200;
IsotopeMasses[87].isotopemasses[14]:=212996189;
IsotopeMasses[87].isotopemasses[15]:=213998971;
IsotopeMasses[87].isotopemasses[16]:=215000341;
IsotopeMasses[87].isotopemasses[17]:=216003198;
IsotopeMasses[87].isotopemasses[18]:=217004632;
IsotopeMasses[87].isotopemasses[19]:=218007578;
IsotopeMasses[87].isotopemasses[20]:=219009252;
IsotopeMasses[87].isotopemasses[21]:=220012327;
IsotopeMasses[87].isotopemasses[22]:=221014255;
IsotopeMasses[87].isotopemasses[23]:=222017552;
IsotopeMasses[87].isotopemasses[24]:=223019736;
IsotopeMasses[87].isotopemasses[25]:=224023250;
IsotopeMasses[87].isotopemasses[26]:=225025570;
IsotopeMasses[87].isotopemasses[27]:=226029390;
IsotopeMasses[87].isotopemasses[28]:=227031840;
IsotopeMasses[87].isotopemasses[29]:=228035730;
IsotopeMasses[87].isotopemasses[30]:=229038450;
IsotopeMasses[87].isotopemasses[31]:=230042500;
IsotopeMasses[87].isotopemasses[32]:=231045400;
IsotopeMasses[87].isotopemasses[33]:=232049800;
IsotopeMasses[88].firstisotope:=202;
IsotopeMasses[88].isotopescount:=33;
IsotopeMasses[88].isotopemasses[0]:=202009890;
IsotopeMasses[88].isotopemasses[1]:=203009270;
IsotopeMasses[88].isotopemasses[2]:=204006500;
IsotopeMasses[88].isotopemasses[3]:=205006270;
IsotopeMasses[88].isotopemasses[4]:=206003827;
IsotopeMasses[88].isotopemasses[5]:=207003800;
IsotopeMasses[88].isotopemasses[6]:=208001840;
IsotopeMasses[88].isotopemasses[7]:=209001990;
IsotopeMasses[88].isotopemasses[8]:=210000495;
IsotopeMasses[88].isotopemasses[9]:=211000900;
IsotopeMasses[88].isotopemasses[10]:=211999794;
IsotopeMasses[88].isotopemasses[11]:=213000384;
IsotopeMasses[88].isotopemasses[12]:=214000108;
IsotopeMasses[88].isotopemasses[13]:=215002720;
IsotopeMasses[88].isotopemasses[14]:=216003533;
IsotopeMasses[88].isotopemasses[15]:=217006320;
IsotopeMasses[88].isotopemasses[16]:=218007140;
IsotopeMasses[88].isotopemasses[17]:=219010085;
IsotopeMasses[88].isotopemasses[18]:=220011028;
IsotopeMasses[88].isotopemasses[19]:=221013917;
IsotopeMasses[88].isotopemasses[20]:=222015375;
IsotopeMasses[88].isotopemasses[21]:=223018502;
IsotopeMasses[88].isotopemasses[22]:=224020211.8;
IsotopeMasses[88].isotopemasses[23]:=225023612;
IsotopeMasses[88].isotopemasses[24]:=226025409.8;
IsotopeMasses[88].isotopemasses[25]:=227029177.8;
IsotopeMasses[88].isotopemasses[26]:=228031070;
IsotopeMasses[88].isotopemasses[27]:=229034958;
IsotopeMasses[88].isotopemasses[28]:=230037056;
IsotopeMasses[88].isotopemasses[29]:=231041200;
IsotopeMasses[88].isotopemasses[30]:=232043600;
IsotopeMasses[88].isotopemasses[31]:=233048100;
IsotopeMasses[88].isotopemasses[32]:=234050700;
IsotopeMasses[89].firstisotope:=206;
IsotopeMasses[89].isotopescount:=31;
IsotopeMasses[89].isotopemasses[0]:=206014500;
IsotopeMasses[89].isotopemasses[1]:=207011950;
IsotopeMasses[89].isotopemasses[2]:=208011550;
IsotopeMasses[89].isotopemasses[3]:=209009490;
IsotopeMasses[89].isotopemasses[4]:=210009440;
IsotopeMasses[89].isotopemasses[5]:=211007730;
IsotopeMasses[89].isotopemasses[6]:=212007810;
IsotopeMasses[89].isotopemasses[7]:=213006610;
IsotopeMasses[89].isotopemasses[8]:=214006902;
IsotopeMasses[89].isotopemasses[9]:=215006454;
IsotopeMasses[89].isotopemasses[10]:=216008720;
IsotopeMasses[89].isotopemasses[11]:=217009347;
IsotopeMasses[89].isotopemasses[12]:=218011640;
IsotopeMasses[89].isotopemasses[13]:=219012420;
IsotopeMasses[89].isotopemasses[14]:=220014763;
IsotopeMasses[89].isotopemasses[15]:=221015590;
IsotopeMasses[89].isotopemasses[16]:=222017844;
IsotopeMasses[89].isotopemasses[17]:=223019137;
IsotopeMasses[89].isotopemasses[18]:=224021723;
IsotopeMasses[89].isotopemasses[19]:=225023230;
IsotopeMasses[89].isotopemasses[20]:=226026098;
IsotopeMasses[89].isotopemasses[21]:=227027752;
IsotopeMasses[89].isotopemasses[22]:=228031021;
IsotopeMasses[89].isotopemasses[23]:=229033020;
IsotopeMasses[89].isotopemasses[24]:=230036300;
IsotopeMasses[89].isotopemasses[25]:=231038560;
IsotopeMasses[89].isotopemasses[26]:=232042030;
IsotopeMasses[89].isotopemasses[27]:=233044600;
IsotopeMasses[89].isotopemasses[28]:=234048400;
IsotopeMasses[89].isotopemasses[29]:=235051200;
IsotopeMasses[89].isotopemasses[30]:=236055300;
IsotopeMasses[90].firstisotope:=209;
IsotopeMasses[90].isotopescount:=30;
IsotopeMasses[90].isotopemasses[0]:=209017720;
IsotopeMasses[90].isotopemasses[1]:=210015080;
IsotopeMasses[90].isotopemasses[2]:=211014930;
IsotopeMasses[90].isotopemasses[3]:=212012980;
IsotopeMasses[90].isotopemasses[4]:=213013010;
IsotopeMasses[90].isotopemasses[5]:=214011500;
IsotopeMasses[90].isotopemasses[6]:=215011730;
IsotopeMasses[90].isotopemasses[7]:=216011062;
IsotopeMasses[90].isotopemasses[8]:=217013114;
IsotopeMasses[90].isotopemasses[9]:=218013284;
IsotopeMasses[90].isotopemasses[10]:=219015540;
IsotopeMasses[90].isotopemasses[11]:=220015748;
IsotopeMasses[90].isotopemasses[12]:=221018184;
IsotopeMasses[90].isotopemasses[13]:=222018468;
IsotopeMasses[90].isotopemasses[14]:=223020811;
IsotopeMasses[90].isotopemasses[15]:=224021467;
IsotopeMasses[90].isotopemasses[16]:=225023951;
IsotopeMasses[90].isotopemasses[17]:=226024903;
IsotopeMasses[90].isotopemasses[18]:=227027704;
IsotopeMasses[90].isotopemasses[19]:=228028741.1;
IsotopeMasses[90].isotopemasses[20]:=229031762;
IsotopeMasses[90].isotopemasses[21]:=230033133.8;
IsotopeMasses[90].isotopemasses[22]:=231036304.3;
IsotopeMasses[90].isotopemasses[23]:=232038055.3;
IsotopeMasses[90].isotopemasses[24]:=233041581.8;
IsotopeMasses[90].isotopemasses[25]:=234043601;
IsotopeMasses[90].isotopemasses[26]:=235047510;
IsotopeMasses[90].isotopemasses[27]:=236049870;
IsotopeMasses[90].isotopemasses[28]:=237053900;
IsotopeMasses[90].isotopemasses[29]:=238056500;
IsotopeMasses[91].firstisotope:=212;
IsotopeMasses[91].isotopescount:=29;
IsotopeMasses[91].isotopemasses[0]:=212023200;
IsotopeMasses[91].isotopemasses[1]:=213021110;
IsotopeMasses[91].isotopemasses[2]:=214020920;
IsotopeMasses[91].isotopemasses[3]:=215019190;
IsotopeMasses[91].isotopemasses[4]:=216019110;
IsotopeMasses[91].isotopemasses[5]:=217018320;
IsotopeMasses[91].isotopemasses[6]:=218020040;
IsotopeMasses[91].isotopemasses[7]:=219019880;
IsotopeMasses[91].isotopemasses[8]:=220021880;
IsotopeMasses[91].isotopemasses[9]:=221021880;
IsotopeMasses[91].isotopemasses[10]:=222023740;
IsotopeMasses[91].isotopemasses[11]:=223023960;
IsotopeMasses[91].isotopemasses[12]:=224025626;
IsotopeMasses[91].isotopemasses[13]:=225026130;
IsotopeMasses[91].isotopemasses[14]:=226027948;
IsotopeMasses[91].isotopemasses[15]:=227028805;
IsotopeMasses[91].isotopemasses[16]:=228031051;
IsotopeMasses[91].isotopemasses[17]:=229032097;
IsotopeMasses[91].isotopemasses[18]:=230034541;
IsotopeMasses[91].isotopemasses[19]:=231035884;
IsotopeMasses[91].isotopemasses[20]:=232038592;
IsotopeMasses[91].isotopemasses[21]:=233040247.3;
IsotopeMasses[91].isotopemasses[22]:=234043308;
IsotopeMasses[91].isotopemasses[23]:=235045440;
IsotopeMasses[91].isotopemasses[24]:=236048680;
IsotopeMasses[91].isotopemasses[25]:=237051150;
IsotopeMasses[91].isotopemasses[26]:=238054500;
IsotopeMasses[91].isotopemasses[27]:=239057260;
IsotopeMasses[91].isotopemasses[28]:=240061000;
IsotopeMasses[92].firstisotope:=217;
IsotopeMasses[92].isotopescount:=26;
IsotopeMasses[92].isotopemasses[0]:=217024370;
IsotopeMasses[92].isotopemasses[1]:=218023540;
IsotopeMasses[92].isotopemasses[2]:=219024920;
IsotopeMasses[92].isotopemasses[3]:=220024720;
IsotopeMasses[92].isotopemasses[4]:=221026400;
IsotopeMasses[92].isotopemasses[5]:=222026090;
IsotopeMasses[92].isotopemasses[6]:=223027740;
IsotopeMasses[92].isotopemasses[7]:=224027600;
IsotopeMasses[92].isotopemasses[8]:=225029391;
IsotopeMasses[92].isotopemasses[9]:=226029339;
IsotopeMasses[92].isotopemasses[10]:=227031156;
IsotopeMasses[92].isotopemasses[11]:=228031374;
IsotopeMasses[92].isotopemasses[12]:=229033506;
IsotopeMasses[92].isotopemasses[13]:=230033940;
IsotopeMasses[92].isotopemasses[14]:=231036294;
IsotopeMasses[92].isotopemasses[15]:=232037156.2;
IsotopeMasses[92].isotopemasses[16]:=233039635;
IsotopeMasses[92].isotopemasses[17]:=234040952.1;
IsotopeMasses[92].isotopemasses[18]:=235043929.9;
IsotopeMasses[92].isotopemasses[19]:=236045568;
IsotopeMasses[92].isotopemasses[20]:=237048730.2;
IsotopeMasses[92].isotopemasses[21]:=238050788.2;
IsotopeMasses[92].isotopemasses[22]:=239054293.3;
IsotopeMasses[92].isotopemasses[23]:=240056592;
IsotopeMasses[92].isotopemasses[24]:=241060300;
IsotopeMasses[92].isotopemasses[25]:=242062930;
IsotopeMasses[93].firstisotope:=225;
IsotopeMasses[93].isotopescount:=20;
IsotopeMasses[93].isotopemasses[0]:=225033910;
IsotopeMasses[93].isotopemasses[1]:=226035150;
IsotopeMasses[93].isotopemasses[2]:=227034960;
IsotopeMasses[93].isotopemasses[3]:=228036180;
IsotopeMasses[93].isotopemasses[4]:=229036260;
IsotopeMasses[93].isotopemasses[5]:=230037830;
IsotopeMasses[93].isotopemasses[6]:=231038250;
IsotopeMasses[93].isotopemasses[7]:=232040110;
IsotopeMasses[93].isotopemasses[8]:=233040740;
IsotopeMasses[93].isotopemasses[9]:=234042895;
IsotopeMasses[93].isotopemasses[10]:=235044063.3;
IsotopeMasses[93].isotopemasses[11]:=236046570;
IsotopeMasses[93].isotopemasses[12]:=237048173.4;
IsotopeMasses[93].isotopemasses[13]:=238050946.4;
IsotopeMasses[93].isotopemasses[14]:=239052939;
IsotopeMasses[93].isotopemasses[15]:=240056162;
IsotopeMasses[93].isotopemasses[16]:=241058250;
IsotopeMasses[93].isotopemasses[17]:=242061640;
IsotopeMasses[93].isotopemasses[18]:=243064280;
IsotopeMasses[93].isotopemasses[19]:=244067900;
IsotopeMasses[94].firstisotope:=228;
IsotopeMasses[94].isotopescount:=20;
IsotopeMasses[94].isotopemasses[0]:=228038740;
IsotopeMasses[94].isotopemasses[1]:=229040150;
IsotopeMasses[94].isotopemasses[2]:=230039650;
IsotopeMasses[94].isotopemasses[3]:=231041100;
IsotopeMasses[94].isotopemasses[4]:=232041187;
IsotopeMasses[94].isotopemasses[5]:=233043000;
IsotopeMasses[94].isotopemasses[6]:=234043317;
IsotopeMasses[94].isotopemasses[7]:=235045286;
IsotopeMasses[94].isotopemasses[8]:=236046058;
IsotopeMasses[94].isotopemasses[9]:=237048409.7;
IsotopeMasses[94].isotopemasses[10]:=238049559.9;
IsotopeMasses[94].isotopemasses[11]:=239052163.4;
IsotopeMasses[94].isotopemasses[12]:=240053813.5;
IsotopeMasses[94].isotopemasses[13]:=241056851.5;
IsotopeMasses[94].isotopemasses[14]:=242058742.6;
IsotopeMasses[94].isotopemasses[15]:=243062003;
IsotopeMasses[94].isotopemasses[16]:=244064204;
IsotopeMasses[94].isotopemasses[17]:=245067747;
IsotopeMasses[94].isotopemasses[18]:=246070205;
IsotopeMasses[94].isotopemasses[19]:=247074100;
IsotopeMasses[95].firstisotope:=231;
IsotopeMasses[95].isotopescount:=19;
IsotopeMasses[95].isotopemasses[0]:=231045600;
IsotopeMasses[95].isotopemasses[1]:=232046600;
IsotopeMasses[95].isotopemasses[2]:=233046350;
IsotopeMasses[95].isotopemasses[3]:=234047810;
IsotopeMasses[95].isotopemasses[4]:=235047950;
IsotopeMasses[95].isotopemasses[5]:=236049580;
IsotopeMasses[95].isotopemasses[6]:=237050000;
IsotopeMasses[95].isotopemasses[7]:=238051980;
IsotopeMasses[95].isotopemasses[8]:=239053024;
IsotopeMasses[95].isotopemasses[9]:=240055300;
IsotopeMasses[95].isotopemasses[10]:=241056829.1;
IsotopeMasses[95].isotopemasses[11]:=242059549.2;
IsotopeMasses[95].isotopemasses[12]:=243061381.1;
IsotopeMasses[95].isotopemasses[13]:=244064284.8;
IsotopeMasses[95].isotopemasses[14]:=245066452;
IsotopeMasses[95].isotopemasses[15]:=246069775;
IsotopeMasses[95].isotopemasses[16]:=247072090;
IsotopeMasses[95].isotopemasses[17]:=248075750;
IsotopeMasses[95].isotopemasses[18]:=249078500;
IsotopeMasses[96].firstisotope:=233;
IsotopeMasses[96].isotopescount:=20;
IsotopeMasses[96].isotopemasses[0]:=233050770;
IsotopeMasses[96].isotopemasses[1]:=234050160;
IsotopeMasses[96].isotopemasses[2]:=235051430;
IsotopeMasses[96].isotopemasses[3]:=236051410;
IsotopeMasses[96].isotopemasses[4]:=237052900;
IsotopeMasses[96].isotopemasses[5]:=238053030;
IsotopeMasses[96].isotopemasses[6]:=239054960;
IsotopeMasses[96].isotopemasses[7]:=240055529.5;
IsotopeMasses[96].isotopemasses[8]:=241057653;
IsotopeMasses[96].isotopemasses[9]:=242058835.8;
IsotopeMasses[96].isotopemasses[10]:=243061389.1;
IsotopeMasses[96].isotopemasses[11]:=244062752.6;
IsotopeMasses[96].isotopemasses[12]:=245065491.2;
IsotopeMasses[96].isotopemasses[13]:=246067223.7;
IsotopeMasses[96].isotopemasses[14]:=247070354;
IsotopeMasses[96].isotopemasses[15]:=248072349;
IsotopeMasses[96].isotopemasses[16]:=249075953;
IsotopeMasses[96].isotopemasses[17]:=250078357;
IsotopeMasses[96].isotopemasses[18]:=251082285;
IsotopeMasses[96].isotopemasses[19]:=252084900;
IsotopeMasses[97].firstisotope:=235;
IsotopeMasses[97].isotopescount:=20;
IsotopeMasses[97].isotopemasses[0]:=235056600;
IsotopeMasses[97].isotopemasses[1]:=236057300;
IsotopeMasses[97].isotopemasses[2]:=237057000;
IsotopeMasses[97].isotopemasses[3]:=238058300;
IsotopeMasses[97].isotopemasses[4]:=239058280;
IsotopeMasses[97].isotopemasses[5]:=240059760;
IsotopeMasses[97].isotopemasses[6]:=241060230;
IsotopeMasses[97].isotopemasses[7]:=242061980;
IsotopeMasses[97].isotopemasses[8]:=243063008;
IsotopeMasses[97].isotopemasses[9]:=244065181;
IsotopeMasses[97].isotopemasses[10]:=245066361.6;
IsotopeMasses[97].isotopemasses[11]:=246068670;
IsotopeMasses[97].isotopemasses[12]:=247070307;
IsotopeMasses[97].isotopemasses[13]:=248073090;
IsotopeMasses[97].isotopemasses[14]:=249074987;
IsotopeMasses[97].isotopemasses[15]:=250078317;
IsotopeMasses[97].isotopemasses[16]:=251080760;
IsotopeMasses[97].isotopemasses[17]:=252084310;
IsotopeMasses[97].isotopemasses[18]:=253086900;
IsotopeMasses[97].isotopemasses[19]:=254090600;
IsotopeMasses[98].firstisotope:=237;
IsotopeMasses[98].isotopescount:=20;
IsotopeMasses[98].isotopemasses[0]:=237062100;
IsotopeMasses[98].isotopemasses[1]:=238061400;
IsotopeMasses[98].isotopemasses[2]:=239062420;
IsotopeMasses[98].isotopemasses[3]:=240062300;
IsotopeMasses[98].isotopemasses[4]:=241063700;
IsotopeMasses[98].isotopemasses[5]:=242063700;
IsotopeMasses[98].isotopemasses[6]:=243065430;
IsotopeMasses[98].isotopemasses[7]:=244066001;
IsotopeMasses[98].isotopemasses[8]:=245068049;
IsotopeMasses[98].isotopemasses[9]:=246068805.3;
IsotopeMasses[98].isotopemasses[10]:=247071001;
IsotopeMasses[98].isotopemasses[11]:=248072185;
IsotopeMasses[98].isotopemasses[12]:=249074853.5;
IsotopeMasses[98].isotopemasses[13]:=250076406.1;
IsotopeMasses[98].isotopemasses[14]:=251079587;
IsotopeMasses[98].isotopemasses[15]:=252081626;
IsotopeMasses[98].isotopemasses[16]:=253085133;
IsotopeMasses[98].isotopemasses[17]:=254087323;
IsotopeMasses[98].isotopemasses[18]:=255091050;
IsotopeMasses[98].isotopemasses[19]:=256093400;
IsotopeMasses[99].firstisotope:=240;
IsotopeMasses[99].isotopescount:=19;
IsotopeMasses[99].isotopemasses[0]:=240068900;
IsotopeMasses[99].isotopemasses[1]:=241068540;
IsotopeMasses[99].isotopemasses[2]:=242069700;
IsotopeMasses[99].isotopemasses[3]:=243069550;
IsotopeMasses[99].isotopemasses[4]:=244070880;
IsotopeMasses[99].isotopemasses[5]:=245071320;
IsotopeMasses[99].isotopemasses[6]:=246072900;
IsotopeMasses[99].isotopemasses[7]:=247073660;
IsotopeMasses[99].isotopemasses[8]:=248075470;
IsotopeMasses[99].isotopemasses[9]:=249076410;
IsotopeMasses[99].isotopemasses[10]:=250078610;
IsotopeMasses[99].isotopemasses[11]:=251079992;
IsotopeMasses[99].isotopemasses[12]:=252082980;
IsotopeMasses[99].isotopemasses[13]:=253084825;
IsotopeMasses[99].isotopemasses[14]:=254088022;
IsotopeMasses[99].isotopemasses[15]:=255090273;
IsotopeMasses[99].isotopemasses[16]:=256093600;
IsotopeMasses[99].isotopemasses[17]:=257096000;
IsotopeMasses[99].isotopemasses[18]:=258099500;
IsotopeMasses[100].firstisotope:=242;
IsotopeMasses[100].isotopescount:=19;
IsotopeMasses[100].isotopemasses[0]:=242073400;
IsotopeMasses[100].isotopemasses[1]:=243074350;
IsotopeMasses[100].isotopemasses[2]:=244074100;
IsotopeMasses[100].isotopemasses[3]:=245075400;
IsotopeMasses[100].isotopemasses[4]:=246075300;
IsotopeMasses[100].isotopemasses[5]:=247076850;
IsotopeMasses[100].isotopemasses[6]:=248077195;
IsotopeMasses[100].isotopemasses[7]:=249079030;
IsotopeMasses[100].isotopemasses[8]:=250079521;
IsotopeMasses[100].isotopemasses[9]:=251081575;
IsotopeMasses[100].isotopemasses[10]:=252082467;
IsotopeMasses[100].isotopemasses[11]:=253085185;
IsotopeMasses[100].isotopemasses[12]:=254086854;
IsotopeMasses[100].isotopemasses[13]:=255089962;
IsotopeMasses[100].isotopemasses[14]:=256091773;
IsotopeMasses[100].isotopemasses[15]:=257095105;
IsotopeMasses[100].isotopemasses[16]:=258097080;
IsotopeMasses[100].isotopemasses[17]:=259100600;
IsotopeMasses[100].isotopemasses[18]:=260102700;
IsotopeMasses[101].firstisotope:=245;
IsotopeMasses[101].isotopescount:=18;
IsotopeMasses[101].isotopemasses[0]:=245080800;
IsotopeMasses[101].isotopemasses[1]:=246081900;
IsotopeMasses[101].isotopemasses[2]:=247081600;
IsotopeMasses[101].isotopemasses[3]:=248082800;
IsotopeMasses[101].isotopemasses[4]:=249083010;
IsotopeMasses[101].isotopemasses[5]:=250084400;
IsotopeMasses[101].isotopemasses[6]:=251084840;
IsotopeMasses[101].isotopemasses[7]:=252086560;
IsotopeMasses[101].isotopemasses[8]:=253087280;
IsotopeMasses[101].isotopemasses[9]:=254089660;
IsotopeMasses[101].isotopemasses[10]:=255091083;
IsotopeMasses[101].isotopemasses[11]:=256094060;
IsotopeMasses[101].isotopemasses[12]:=257095541;
IsotopeMasses[101].isotopemasses[13]:=258098431;
IsotopeMasses[101].isotopemasses[14]:=259100510;
IsotopeMasses[101].isotopemasses[15]:=260103700;
IsotopeMasses[101].isotopemasses[16]:=261105700;
IsotopeMasses[101].isotopemasses[17]:=262108900;
IsotopeMasses[102].firstisotope:=248;
IsotopeMasses[102].isotopescount:=17;
IsotopeMasses[102].isotopemasses[0]:=248086600;
IsotopeMasses[102].isotopemasses[1]:=249087800;
IsotopeMasses[102].isotopemasses[2]:=250087510;
IsotopeMasses[102].isotopemasses[3]:=251089010;
IsotopeMasses[102].isotopemasses[4]:=252088977;
IsotopeMasses[102].isotopemasses[5]:=253090680;
IsotopeMasses[102].isotopemasses[6]:=254090955;
IsotopeMasses[102].isotopemasses[7]:=255093241;
IsotopeMasses[102].isotopemasses[8]:=256094283;
IsotopeMasses[102].isotopemasses[9]:=257096877;
IsotopeMasses[102].isotopemasses[10]:=258098210;
IsotopeMasses[102].isotopemasses[11]:=259101030;
IsotopeMasses[102].isotopemasses[12]:=260102640;
IsotopeMasses[102].isotopemasses[13]:=261105700;
IsotopeMasses[102].isotopemasses[14]:=262107300;
IsotopeMasses[102].isotopemasses[15]:=263110600;
IsotopeMasses[102].isotopemasses[16]:=264112300;
IsotopeMasses[103].firstisotope:=251;
IsotopeMasses[103].isotopescount:=16;
IsotopeMasses[103].isotopemasses[0]:=251094400;
IsotopeMasses[103].isotopemasses[1]:=252095400;
IsotopeMasses[103].isotopemasses[2]:=253095210;
IsotopeMasses[103].isotopemasses[3]:=254096500;
IsotopeMasses[103].isotopemasses[4]:=255096680;
IsotopeMasses[103].isotopemasses[5]:=256098630;
IsotopeMasses[103].isotopemasses[6]:=257099560;
IsotopeMasses[103].isotopemasses[7]:=258101810;
IsotopeMasses[103].isotopemasses[8]:=259102900;
IsotopeMasses[103].isotopemasses[9]:=260105500;
IsotopeMasses[103].isotopemasses[10]:=261106880;
IsotopeMasses[103].isotopemasses[11]:=262109630;
IsotopeMasses[103].isotopemasses[12]:=263111300;
IsotopeMasses[103].isotopemasses[13]:=264114000;
IsotopeMasses[103].isotopemasses[14]:=265115800;
IsotopeMasses[103].isotopemasses[15]:=266119300;

findmainisotopes;


end;

procedure PrepareShortContactsData;
var
q,w:integer;
r1,r2:double;
begin
for q:=0 to atomsinfocount-1 do for w:=0 to atomsinfocount-1 do begin
r1:=VanRadii[q]; r2:=VanRadii[w];
ShortContactsData.Bonds[q,w].typescount:=1;
ShortContactsData.Bonds[q,w].types[0].typ:=0;
ShortContactsData.Bonds[q,w].types[0].standardvalue:=r1+r2;
ShortContactsData.Bonds[q,w].types[0].maxvalue2:=sqr(r1+r2)+0.001;
ShortContactsData.Bonds[q,w].maxvalue:=r1+r2;
ShortContactsData.Bonds[q,w].maxvalue2:=sqr(r1+r2)+0.001;
//ShortContactsData.UseShortContactsMethod:=true;


end;//next q,w

end;

{ CrystABCParams }

function TCrystABCParams.AlphaInDegrees: double;
begin
result:=alpha*180/pi;
end;

function TCrystABCParams.BetaInDegrees: double;
begin
result:=beta*180/pi;
end;

function ComputeABCFromLatticeVectors(vect1,vect2,vect3:tvect; out cellabc:TCrystABCParams):boolean;
var
//wn:double;
res:TCrystABCParams;
begin

result:=true;
if not equal(vect1.y,0) then result:=false;
if not equal(vect1.z,0) then result:=false;
if not equal(vect2.z,0) then result:=false;


res.a:=vect1.x;
res.b:=sqrt(sqr(vect2.x)+sqr(vect2.y));
res.c:=sqrt(sqr(vect3.x)+sqr(vect3.y)+sqr(vect3.z));
res.gamma:=ArcTan2(vect2.y,vect2.x);
//wn:=arctan2(vect3.y,vect3.z);

//sin(wn) в обратной процедуре считается правильно, а для cos(wn) надо выбрать знак
//cos(wn) отрицательный если vect3.z<0

res.beta:=arctan2(sqrt(sqr(vect3.y)+sqr(vect3.z)),vect3.x);

res.alpha:=ArcTan2(
sqrt(sqr(vect2.x*vect3.y-vect2.y*vect3.x)+sqr(vect2.x*vect3.z)+sqr(vect2.y*vect3.z))
,
(vect3.y*vect2.y+vect2.x*vect3.x)
);

cellabc:=res;
//res.alpha:=arccos(sin(wn)*(sin(res.gamma)*sin(res.beta))+cos(res.gamma)*cos(res.beta));


//res.alpha:=arccos(vect3.y/sqrt(sqr(vect3.y)+sqr(vect3.z))*(sin(res.gamma)*sin(res.beta))+cos(res.gamma)*cos(res.beta));
//res.alpha:=arccos(vect3.y/sqrt(sqr(vect3.y)+sqr(vect3.z))*(sin(res.gamma)*sin(res.gamma)*sin(res.beta)*sin(res.beta))/sin(res.gamma)/sin(res.beta)+cos(res.gamma)*cos(res.beta));
//res.alpha:=arccos(vect3.y/sqrt(sqr(vect3.y)+sqr(vect3.z))/sin(res.gamma)/sin(res.beta)*(sin(res.gamma)*sin(res.gamma)*sin(res.beta)*sin(res.beta))+sin(res.gamma)*cos(res.gamma)*sin(res.beta)*cos(res.beta)/sin(res.gamma)/sin(res.beta));
{
res.alpha:=arccos(
(vect3.y*vect2.y+vect2.x*vect3.x)
/
sqrt(sqr(vect3.x)+sqr(vect3.y)+sqr(vect3.z))/sqrt(sqr(vect2.x)+sqr(vect2.y))
);
}

{
cos(res.alpha):=(vect3.y*vect2.y+vect2.x*vect3.x)/sqrt(sqr(vect3.x)+sqr(vect3.y)+sqr(vect3.z))/sqrt(sqr(vect2.x)+sqr(vect2.y))
sin(res.alpha):=sqrt(1-sqr((vect3.y*vect2.y+vect2.x*vect3.x)/sqrt(sqr(vect3.x)+sqr(vect3.y)+sqr(vect3.z))/sqrt(sqr(vect2.x)+sqr(vect2.y))))
sin(res.alpha):=sqrt(1-sqr(vect3.y*vect2.y+vect2.x*vect3.x)/(sqr(vect3.x)+sqr(vect3.y)+sqr(vect3.z))/(sqr(vect2.x)+sqr(vect2.y)))
sin(res.alpha):=sqrt(((sqr(vect3.x)+sqr(vect3.y)+sqr(vect3.z))*(sqr(vect2.x)+sqr(vect2.y))-sqr(vect3.y*vect2.y+vect2.x*vect3.x))/(sqr(vect3.x)+sqr(vect3.y)+sqr(vect3.z))/(sqr(vect2.x)+sqr(vect2.y)))
}
//res.alpha:=arcsin(sqrt(((sqr(vect3.x)+sqr(vect3.y)+sqr(vect3.z))*(sqr(vect2.x)+sqr(vect2.y))-sqr(vect3.y*vect2.y+vect2.x*vect3.x))/(sqr(vect3.x)+sqr(vect3.y)+sqr(vect3.z))/(sqr(vect2.x)+sqr(vect2.y))));
{
res.alpha:=arcsin(sqrt(
(sqr(vect2.x*vect3.x)+sqr(vect2.x*vect3.y)+sqr(vect2.x*vect3.z)+sqr(vect2.y*vect3.x)+sqr(vect2.y*vect3.y)+sqr(vect2.y*vect3.z)-sqr(vect3.y*vect2.y+vect2.x*vect3.x))
)
/
sqrt(sqr(vect3.x)+sqr(vect3.y)+sqr(vect3.z))/sqrt(sqr(vect2.x)+sqr(vect2.y))
);
}
{
res.alpha:=arcsin(sqrt(
(sqr(vect2.x*vect3.y)+sqr(vect2.x*vect3.z)+sqr(vect2.y*vect3.x)+sqr(vect2.y*vect3.z)-2*vect3.y*vect2.y*vect2.x*vect3.x)
)
/
sqrt(sqr(vect3.x)+sqr(vect3.y)+sqr(vect3.z))/sqrt(sqr(vect2.x)+sqr(vect2.y))
);
}



{
res.gamma:=ArcTan2(vect2.y,vect2.x);
tan(res.gamma)=vect2.y/vect2.x
sin(res.gamma)=vect2.y/sqrt(sqr(vect2.x)+sqr(vect2.y))
cos(res.gamma)=vect2.x/sqrt(sqr(vect2.x)+sqr(vect2.y))

res.beta:=arctan2(sqrt(sqr(vect3.y)+sqr(vect3.z)),vect3.x);
tan(res.beta):=sqrt(sqr(vect3.y)+sqr(vect3.z))/vect3.x;
sin(res.beta)=sqrt(sqr(vect3.y)+sqr(vect3.z))/(sqrt(sqr(vect3.x)+sqr(vect3.y)+sqr(vect3.z)))
cos(res.beta)=vect3.x/sqrt(sqr(vect3.x)+sqr(vect3.y)+sqr(vect3.z))
}




{
sinal:=sin(alpha);
cosal:=cos(alpha);
singam:=sin(gamma);
cosgam:=cos(gamma);
cosw:=(cos(beta)-cosal*cosgam)/(sinal*singam);
sinw:=sqrt(1-sqr(cosw));
result:=BlankMatrix;
vect1.x:=a*singam*sinw;
vect2.x:=a*cosgam;
vect2.y:=b;
vect2.z:=c*cosal;
vect3.x:=a*singam*cosw;
vect3.z:=c*sinal;
}

{
try
if abs(vect2.z)>minsafefloat then alpha:=arctan(vect3.z/vect2.z)
else alpha:=pi/2;
b:=vect2.y;
c:=vect3.z/sin(alpha);

w:=arctan(vect1.x/safe(vect3.x));

gamma:=arctan(vect1.x/safe(vect2.x)/safe(sin(w)));
if gamma<0 then gamma:=gamma+pi;

a:=vect2.x/cos(gamma);

beta:=arccos(cos(w)*(sin(alpha)*sin(gamma))+cos(alpha)*cos(gamma));
except

end;
}
{
try
a:=sqrt(sqr(vect1.x)+sqr(vect1.y)+sqr(vect1.z));
b:=sqrt(sqr(vect2.x)+sqr(vect2.y)+sqr(vect2.z));
c:=sqrt(sqr(vect3.x)+sqr(vect3.y)+sqr(vect3.z));
alpha:=arccos((vect2.x*vect3.x+vect2.y*vect3.y+vect2.z*vect3.z)/(b*c));
beta:=arccos((vect1.x*vect3.x+vect1.y*vect3.y+vect1.z*vect3.z)/(a*c));
gamma:=arccos((vect1.x*vect2.x+vect1.y*vect2.y+vect1.z*vect2.z)/(a*b));
except

end;
exit;
}
{
try
a:=sqrt(sqr(vect1.x)+sqr(vect2.x)+sqr(vect3.x));
b:=sqrt(sqr(vect1.y)+sqr(vect2.y)+sqr(vect3.y));
c:=sqrt(sqr(vect1.z)+sqr(vect2.z)+sqr(vect3.z));
alpha:=arccos((vect1.y*vect1.z+vect2.y*vect2.z+vect3.y*vect3.z)/(b*c));
beta:=arccos((vect1.x*vect1.z+vect2.x*vect2.z+vect3.x*vect3.z)/(a*c));
gamma:=arccos((vect1.x*vect1.y+vect2.x*vect2.y+vect3.x*vect3.y)/(a*b));
except

end;
exit;
}

{
divvxy:=1;//warn

try
res.a:=vect1.x;
if not equal(vect2.x,0) then res.gamma:=arctan(vect2.y/vect2.x)
else res.gamma:=pi/2;

if res.gamma<0 then res.gamma:=res.gamma+pi;

if abs(vect2.y)>minsafefloat then res.b:=vect2.y/sin(res.gamma)
else res.b:=0;





wn:=arctan(vect3.y/safe(vect3.z));

if abs(vect3.y)<minsafefloat then if abs(vect3.x)<minsafefloat then divvxy:=1
else divvxy:=(vect3.y/safe(vect3.x));
res.beta:=arctan(divvxy/safe(sin(wn)));

if res.beta<0 then res.beta:=res.beta+pi;

res.alpha:=arccos(sin(wn)*(sin(res.gamma)*sin(res.beta))+cos(res.gamma)*cos(res.beta));

res.c:=vect3.z/sin(res.beta)/safe(cos(wn));


except
result:=false;
end;
}

end;

function TCrystABCParams.ComputeCartToFracMatrix: trotmatrix;
var
{sinal,}cosal{,tanal},singam,cosgam,tangam:double;
cosbet,sinbet,tanbet:double;
sinwo,coswo,sinwn,coswn,tanwn:double;
begin
{
sinal:=sin(alpha);
cosal:=cos(alpha);
tanal:=tan(alpha);
singam:=sin(gamma);
cosgam:=cos(gamma);
tangam:=tan(gamma);
cosw:=(cos(beta)-cosal*cosgam)/(sinal*singam);
sinw:=sqrt(1-sqr(cosw));
tanw:=sinw/cosw;

result:=BlankMatrix;
result.a1:=1/(a*singam*sinwo);
result.a2:=1/(b*tanal*tanwo)-1/(b*tangam*sinwo);
result.b2:=1/b;
result.c2:=-1/(b*tanal);
result.a3:=-1/(c*sinal*tanwo);
result.c3:=1/(c*sinal);
}
//sinal:=sin(alpha);
cosal:=cos(alpha);
//tanal:=tan(alpha);
singam:=sin(gamma);
cosgam:=cos(gamma);
tangam:=tan(gamma);
sinbet:=sin(beta);
cosbet:=cos(beta);
tanbet:=tan(beta);
coswo:=(cosal-cosgam*cosbet)/(singam*sinbet);
sinwo:=sqrt(1-sqr(coswo));

sinwn:=coswo; coswn:=sinwo;
tanwn:=sinwn/coswn;



result:=BlankMatrix;

result.ax:=1/a;
result.bx:=-1/(a*tangam);
result.cx:=tanwn/(a*tangam)-1/(a*tanbet*coswn);
result.by:=1/(b*singam);
result.cy:=-1*tanwn/(b*singam);
result.cz:=1/(c*sinbet*coswn);

{
result.a1:=1/a;
result.a2:=-1/(a*tangam);
result.a3:=tanwn/(a*tangam)-1/(a*tanbet*coswn);
result.b2:=1/(b*singam);
result.c2:=-1*tanwn/(b*singam);
result.c3:=1/(c*sinbet*coswn);
}
{стар  нов

b   a
c   b
a   c

al   gam
gam  bet
bet  al


b2  a1
c2  b1
c3  b2
a2  c1
a1  c2
a3  c3

coswo coswn
sinwo  sinwn
}


{
  result:=BlankMatrix;
  result.a1:=1/a;
  result.b1:=-1/(a*tangam);
  result.b2:=1/(b*singam);
  result.c1:=1/(a*tangam*tanwn)-1/(a*tanbet*sinwn);
  result.c2:=1/(c*sinbet*sinwn);
  result.c3:=-1/(b*singam*tanwn);
}


end;

function TCrystABCParams.ComputeFracToCartMatrix: trotmatrix;
var
{sinal,}cosal,
singam,cosgam:double;
sinbet,cosbet:double;
sinwn,coswn:double;

wn:double;
begin
{
sinal:=sin(alpha);
cosal:=cos(alpha);
singam:=sin(gamma);
cosgam:=cos(gamma);
cosw:=(cos(beta)-cosal*cosgam)/(sinal*singam);
sinw:=sqrt(1-sqr(cosw));
result:=BlankMatrix;
result.a1:=a*singam*sinw;
result.a2:=a*cosgam;
result.b2:=b;
result.c2:=c*cosal;
result.a3:=a*singam*cosw;
result.c3:=c*sinal;

exit;
}
{
sinal:=sin(alpha);
cosal:=cos(alpha);
singam:=sin(gamma);
cosgam:=cos(gamma);
sinbet:=sin(beta);
cosbet:=cos(beta);
cosw:=(cosal-cosgam*cosbet)/(singam*sinbet);
sinw:=sqrt(1-sqr(cosw));

result.a1:=a;
result.b1:=0;
result.c1:=0;
result.a2:=b*cosgam;
result.b2:=b*singam;
result.c2:=0;
result.a3:=c*cosbet;
result.b3:=c*sinbet*cosw;
result.c3:=c*sinbet*sinw;
}

//sinal:=sin(alpha);
cosal:=cos(alpha);
singam:=sin(gamma);
cosgam:=cos(gamma);
sinbet:=sin(beta);
cosbet:=cos(beta);
sinwn:=(cosal-cosgam*cosbet)/safe(singam*sinbet);
if sinwn>1 then sinwn:=1;
if sinwn<-1 then sinwn:=-1;
coswn:={-}sqrt(1-sqr(sinwn));//может надо -

//sinwn2=


result.ax:=a;
result.bx:=b*cosgam;
result.cx:=c*cosbet;
result.ay:=0;
result.by:=b*singam;
result.cy:=c*sinbet*sinwn;
result.az:=0;
result.bz:=0;
result.cz:=c*sinbet*coswn;

{

cosw:=(cos(beta)-cosal*cosgam)/(sinal*singam);
sinw:=sqrt(1-sqr(cosw));

result.a1:=a*singam*sinwo;
result.a2:=a*cosgam;
result.b2:=b;
result.c2:=c*cosal;
result.a3:=a*singam*coswo;
result.c3:=c*sinal;



стар  нов

b   a
c   b
a   c

al   gam
gam  bet
bet  al


b2  a1
c2  b1
c3  b2
a2  c1
a1  c2
a3  c3

coswo coswn
sinwo  sinwn

sinal:=sin(alpha);
cosal:=cos(alpha);
tanal:=tan(alpha);
singam:=sin(gamma);
cosgam:=cos(gamma);
tangam:=tan(gamma);
cosw:=(cos(beta)-cosal*cosgam)/(sinal*singam);
sinw:=sqrt(1-sqr(cosw));
tanw:=sinw/cosw;
result:=BlankMatrix;

н cosw:=(cosal-cosgam*cosbet)/(singam*sinbet);
  sinw:=sqrt(1-sqr(cosw));
  tanw:=sinw/cosw;
  result:=BlankMatrix;
  result.a1:=1/a;
  result.b2:=1/(b*singam)
  result.b1:=-1/(a*tangam)
  result.c2:=1/(c*sinbet*sinw)
  result.c3:=-1/(b*singam*tanw)
  result.c1:=1/(a*tangam*tanw)-1/(a*tanbet*sinw)

result.a1:=1/(a*singam*sinw);
result.a2:=1/(b*tanal*tanw)-1/(b*tangam*sinw);
result.b2:=1/b;
result.c2:=-1/(b*tanal);
result.a3:=-1/(c*sinal*tanw);
result.c3:=1/(c*sinal);

}
end;

procedure TCrystABCParams.ComputeLatticeVectors(out vect1, vect2, vect3: tvect);
//var
//sinal,cosal,sinw,cosw,singam,cosgam:double;
var
rm:tRotMatrix;
begin
rm:=ComputeFracToCartMatrix;
//vect1.x:=rm.a1; vect1.y:=rm.b1; vect1.z:=rm.c1;
//vect2.x:=rm.a2; vect2.y:=rm.b2; vect2.z:=rm.c2;
//vect3.x:=rm.a3; vect3.y:=rm.b3; vect3.z:=rm.c3;

vect1.x:=rm.ax; vect1.y:=rm.ay; vect1.z:=rm.az;
vect2.x:=rm.bx; vect2.y:=rm.by; vect2.z:=rm.bz;
vect3.x:=rm.cx; vect3.y:=rm.cy; vect3.z:=rm.cz;

{
sinal:=sin(alpha);
cosal:=cos(alpha);
singam:=sin(gamma);
cosgam:=cos(gamma);
cosw:=(cos(beta)-cosal*cosgam)/(sinal*singam);
sinw:=sqrt(1-sqr(cosw));
vect1.x:=a*singam*sinw;
vect1.y:=a*cosgam;
vect1.z:=a*singam*cosw;

vect2.x:=0;
vect2.y:=b;
vect2.z:=0;

vect3.x:=0;
vect3.y:=c*cosal;
vect3.z:=c*sinal;
}
end;

function TCrystABCParams.GammaInDegrees: double;
begin
result:=gamma*180/pi;
end;

function TCrystABCParams.IsZero: boolean;
begin
result:=false;
if not equal(a,0) then exit;
if not equal(b,0) then exit;
if not equal(b,0) then exit;
if not equal(alpha,0) then exit;
if not equal(beta,0) then exit;
if not equal(gamma,0) then exit;
result:=true;
end;

{ TThermDataCalculator }

constructor TThermDataCalculator.Create;
begin
FFrequencies:=Tfreqsarray.Create;
FAtomTypes:=tintarray.Create;
FCoords:=tvectsarray.Create;
end;

destructor TThermDataCalculator.Destroy;
begin
FFrequencies.Free;
FAtomTypes.Free;
FCoords.Free;

  inherited;
end;


function TThermDataCalculator.ComputeThermFunc(outstrlist:tstrings; recunits:tthermrecountunits):double;
var
q:integer;
//qtr:extended;
str:extended;
//qrot:extended;
srot:extended;
ctr,crot:extended;
dEtr,dErot:extended;
M:extended;
curv:extended;
k:extended;
t:extended;
kt:extended;
h:extended;
Na:extended;
P:extended;
//hv:extended;
hcv:extended;
teta:extended;
hvdkt:extended;
R:extended;
rt:extended;
cursvib:extended;
sumsvib:extended;//Joule/(Mol*K)
curstr:string;
srecountconst,erecountconst,efromhrecountconst:extended;//Only for printing out
curevib,sumevib:extended;//Joule/Mol

curcvvib,sumcvvib:extended;//Joule/(Mol*K)

curzpe,sumzpe:extended;

ethermh,hthermh,hh,gh:extended;

printgfinh:boolean;

sigma:integer;

negfreqscount:integer;
function EUnitsStr:string;
begin
result:='';//warn
case recunits of
truJouleMolK,truJouleMol:result:='KJoule/Mol';
truCalMolK,truCalMol:result:='KCal/Mol';
truau:result:='Hartree/particle';
truEV:result:='EV/particle';
end;//case

end;//proc

function SUnitsStr:string;
begin
result:='';
case recunits of
truJouleMolK:result:='Joule/(Mol*K)';
truJouleMol:result:='kJoule/Mol';
truCalMolK:result:='Cal/(Mol*K)';
truCalMol:result:='kCal/Mol';
truau:result:='Hartree/particle';
truEV:result:='EV/particle';
end;//case

end;

begin
FComputedData.HasGh:=false;
//k в cm-1
//** -> ^
k:=PhysicsAndChemistryConstantsSi_k;
t:=FTemterk;
P:=FPressurePa;
kt:=k*t;
R:=PhysicsAndChemistryConstantsSi_R;

M:=FMasskg;

h:=PhysicsAndChemistryConstantsSi_h;

Na:=PhysicsAndChemistryConstantsSi_Na;

rt:=r*t;

srecountconst:=0;//warn
erecountconst:=0;//warn
efromhrecountconst:=0;//warn
case recunits of
truJouleMolK:begin
srecountconst:=1;
erecountconst:=0.001;
efromhrecountconst:=autokdzhcoef;
end;
truCalMolK:begin
srecountconst:=1/kcaltokdhcoef;
erecountconst:=0.001/kcaltokdhcoef;
efromhrecountconst:=autokdzhcoef/kcaltokdhcoef;
end;
truJouleMol:begin
srecountconst:=0.001*t;
erecountconst:=0.001;
efromhrecountconst:=autokdzhcoef;
end;
truCalMol:begin
srecountconst:=0.001*t/kcaltokdhcoef;
erecountconst:=0.001/kcaltokdhcoef;
efromhrecountconst:=autokdzhcoef/kcaltokdhcoef;;
end;
truau:begin
srecountconst:=0.001*t/autokdzhcoef;
erecountconst:=0.001/autokdzhcoef;
efromhrecountconst:=1;
end;
truEV:begin
srecountconst:=0.001*t*autoevcoef/autokdzhcoef;
erecountconst:=autoevcoef/autokdzhcoef;
efromhrecountconst:=autoevcoef;
end;
end;//case

printgfinh:=recunits<>truau;

sigma:=AllPointGroupSigmas[FPointGroupFullNum];
//sigma:=60;

negfreqscount:=0; for q:=0 to FFrequencies.Count-1 do if FFrequencies[q].freqval<0 then inc(negfreqscount);



outstrlist.Add('Thermochemistry computation at T='+floattostr(t)+' K, P='+floattostr(p)+' Pa');
outstrlist.Add('');

outstrlist.Add('Atomic masses and coordinates:');
for q:=0 to FAtomTypes.Count-1 do begin
curstr:=floattostr(AtomicMasses[fatomtypes[q]]);
curstr:=InsertDigitToStr(curstr,StandCoordToStr(fcoords[q].x),20);
curstr:=InsertDigitToStr(curstr,StandCoordToStr(fcoords[q].y),40);
curstr:=InsertDigitToStr(curstr,StandCoordToStr(fcoords[q].z),60);
outstrlist.Add(curstr);
end;

outstrlist.Add('');
outstrlist.Add('Molecular mass in kg: '+floattostr(M));

outstrlist.Add('');
outstrlist.Add('Symmetry number (sigma): '+inttostr(sigma)+' ('+GetAnyPointGroupName(FPointGroupFullNum)+')');


//qtr:=power(2*pi*M*k,1.5)*power(t,2.5)*R/(power(h,3)*P*Na);
str:=r*(ln(power(2*pi*m,1.5)*power(k*t,2.5)/(power(h,3)*p))+2.5);
ctr:=1.5*r;
dEtr:=1.5*rt;

if FIsLinear then begin
//qrot:=8*sqr(pi)*FIvaluesSi.y*k*t/(sqr(h)*sigma);
srot:=r*(ln(8*sqr(pi)*FIvaluesSi.y*k*t/(sqr(h)*sigma))+1);
crot:=r;
dErot:=rt;
end
else begin
//qrot:=8*sqr(pi)*power(2*pi*k*T/sqr(h),1.5)*sqrt(FIvaluesSi.x*FIvaluesSi.y*FIvaluesSi.z)/sigma;
srot:=r*(ln(power(2,4.5)*power(pi,3.5)*power(k*t,1.5)*sqrt(FIvaluesSi.x*FIvaluesSi.y*FIvaluesSi.z)/(power(h,3)*sigma))+1.5);
crot:=1.5*r;
dErot:=1.5*rt;
end;
//srot:=31.817*kcaltokdhcoef;



sumsvib:=0;
sumevib:=0;
sumcvvib:=0;
sumzpe:=0;
outstrlist.Add('');
outstrlist.Add('Vibrational components of energy, heat capacity and entropy:');
outstrlist.Add('');

curstr:='I    Frequency i, cm^-1   E(Thermal), ';
curstr:=curstr+EUnitsStr;

curstr:=AddSpacesToString(curstr,50);
case recunits of
truJouleMolK,truCalMolK:curstr:=curstr+'C, ';
else curstr:=curstr+'C*T, ';
end;//case

curstr:=curstr+SUnitsStr;

curstr:=AddSpacesToString(curstr,74);
case recunits of
truJouleMolK,truCalMolK:curstr:=curstr+'S, ';
else curstr:=curstr+'S*T, ';
end;//case
curstr:=curstr+SUnitsStr;

outstrlist.Add(curstr);

for q:=0 to FFrequencies.Count-1 do begin
curv:=FFrequencies[q].freqval;
if FUseFreqsThreshold then if curv<FFreqsThreshold then curv:=FFreqsThreshold;

hcv:=curv*100*h*PhysicsAndChemistryConstantsSi_c;

if equal(curv,0) then continue;
if curv<0 then continue;

teta:=hcv/k;

hvdkt:=hcv/kt;
//m-1*J*s-1*m/s=J/particle
curevib:=r*teta*(0.5+1/(exp(hvdkt)-1));
curzpe:=r*teta*0.5;

sumevib:=sumevib+curevib;
sumzpe:=sumzpe+curzpe;


curcvvib:=r*sqr(hvdkt)*exp(-hvdkt)/sqr(1-exp(-hvdkt));
//In Gaussian thermochemistry page, slightly another formula is provided:
//curcvvib:=r*sqr(hvdkt)*exp(hvdkt)/sqr(1-exp(-hvdkt));
//It seems that their formula has an error.
//We took the correct formula from the book "Molecular thermodynamics" by D. A.
//McQuarrie and J. D. Simon, page 161


sumcvvib:=sumcvvib+curcvvib;


cursvib:=r*hvdkt/(exp(hvdkt)-1)-r*ln(1-exp(-hvdkt));

sumsvib:=sumsvib+cursvib;
curstr:=inttostr(FFrequencies[q].outfnum+1);
curstr:=AddSpacesToString(curstr,8); curstr:=curstr+floattostr(curv);
curstr:=AddSpacesToString(curstr,26); curstr:=curstr+floattostr(curevib*erecountconst);
curstr:=AddSpacesToString(curstr,50); curstr:=curstr+floattostr(curcvvib*srecountconst);
curstr:=AddSpacesToString(curstr,74); curstr:=curstr+floattostr(cursvib*srecountconst);
outstrlist.Add(curstr);
end;//next q vib

if negfreqscount>0  then begin
outstrlist.Add('');
outstrlist.Add('This job contains '+inttostr(negfreqscount)+' negative frequencies.');
if FUseFreqsThreshold then outstrlist.Add('They were increased to the specified threshold of '+floattostr(FFreqsThreshold)+' cm-1')
else outstrlist.Add('They were excluded from the sum for Svib.');
end;


result:=sumsvib;

outstrlist.Add('');

curstr:='             E (Thermal), ';
curstr:=curstr+EUnitsStr;

curstr:=AddSpacesToString(curstr,49);

case recunits of
truJouleMolK,truCalMolK:curstr:=curstr+'C, ';
else curstr:=curstr+'C*T, ';
end;//case
curstr:=curstr+SUnitsStr;


curstr:=AddSpacesToString(curstr,79);
case recunits of
truJouleMolK,truCalMolK:curstr:=curstr+'S, ';
else curstr:=curstr+'S*T, ';
end;//case
curstr:=curstr+SUnitsStr;

outstrlist.Add(curstr);

curstr:='Electronic';
curstr:=InsertDigitToStr(curstr,'0.0',20);
curstr:=InsertDigitToStr(curstr,'0.0',50);
curstr:=InsertDigitToStr(curstr,'0.0',80);
outstrlist.Add(curstr);

curstr:='Translational';
curstr:=InsertDigitToStr(curstr,floattostr(detr*erecountconst),20);
curstr:=InsertDigitToStr(curstr,floattostr(ctr*srecountconst),50);
curstr:=InsertDigitToStr(curstr,floattostr(str*srecountconst),80);
outstrlist.Add(curstr);

curstr:='Rotational         ';
curstr:=InsertDigitToStr(curstr,floattostr(derot*erecountconst),20);
curstr:=InsertDigitToStr(curstr,floattostr(crot*srecountconst),50);
curstr:=InsertDigitToStr(curstr,floattostr(srot*srecountconst),80);
outstrlist.Add(curstr);

curstr:='Vibrational         ';
curstr:=InsertDigitToStr(curstr,floattostr(sumevib*erecountconst),20);
curstr:=InsertDigitToStr(curstr,floattostr(sumcvvib*srecountconst),50);
curstr:=InsertDigitToStr(curstr,floattostr(sumsvib*srecountconst),80);
outstrlist.Add(curstr);

curstr:='Total         ';
curstr:=InsertDigitToStr(curstr,floattostr((detr+derot+sumevib)*erecountconst),20);
curstr:=InsertDigitToStr(curstr,floattostr((ctr+crot+sumcvvib)*srecountconst),50);
curstr:=InsertDigitToStr(curstr,floattostr((str+srot+sumsvib)*srecountconst),80);
outstrlist.Add(curstr);


ethermh:=FElEnergyh+(detr+derot+sumevib)*0.001/autokdzhcoef;
hh:=ethermh+rt*0.001/autokdzhcoef;
gh:=hh-((str+srot+sumsvib)*t*0.001/autokdzhcoef);

outstrlist.Add('');
curstr:='SCF energy from file, '+EUnitsStr;
curstr:=InsertDigitToStr(curstr,floattostr(FElEnergyh*efromhrecountconst),80);
outstrlist.Add(curstr);

curstr:='Zero point energy, '+EUnitsStr;
curstr:=InsertDigitToStr(curstr,floattostr(sumzpe*erecountconst),80);
outstrlist.Add(curstr);

curstr:='Thermal correction to energy (tr. + rot. + vibr), '+EUnitsStr;
curstr:=InsertDigitToStr(curstr,floattostr((dEtr+dErot+sumevib)*erecountconst),80);
outstrlist.Add(curstr);

curstr:='Total thermal energy, '+EUnitsStr;
curstr:=InsertDigitToStr(curstr,floattostr(ethermh*efromhrecountconst),80);
outstrlist.Add(curstr);



curstr:='R*T, '+EUnitsStr;
curstr:=InsertDigitToStr(curstr,floattostr(rt*erecountconst),80);
outstrlist.Add(curstr);

curstr:='Total enthalpy H (E(tot. therm.) + R*T), '+EUnitsStr;
curstr:=InsertDigitToStr(curstr,floattostr ((ethermh+rt*0.001/autokdzhcoef)*efromhrecountconst),80);
outstrlist.Add(curstr);

curstr:='Total entropy S, Cal/(Mol*K)';
curstr:=InsertDigitToStr(curstr,floattostr ((str+srot+sumsvib)/kcaltokdhcoef),80);
outstrlist.Add(curstr);

if not printgfinh then outstrlist.Add('___________________________________________________________________________________________________');
curstr:='Total Gibbs energy G (H-T*S), '+EUnitsStr;
curstr:=InsertDigitToStr(curstr,floattostr (gh*efromhrecountconst),80);
outstrlist.Add(curstr);
if not printgfinh then outstrlist.Add('___________________________________________________________________________________________________');

if printgfinh then begin
outstrlist.Add('___________________________________________________________________________________________________');
curstr:='Total Gibbs energy G (H-T*S), Hartree/particle';
curstr:=InsertDigitToStr(curstr,floattostr (gh),80);
outstrlist.Add(curstr);
outstrlist.Add('___________________________________________________________________________________________________');
end;


if FHasGEnFromFileh then begin
curstr:='Difference between our Gibbs energy and the one from file, '+EUnitsStr;
curstr:=InsertDigitToStr(curstr,floattostr((gh-FGEnFromFileh)*efromhrecountconst),80);
curstr:=curstr+' ('+format('%.9f',[100*(gh-FGEnFromFileh)/FGEnFromFileh])+'%)';
outstrlist.Add(curstr);
end;


FComputedData.HasGh:=true;
FComputedData.Gh:=gh;





end;



{ freqsarray }

procedure tfreqsarray.AddFreq(outfnum: integer; freqval: double);
begin
AddElement;
fitems[FCount-1].outfnum:=outfnum;
fitems[FCount-1].freqval:=freqval;
end;


procedure ComputeNewABCVectorsInTermsOfOld(olda,oldb,oldc:tvect; rotmat:TRotMatrixInt; out newa,newb,newc:tvect);
var
cellabc:TCrystABCParams;
oldcrystrotmat:trotmatrix;
newabcrotmat:trotmatrix;
resmat:trotmatrix;
begin
{
newa.x:=olda.x*rotmat.ax+oldb.x*rotmat.bx+oldc.x*rotmat.cx;
newa.y:=olda.y*rotmat.ax+oldb.y*rotmat.bx+oldc.y*rotmat.cx;
newa.z:=olda.z*rotmat.ax+oldb.z*rotmat.bx+oldc.z*rotmat.cx;

newb.x:=olda.x*rotmat.ay+oldb.x*rotmat.by+oldc.x*rotmat.cy;
newb.y:=olda.y*rotmat.ay+oldb.y*rotmat.by+oldc.y*rotmat.cy;
newb.z:=olda.z*rotmat.ay+oldb.z*rotmat.by+oldc.z*rotmat.cy;

newc.x:=olda.x*rotmat.az+oldb.x*rotmat.bz+oldc.x*rotmat.cz;
newc.y:=olda.y*rotmat.az+oldb.y*rotmat.bz+oldc.y*rotmat.cz;
newc.z:=olda.z*rotmat.az+oldb.z*rotmat.bz+oldc.z*rotmat.cz;
}
{
newa.x:=olda.x*rotmat.ax+oldb.x*rotmat.ax+oldc.x*rotmat.ax;
newa.y:=olda.y*rotmat.ay+oldb.y*rotmat.ay+oldc.y*rotmat.ay;
newa.z:=olda.z*rotmat.az+oldb.z*rotmat.az+oldc.z*rotmat.az;

newb.x:=olda.x*rotmat.bx+oldb.x*rotmat.bx+oldc.x*rotmat.bx;
newb.y:=olda.y*rotmat.by+oldb.y*rotmat.by+oldc.y*rotmat.by;
newb.z:=olda.z*rotmat.bz+oldb.z*rotmat.bz+oldc.z*rotmat.bz;

newc.x:=olda.x*rotmat.cx+oldb.x*rotmat.cx+oldc.x*rotmat.cx;
newc.y:=olda.y*rotmat.cy+oldb.y*rotmat.cy+oldc.y*rotmat.cy;
newc.z:=olda.z*rotmat.cz+oldb.z*rotmat.cz+oldc.z*rotmat.cz;
}

ComputeABCFromLatticeVectors(olda,oldb,oldc,cellabc);

oldcrystrotmat:=cellabc.ComputeFracToCartMatrix;

newabcrotmat:=rotmat.GetAsRotMat;

//resmat:=MultMatrixes(oldcrystrotmat,newabcrotmat);
resmat:=MultMatrixes(newabcrotmat,oldcrystrotmat);

newa.x:=resmat.ax;
newa.y:=resmat.ay;
newa.z:=resmat.az;

newb.x:=resmat.bx;
newb.y:=resmat.by;
newb.z:=resmat.bz;

newc.x:=resmat.cx;
newc.y:=resmat.cy;
newc.z:=resmat.cz;


end;


{ TPossibleBondsDataList }

procedure TPossibleBondsDataList.RestoreOptionCalculateBonds;
begin
CalculateBonds:=fSavedOptionCalculateBonds;
end;

procedure TPossibleBondsDataList.SaveOptionCalculateBonds;
begin
fSavedOptionCalculateBonds:=CalculateBonds;
CalculateBonds:=false;
end;

initialization
begin
PrepareIsotopeMasses_Abundancies;
PrepareCollDiams;

PrepareShortContactsData;

end;
end.
